<?php
/*
Wettkampfabwicklung, Aktion: eigenemeldung
verwendete Templates:
 - 42.eigenemeldung.inc.html
 - 42.eigenemeldung-dms-dmsj.inc.html (über das DMS- bzw. DMS-J-Modul)
*/
if(isset($_GET['abbrechen'])){
	if(isset($_SESSION['wk_abwickeln']['eigenemeldungen'])){
		unset($_SESSION['wk_abwickeln']['eigenemeldungen']);
	}
	weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG);
}

if($_wettkampfart == 'dms' or $_wettkampfart == 'dmsj'){
	# Meldung suchen
	if(!isset($_wkeinst[$_wettkampfart]) or count($_wkeinst[$_wettkampfart]) == 0){
		$_tmpl->assign('meldung', -2); # =keine Meldungen für den Wettkampf vorhanden
	}
	else{
		$gemeldetin = false;
		# Mannschaft suchen
		foreach($_wkeinst[$_wettkampfart] as $mannschaft => $mitglieder){
			$mids = explode('|', $mitglieder);
			if(in_array($_SESSION['user']['id'], $mids)){
				$gemeldetin = $mannschaft;
				break;
			}
		}
		if($gemeldetin !== false){ # Meldung gefunden, Mitgliedernamen dazu suchen
			$query = "SELECT id, CONCAT(nachname, ', ', vorname, ' (',mw,', ',YEAR(gebdatum),')') as name FROM ".DB_PREFIX."mitglieder
						WHERE id IN (".str_replace('|',',',$_wkeinst[$_wettkampfart][$gemeldetin]).")
						ORDER BY nachname, vorname";
			$_db->holeDaten($query);
			$meldung = array(
				'mannschaft' => ($_wettkampfart=='dms'?$_geschlechter[$gemeldetin[0]]:'Jugend '.strtoupper($gemeldetin[0])).', '.$gemeldetin[1].'. Mannschaft',
				'hervorheben' => $_SESSION['user']['id'],
				'mitglieder' => $_db->baueArray('name','id')
			);
			$_tmpl->assign('meldung', $meldung);
		}
		else{
			$_tmpl->assign('meldung', -1); # =Mitglied in keiner Mannschaft gemeldet
		}
	}
	$_inh .= $_tmpl->fetch('wettkaempfe/42.eigenemeldung-dms-dmsj.inc.html');
}
else{
	$internermeldeschluss = false;
	$meldeschluss = false;	
	$meldungmoeglich = false;
	if(isset($_wkeinst['wettkampfdaten']['meldeschlussintern_datum'])){
		list($tag, $monat, $jahr) = explode('.', $_wkeinst['wettkampfdaten']['meldeschlussintern_datum']);
		list($stunde, $minute) = explode(':', $_wkeinst['wettkampfdaten']['meldeschlussintern_zeit']);
		$ts = mktime($stunde, $minute, 0, $monat, $tag, $jahr);
		$query = "SELECT DATE_FORMAT(FROM_UNIXTIME(".$ts."),'%e. %M %Y, %H:%i Uhr') as ausgabe, 
					IF(FROM_UNIXTIME(".$ts.")>NOW(), 1, 0) as meldungmoeglich";
		$_db->holeDaten($query);
		$internermeldeschluss = $_db->holeZeile();
		
	}
	if(!empty($_wkeinst['wettkampfdaten']['meldeschluss_datum'])){
		list($tag, $monat, $jahr) = explode('.', $_wkeinst['wettkampfdaten']['meldeschluss_datum']);
		list($stunde, $minute) = explode(':', $_wkeinst['wettkampfdaten']['meldeschluss_zeit']);
		$ts = mktime($stunde, $minute, 0, $monat, $tag, $jahr);
		$query = "SELECT DATE_FORMAT(FROM_UNIXTIME(".$ts."),'%e. %M %Y, %H:%i Uhr') as ausgabe, 
					IF(FROM_UNIXTIME(".$ts.")>NOW(), 1, 0) as meldungmoeglich";
		$_db->holeDaten($query);
		$meldeschluss = $_db->holeZeile();
	}
	if(($meldeschluss===false or $meldeschluss['meldungmoeglich']==1) and ($internermeldeschluss===false or $internermeldeschluss['meldungmoeglich']==1)){
		$meldungmoeglich = true;
	}
	$_tmpl->assign('internermeldeschluss', $internermeldeschluss);
	$_tmpl->assign('meldeschluss', $meldeschluss);
	$_tmpl->assign('meldungmoeglich', $meldungmoeglich);

	if(!isset($_SESSION['wk_abwickeln']['eigenemeldungen'])){
		$verfuegbarewettkaempfe = $wk->wettkaempfeFuerSchwimmer($_SESSION['wk_abwickeln']['id'], $_SESSION['user']['id']);
		if(count($verfuegbarewettkaempfe['wks'])>0){
			$_SESSION['wk_abwickeln']['eigenemeldungen'] = array();
			$wkids = $verfuegbarewettkaempfe['wks'];
			
			$mid = $_SESSION['user']['id'];
			# Wettkämpfe holen
			$sort = $_einst['wettkampfabwicklung']['eigenemeldung_reihenfolgewettkaempfe']=='wknr'?'w.wknr':'w.disziplin, sort';
			$query = "SELECT w.id, a.nr, w.wknr, w.laenge, w.disziplin, w.wkart, FIELD(w.laenge,'25','50','100','200','400','800','1500') AS sort
						FROM ".DB_PREFIX."wks as w LEFT JOIN ".DB_PREFIX."abschnitte as a ON w.abschnittid=a.id
						WHERE w.id IN (".implode(',',$wkids).") ORDER BY ".$sort;
			$_db->holeDaten($query);
			$_SESSION['wk_abwickeln']['eigenemeldungen']['wettkaempfe'] = $_db->baueArray('*', 'id');
	
			$mitgliedzeiten = $wk->sucheStreckenzeitenfuerMitglied($wkids, $mid);
			$query = "SELECT id, CONCAT(laenge,'_',disziplin) as strecke FROM ".DB_PREFIX."wks WHERE id IN (".implode(',',$wkids).")";
			$_db->holeDaten($query);
			$strecke2wkid = $_db->baueArray('strecke','id');
			$aktuellezeiten = $wk->holeAktuelleZeitenFuerMitglied($mid, '', false);
			foreach($mitgliedzeiten as $wkid => $zeiten){
				$_SESSION['wk_abwickeln']['eigenemeldungen']['zeiten'][$wkid] = array();
				if(isset($aktuellezeiten[$strecke2wkid[$wkid]])){
					$_SESSION['wk_abwickeln']['eigenemeldungen']['zeiten'][$wkid][$aktuellezeiten[$strecke2wkid[$wkid]]] =
					text_format($aktuellezeiten[$strecke2wkid[$wkid]],'schwimmzeit').' (=aktuelle Zeit)';
				}
				foreach($zeiten as $zeit){
					$str = text_format($zeit['zeit'],'schwimmzeit').', ';
					$str .= $zeit['datum'].(!is_null($zeit['schwimmernr'])?', Staffelzeit ('.$zeit['schwimmernr'].'.)':'').', ';
					$str .= $zeit['bahnlaenge'].'m, '.$zeit['kurztitel'];
					if(isset($_SESSION['wk_abwickeln']['eigenemeldungen']['zeiten'][$wkid][$zeit['zeit']])){
						$str .= ' (=aktuelle Zeit)';
					}
					$_SESSION['wk_abwickeln']['eigenemeldungen']['zeiten'][$wkid][$zeit['zeit']] = $str;
				}
			}
			foreach($_SESSION['wk_abwickeln']['eigenemeldungen']['zeiten'] as $wk => $zeiten){
				ksort($_SESSION['wk_abwickeln']['eigenemeldungen']['zeiten'][$wk]);
			}
			$_SESSION['wk_abwickeln']['eigenemeldungen']['pflichtzeiten'] = $verfuegbarewettkaempfe['pflichtzeiten'];

			$_SESSION['wk_abwickeln']['eigenemeldungen']['gemeldet'] = array();
			if(count($verfuegbarewettkaempfe['vorhandene'])>0){
				$query = "SELECT ms.wkid, ms.meldezeit
							FROM ".DB_PREFIX."meldungen_starts as ms LEFT JOIN ".DB_PREFIX."meldungen_teilnehmer as mt ON ms.teilnehmerid=mt.id
							WHERE mid=".$mid." AND wettkampfid=".$_SESSION['wk_abwickeln']['id'];
				$_db->holeDaten($query);
				$_SESSION['wk_abwickeln']['eigenemeldungen']['gemeldet'] = $_db->baueArray('meldezeit','wkid');
				foreach($_SESSION['wk_abwickeln']['eigenemeldungen']['gemeldet'] as $wknr => $zeit){
					$_SESSION['wk_abwickeln']['eigenemeldungen']['gemeldet'][$wknr] = is_null($zeit)?false:$zeit;
				}
			}
		}
		else{
			$_SESSION['wk_abwickeln']['eigenemeldungen'] = false;
		}
	}
	if($_SESSION['wk_abwickeln']['eigenemeldungen'] === false){
		$_tmpl->assign('fehler', 'Es wurden keine passenden Einzelwettkämpfe gefunden.');
	}
	else{
		$daten = $_SESSION['wk_abwickeln']['eigenemeldungen'];
		if(isset($_POST['speichern'])){
			require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
			$f = '';
			$neuerstand = array();
			if(isset($_POST['wettkaempfe'])){
				foreach($_POST['wettkaempfe'] as $wkid => $tmp){
					if(!isset($daten['wettkaempfe'][$wkid])){
						continue;
					}
					$wkdat = $daten['wettkaempfe'][$wkid];
					$wkstr = $wkdat['laenge'].'m '.$_lagen[$wkdat['disziplin']];
					if(!isset($_POST['zeiten'][$wkid])){
						$f .= 'Die Meldezeit für '.$wkstr.' fehlt<br />';
						$neuerstand[$wkid] = '';
					}
					elseif($_POST['zeiten'][$wkid] == 'textfeld'){
						$f .= pruefen($_POST['textfeld'][$wkid], 'leer', 'Die Meldezeit für '.$wkstr.' fehlt');
						$f .= pruefen($_POST['textfeld'][$wkid], 'schwimmzeit', 'Die Meldezeit für '.$wkstr.' fehlt');
						$neuerstand[$wkid] = $_POST['textfeld'][$wkid];
					}
					elseif($_POST['zeiten'][$wkid] == 'ohne'){
						$neuerstand[$wkid] = false;
					}
					else{
						$f .= pruefen($_POST['zeiten'][$wkid], 'zahl', 'Die Meldezeit für '.$wkstr.' ist ungültig');
						$neuerstand[$wkid] = $_POST['zeiten'][$wkid];
					}
				}
			}
			if(!empty($f)){
				$daten['gemeldet'] = $neuerstand;
				$_tmpl->assign('fehler', $f);
			}
			else{
				$loeschen = array();
				$anlegen = array();
				$aktualisieren = array();
				$alterstand = $daten['gemeldet'];
				foreach($neuerstand as $wkid => $zeit){
					if(!array_key_exists($wkid, $alterstand)){ # Meldung hat bisher nicht existiert
						$anlegen[$wkid] = $zeit;
					}
					else{ # Meldung existiert bereits
						if($alterstand[$wkid] != $zeit){ # Zeiten sind nicht gleich
							$aktualisieren[$wkid] = $zeit;
						}
						unset($alterstand[$wkid]);
					}
				}
				if(count($alterstand)>0){
					foreach($alterstand as $wkid => $zeit){
						$loeschen[] = $wkid;
					}
				}
				$query = "SELECT id, teilnahme FROM ".DB_PREFIX."meldungen_teilnehmer
							WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND mid = ".$_SESSION['user']['id'];
				$_db->holeDaten($query);
				$mitgl = $_db->holeZeile();
				if($mitgl === false){ #  bisher noch nicht gemeldet
					if(count($anlegen)>0){
						$query = "INSERT INTO ".DB_PREFIX."meldungen_teilnehmer (wettkampfid, mid, teilnahme)
									VALUES (".$_SESSION['wk_abwickeln']['id'].", ".$_SESSION['user']['id'].", '+')";
						$_db->fuehreQueryAus($query);
						$mitgl = array('id' => $_db->holeInsertId(), 'teilnahme' => '+');
					}
				}
				elseif(count($loeschen)>0){
					$query = "DELETE FROM ".DB_PREFIX."meldungen_starts WHERE teilnehmerid = ".$mitgl['id']." AND wkid IN (".implode(',',$loeschen).")";
					$_db->fuehreQueryAus($query);
				}
				if((isset($_wkeinst['flags']['ruecklaufzettel'])?$_wkeinst['flags']['ruecklaufzettel']=='+':$_gleinst['wettkaempfe_abwickeln']['ruecklaufzettel']==1) and $mitgl['teilnahme']!='+'){
					$query = "UPDATE ".DB_PREFIX."meldungen_teilnehmer SET teilnahme = '+' WHERE id = ".$mitgl['id'];
					$_db->fuehreQueryAus($query);
				}
				if(count($anlegen)>0){
					$query = "INSERT INTO ".DB_PREFIX."meldungen_starts (teilnehmerid, meldezeit, wkid, teilnahme) VALUES";
					$tmp = array();
					foreach($anlegen as $wkid => $zeit){
						$tmp[] = "(".$mitgl['id'].", ".($zeit===false?'NULL':$zeit).", ".$wkid.", '+')";
					}
					$query .= implode(', ',$tmp);
					$_db->fuehreQueryAus($query);
				}
				if(count($aktualisieren)>0){
					foreach($aktualisieren as $wkid => $zeit){
						$query = "UPDATE ".DB_PREFIX."meldungen_starts SET meldezeit = ".$zeit." WHERE teilnehmerid = ".$mitgl['id']." AND wkid = ".$wkid;
						$_db->fuehreQueryAus($query);
					}
				}
				$query = "UPDATE ".DB_PREFIX."meldungen_starts SET teilnahme = '+' WHERE teilnehmerid = ".$mitgl['id']." AND wkid = ".$wkid;
				$_db->fuehreQueryAus($query);
				unset($_SESSION['wk_abwickeln']['eigenemeldungen']);
				weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=eigenemeldung', 'Die Meldung wurde gespeichert');
			}
		}
		$_tmpl->tk_javascriptzuweisen('dateien', 'jquery');
		$_tmpl->tk_javascriptzuweisen('onready', "$('input[name^=\"textfeld[\"]').focus(function(){
    var wkid=this.name.substring(9,this.name.length-1);
    $('input[name=\"zeiten['+wkid+']\"]:first').attr('checked','checked');
  });");
		$_tmpl->assign('_lagen', $_lagen);
		$_tmpl->assign('daten', $daten);
		$_inh .= $_tmpl->fetch('wettkaempfe/42.eigenemeldung.inc.html');
	}
}

# EOF
?>
