<?php
/*
Wettkampfabwicklung, Aktion: meldedateigenerieren
verwendete Templates:
 - [keine]
*/
$fehler = false;
if(isset($_SESSION['wk_abwickeln']['pflichtzeiten']) and ($_SESSION['wk_abwickeln']['pflichtzeiten_rp']=='p' or $_SESSION['wk_abwickeln']['pflichtzeiten_o']==1)){
	$link = ROOT.'/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=einhaltung_pflichtzeit';
	if(!isset($_wkeinst['flags']['pflichtzeitengeprueft']) or $_wkeinst['flags']['pflichtzeitengeprueft'] == '0'){
		$fehlermeldung = 'Die Meldung muss erst auf die Einhaltung der Pflichtzeiten <a href="'.$link.'">überprüft</a> werden.';
		$fehler = true;
	}
	elseif($_wkeinst['flags']['pflichtzeitengeprueft'] == '-'){
		$fehlermeldung = 'Die momentane Meldung kann nicht abgeschickt werden, da Mitglieder gemeldet sind, die die Pflichtzeit nicht erfüllen bzw. ohne Zeit gemeldet sind, siehe <a href="'.$link.'">Prüfseite</a>.';
		$fehler = true;
	}
}

if($fehler){
	$_tmpl->assign('fehler', $fehlermeldung);
}
else{
$wkid = $_SESSION['wk_abwickeln']['id'];

# Daten holen
$daten = array();
# Abschnitte
$query = "SELECT id, nr, DATE_FORMAT(datum, '%d.%m.%Y') as datum, TIME_FORMAT(beginn, '%H:%i') as uhrzeit
			FROM ".DB_PREFIX."abschnitte WHERE wettkampfid = ".$wkid." ORDER BY nr";
$_db->holeDaten($query);
$daten['abschnitte'] = $_db->baueArray('*','id');
# Wettkaempfe
$query = "SELECT w.id, w.wknr, a.nr, w.wkart, laenge, disziplin, UCASE(mw) as mw
			FROM ".DB_PREFIX."abschnitte as a, ".DB_PREFIX."wks as w
			WHERE w.abschnittid = a.id AND a.wettkampfid = ".$wkid." ORDER BY a.nr, w.wknr";
$_db->holeDaten($query);
$daten['wettkaempfe'] = $_db->baueArray('*','wknr');
# Ansprechpartner
$query = "SELECT CONCAT(m.nachname,', ',m.vorname) as name, CONCAT(m.strasse,' ',m.hausnr) as strasse, m.plz, m.ort, m.email, m.id as mid
			FROM ".DB_PREFIX."mitglieder as m, ".DB_PREFIX."vorstand as v
			WHERE m.id = v.mitgliedid AND v.id = ".$_wkeinst['meldedatei']['ansprechpartner']."";
$_db->holeDaten($query);
if($_db->holeAnzahl() > 0){
	$daten['ansprechpartner'] = $_db->holeZeile();
	$daten['ansprechpartner']['tel'] = '';
	$daten['ansprechpartner']['fax'] = '';
	$query = "SELECT CONCAT(vorwahl,'/',nummer) as tel, telefonart FROM ".DB_PREFIX."telefon
				WHERE mitgliedid = ".$_db->holeWert('mid')." AND telefonart IN (1,4) ORDER BY tel";
	$_db->holeDaten($query);
	if($_db->holeAnzahl() > 0){
		foreach($_db->baueArray('*','#') as $row){
			if($row['telefonart']==1 and empty($daten['ansprechpartner']['tel'])){
				$daten['ansprechpartner']['tel'] = $row['tel'];
			}
			if($row['telefonart']==4 and empty($daten['ansprechpartner']['fax'])){
				$daten['ansprechpartner']['fax'] = $row['tel'];
			}
		}
	}
}
else{
	$daten['ansprechpartner'] = false;
}
# Kampfrichter
$daten['kampfrichter'] = false;
if(count($_wkeinst['kampfrichter']) > 0){
	$query = "SELECT k.id, CONCAT(nachname,', ',vorname) as name, gruppe, mw
			FROM ".DB_PREFIX."kampfrichter as k, ".DB_PREFIX."mitglieder as m
			WHERE k.id = m.id AND k.id IN (".implode(',',array_keys($_wkeinst['kampfrichter'])).")
			ORDER BY m.nachname, m.vorname";
	$_db->holeDaten($query);
	$daten['kampfrichter'] = $_db->baueArray('*', 'id');
	foreach($daten['kampfrichter'] as $kid => $row){
		$daten['kampfrichter'][$kid]['abschnitte'] = explode(',',$_wkeinst['kampfrichter'][$row['id']]);
	}
}


# Einzelstarts
$daten['einzelstarts'] = array();
$ruecklaufzettel = (isset($_wkeinst['flags']['ruecklaufzettel'])?$_wkeinst['flags']['ruecklaufzettel']=='+':$_gleinst['wettkaempfe_abwickeln']['ruecklaufzettel']==1);

$query = "SELECT CONCAT(m.nachname, ', ', m.vorname) as name, dsvid, UCASE(mw) as mw, YEAR(gebdatum) as jg, mt.id as teilnehmerid
			FROM ".DB_PREFIX."meldungen_teilnehmer as mt, ".DB_PREFIX."mitglieder as m
			WHERE wettkampfid = ".$wkid." AND m.id = mt.mid ".($ruecklaufzettel?"AND teilnahme = '+'":"")."
			ORDER BY m.nachname, m.vorname";
$_db->holeDaten($query);
if($_db->holeAnzahl() > 0){
	$daten['einzelstarts'] = $_db->baueArray('*','teilnehmerid');
	$mids = implode(',', $_db->baueArray('teilnehmerid','#'));
	$query = "SELECT w.id as wkid, wknr, ms.meldezeit as zeit, w.laenge, w.disziplin, teilnehmerid
				FROM ".DB_PREFIX."meldungen_starts as ms, ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a
				WHERE ".($ruecklaufzettel?"teilnahme = '+' AND ":"")."teilnehmerid IN (".$mids.") 
				  AND ms.wkid = w.id AND a.id = w.abschnittid
				ORDER BY a.nr, w.wknr";
	$_db->holeDaten($query);
	$starts = $_db->baueArray('*','#');
	foreach($starts as $start){
		if(!isset($daten['einzelstarts'][$start['teilnehmerid']]['_starts'])){
			$daten['einzelstarts'][$start['teilnehmerid']]['_starts'] = array();
		}
		$daten['einzelstarts'][$start['teilnehmerid']]['_starts'][] = $start;
	}
}
# Staffelstarts
$daten['staffelstarts'] = array();
if(isset($_wkeinst['staffeln'])){
	foreach($_wkeinst['staffeln'] as $key => $staffel){
		if(substr($key,0,9) == 'staffeln_'){
			unset($_wkeinst['staffeln'][$key]);
		}
	}
	if(count($_wkeinst['staffeln']) > 0){
		$query = "SELECT wknr, id FROM ".DB_PREFIX."wks WHERE id IN (".implode(',', array_keys($_wkeinst['staffeln'])).")";
		$_db->holeDaten($query);
		$wkids = $_db->baueArray('wknr','id');
		$staffeln = array();
		foreach($_wkeinst['staffeln'] as $key => $staffel){
			$zeiten = explode(',', $staffel);
			$klasse = 'foo';
			foreach($zeiten as $z){
				if(strpos($z,'-')!==false){
					list($z,$k) = explode('-',$z,2);
				}
				else{
					$k = '';
				}
				if($klasse != $k){
					$i = 1;
					$klasse = $k;
				}
				else{
					$i++;
				}
				$daten['staffelstarts'][] = array(
					'wknr' => $wkids[$key],
					'nr'   => $i,
					'zeit' => $z,
					'klasse' => $k
				);
			}
		}
	}
}

# Meldung erzeugen
$format = $_wkeinst['meldedatei']['meldeformat'];
$dateiname = $_wkeinst['meldedatei']['dateiname'];
if(substr($dateiname,-4) == '.dsv'){
	$dateiname = substr($dateiname, 0, -4);	
}
switch($format){
case 'lenex2':
case 'lenex3':
	require_once(PFAD_INCLUDE.'class/lenex.inc.php');
	$lenex = new lenex;
	$lenex->setzeVersion($format=='lenex2'?'2':'3');
	$datinh = $lenex->erzeugeMeldedatei($daten, $_wkeinst['wettkampfdaten']);
	
	require_once(PFAD_INCLUDE.'class/zip.inc.php');
	$zip = new zipfile;
	$zip->addFile_daten($datinh, $dateiname.'.lef');
	$zip->gebeDateiAus($dateiname.'.lxf', 'application/x-lenexdatei');

case 'dsv6':
case 'dsv6_komprimiert':
	require_once(PFAD_INCLUDE.'func/erzeugedsv6datei.inc.php');
	$query = "SELECT bahnlaenge FROM ".DB_PREFIX."wettkaempfe WHERE id = ".$_SESSION['wk_abwickeln']['id'];
	$_db->holeDaten($query);
	$_wkeinst['wettkampfdaten']['bahnlaenge'] = $_db->holeWert();
	$datinh = erzeugeDsv6Datei($daten, $_wkeinst['wettkampfdaten']);
	if($format=='dsv6_komprimiert'){
		require_once(PFAD_INCLUDE.'class/zip.inc.php');
		$zip = new zipfile;
		$zip->addFile_daten($datinh, $dateiname.'.dsv6');
		$zip->gebeDateiAus($dateiname.'.dsv6.zip');
	}
	else{
		header('Content-Type: text/x-dsvdatei');
		header('Content-Length: '.strlen($datinh));
		header('Content-Disposition: attachment; filename="'.$dateiname.'.dsv6"');
		echo $datinh;
		exit;
	}

case 'dsv4':
case 'dsv5':
case 'dsv5_komprimiert':
	require_once(PFAD_INCLUDE.'func/erzeugedsvdatei.inc.php');
	$datinh = erzeugeDsvDatei($daten, $_wkeinst['wettkampfdaten']);
	if($format=='dsv5_komprimiert'){
		require_once(PFAD_INCLUDE.'class/zip.inc.php');
		$zip = new zipfile;
		$zip->addFile_daten($datinh, $dateiname.'.dsv');
		$zip->gebeDateiAus($dateiname.'.dsv.zip');
	}
	else{
		header('Content-Type: text/x-dsvdatei');
		header('Content-Length: '.strlen($datinh));
		header('Content-Disposition: attachment; filename="'.$dateiname.'.dsv"');
		echo $datinh;
		exit;
	}

case 'dsvform':
	require_once(PFAD_INCLUDE.'class/ooodateien.inc.php');
	$ooo = new ooodateien($_tmpl,'meldebogen');
	# Daten einsammeln
	# Meta-Daten
	$_meta = array(
		'generator' => 'tkswim '.TKSWIM_VERSION,
		'titel'     => 'Meldebogen (DSV-Form 101+102)',
		'creator'   => $_SESSION['user']['realname'],
		'datum'      => date('Y-m-d\TH:i:s')
	);
	$ooo->setzeWerte('_meta',$_meta);
	# Wettkampfdaten
	$wettkampf = array(
		'name' => text_format($_wkeinst['wettkampfdaten']['titel'],'xml'),
		'am'   => $_wkeinst['wettkampfdaten']['datum'],
		'bis'  => '',
		'ort'  => $_wkeinst['wettkampfdaten']['ort']
	);
	$ooo->setzeWerte('wk',$wettkampf);
	# Vereins-Daten
	$verein = array(
		'name' => TKSWIM_VEREIN,
		'id'   => TKSWIM_VEREINSID,
		'lsv'  => TKSWIM_LSVKENNZIFFER
	);
	$ooo->setzeWerte('verein',$verein);
	# Ansprechpartner
	$anspr = $daten['ansprechpartner'];
	$ooo->setzeWerte('anspr',$anspr);
	# Kampfrichter
	if($daten['kampfrichter'] !== false){
		$kampfrichter = array();
		$i = 1;
		foreach($daten['kampfrichter'] as $kari){
			$kampfrichter['name'.$i] = $kari['name'];
			$kampfrichter['gr'.$i] = $_kampfrichtergruppen[$kari['gruppe']];
			$i++;
			if($i>3){
				break;
			}
		}
		$ooo->setzeWerte('kari',$kampfrichter);
	}
	# Einzel- und Staffelstarts seitenweise zusammenbauen
	$starts = array();
	$anz = array(
		'einzel_karten'  => 0,
		'staffel_karten' => 0,
		'einzel_liste'   => 0,
		'staffel_liste'  => count($daten['staffelstarts']),
		'mannschaften'   => 0,
		'staffel_blatt'  => 0,
		'einzel_blatt'   => 0
	);
	$l = 1;
	foreach($daten['einzelstarts'] as $teilnehmerid => $mitglied){
		$anz['einzel_liste'] += count($mitglied['_starts']);
		foreach($mitglied['_starts'] as $start){
			$starts[] = array(
				'lfdnr'     => $l,
				'name'      => $mitglied['name'],
				'dsvid'     => $mitglied['dsvid'],
				'mw'        => $mitglied['mw'],
				'jg'        => substr($mitglied['jg'],2),
				'ak'        => '',
				'wknr'      => $start['wknr'],
				'strecke'   => $start['laenge'].' '.$_lagen[$start['disziplin']][0],
				'meldezeit' => is_null($start['zeit'])?($_gleinst['wettkaempfe_abwickeln']['ohnemeldezeit']=='ohnezeit'?'00:00,00':'59:59,99'):text_format($start['zeit'],'schwimmzeit')
			);
		}
		$l++;
	}
	$seiten = array();
	$i = $j = 1;
	$eintraegeproseite = 20;
	foreach($starts as $start){
		if(!isset($seiten[$i])){
			$seiten[$i] = array();
		}
		$seiten[$i][] = $start;
		$j++;
		if($j > $eintraegeproseite){
			$j = 1;
			$i++;
		}
	}
	if(!isset($seiten[$i])){
		$i--;
	}
	if(count($seiten[$i]) != $eintraegeproseite){
		for($k = count($seiten[$i]); $k < $eintraegeproseite; $k++){
			$seiten[$i][] = false;
		}
	}
	$anz['einzel_blatt'] = ceil($anz['einzel_liste']/$eintraegeproseite);
	if(count($daten['staffelstarts']) > 0){
		$i++;
		$j = 1;
	}
	foreach($daten['staffelstarts'] as $teilnehmerid => $staffel){
		$w = $daten['wettkaempfe'][$staffel['wknr']];
		if(!isset($seiten[$i])){
			$seiten[$i] = array();
		}
		$seiten[$i][] = array(
			'lfdnr'     => $l,
			'name'      => $staffel['nr'].'. Mannschaft'.(!empty($staffel['klasse'])?' ('.$staffel['klasse'].')':''),
			'dsvid'     => '',
			'mw'        => $w['mw'],
			'jg'        => '',
			'ak'        => '',
			'wknr'      => $staffel['wknr'],
			'strecke'   => $w['laenge'].' '.$_lagen[$w['disziplin']][0],
			'meldezeit' => text_format($staffel['zeit'],'schwimmzeit')
		);
		$j++;
		$l++;
		if($j > $eintraegeproseite){
			$j = 1;
			$i++;
		}
	}
	$anz['staffel_blatt'] = ceil($anz['staffel_liste']/$eintraegeproseite);
	if(count($seiten[$i]) != $eintraegeproseite){
		for($k = count($seiten[$i]); $k < $eintraegeproseite; $k++){
			$seiten[$i][] = false;
		}
	}
	$ooo->setzeWerte('anz',$anz);
	$query = "SELECT meldegeld FROM ".DB_PREFIX."wettkaempfe WHERE id = ".$_SESSION['wk_abwickeln']['id']."";
	$_db->holeDaten($query);
	$meldegeld = $wk->parseMeldegeld($_db->holeWert(),'db','wkpreis_rechnen');
	$preis = array(
		'ek_einzel' => '0,00', 'ek_summe' => '0,00',
		'sk_einzel' => '0,00', 'sk_summe' => '0,00',
		'el_einzel' => number_format($meldegeld['einzel'], 2, ',', ''),
		'el_summe'  => number_format($anz['einzel_liste']*$meldegeld['einzel'], 2, ',', ''),
		'sl_einzel' => number_format($meldegeld['staffel'], 2, ',', ''),
		'sl_summe'  => number_format($anz['staffel_liste']*$meldegeld['staffel'], 2, ',', ''),
		'mannsch_einzel' => '0,00', 'mannsch_summe' => '0,00',
		'kari_einzel' => '0,00', 'kari_summe' => '0,00'
	);
	$preis['summe'] = number_format($anz['einzel_liste']*$meldegeld['einzel']+$anz['staffel_liste']*$meldegeld['staffel'], 2, ',', '');
	$ooo->setzeWerte('seiten',$seiten);
	$ooo->setzeWerte('seitenzahl', count($seiten));
	$ooo->setzeWerte('preis',$preis);
	$ooo->setzeEinstellung('ooo:configuration-settings','AddParaTableSpacingAtStart','boolean',true);
	# Datei generieren
	$ooo->generiereDateien();
	$ooo->setzeDateiname('meldebogen.odt');
	$ooo->gebeOooDateiAus();
	break;
default:
	$_tmpl->assign('fehler','Es wurde kein gültiges Format für die Meldedatei angegeben.');
	break;
} # Ende meldeformat-switch
} # Ende $fehler-else
# EOF
