<?php
/*
Wettkampfabwicklung, Aktion: staffelzusammensetzung
verwendete Templates:
 - 42.staffeln-gespeicherte.inc.html
 - 42.staffeln-zusammensetzung.inc.html
 - 42.staffeln-zusammensetzung-zeiten.inc.html
 - 42.staffeln-zusammensetzung-ergebnis.inc.html
*/
if(isset($_GET['gespeicherte']) and isset($_wkeinst['staffeln'])){
	if(substr($_GET['gespeicherte'],0,9) == 'loeschen_'){
		unset($_wkeinst['staffeln'][substr($_GET['gespeicherte'],9)]);
		schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'], $_wkeinst, true);
		weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=staffelzusammensetzung&gespeicherte','Die Staffeln wurde gelöscht');
	}
	$staffeln = array();
	$art = array();
	$mids = array();
	foreach($_wkeinst['staffeln'] as $key => $staffel){
		if(substr($key,0,9) != 'staffeln_'){
			continue;
		}
		list(,$strecke,$lage,$mwx) = explode('_',$key);
		$art[$key] = array('strecke'=>$strecke,'lage'=>$_lagen[$lage],'mwx'=>$_geschlechter[$mwx]);
		$staffeln[$key] = unserialize(str_replace("'",'"',$staffel));
		foreach($staffeln[$key] as $mitgl){
			$mids = array_merge($mids,$mitgl['schwimmer']);
		}
	}
	if(count($staffeln) < 1){
		weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=staffelzusammensetzung','Es wurden keine Staffeln gefunden');
	}
	$mids = array_unique($mids);
	if(count($mids)>0){
		$query = "SELECT id, CONCAT(nachname,', ',vorname,' (',YEAR(gebdatum),', ',mw,')') as name FROM ".DB_PREFIX."mitglieder as m
					WHERE id IN (".implode(',',$mids).") ORDER BY name";
		$_db->holeDaten($query);
		$mitglieder = $_db->baueArray('name','id');
	}
	else{
		$mitglieder = array();
	}

	if($_GET['gespeicherte'] == 'pdf'){
		require_once(PFAD_INCLUDE.'class/pdf.inc.php');
		$pdf = new tkpdf(10);
		$pdf->tkseitentitel('Staffelzusammensetzung für '.$_wkeinst['meldezettel']['rueckmeldungfuer']);
		$pdf->tk_autor = $_SESSION['user']['realname'];
		$pdf->tk_titel = 'Staffelzusammensetzung für '.$_wkeinst['meldezettel']['rueckmeldungfuer'];
		$optionen = array(
			'fontSize' => $pdf->tk_schriftgroesse,
			'xPos' => 60,
			'xOrientation' => 'right',
			'shaded' => 0,
			'showLines' => 0,
			'colGap' => 7,
			'showHeadings' => 0
		);
		$daten = array();

		foreach($staffeln as $key => $row){
			$tmp = array(
				'titel' => $art[$key]['strecke'].'m '.$art[$key]['lage'].' '.$art[$key]['mwx'],
				'daten' => array()
			);
			$i = 1;$j = 1;
			foreach($row as $st){
				$dat = '<b>'.$i.'. Mannschaft</b> ('.text_format($st['geszeit'],'schwimmzeit').'):'."\n";
				if($art[$key]['lage']=='Lagen'){
					$dat .= '<i>Rücken:</i> '.$mitglieder[$st['schwimmer'][3]]."\n";
					$dat .= '<i>Brust:</i> '.$mitglieder[$st['schwimmer'][2]]."\n";
					$dat .= '<i>Schmetterling:</i> '.$mitglieder[$st['schwimmer'][4]]."\n";
					$dat .= '<i>Freistil:</i> '.$mitglieder[$st['schwimmer'][1]]."\n";
					if($i%2){
						$j++;
						$tmp['daten'][$j] = array();
					}
					$tmp['daten'][$j][] = $dat;
				}
				else{
					foreach($st['schwimmer'] as $nr => $schw){
						$dat .= $mitglieder[$schw]."\n";
					}
					if($i%3==1){
						$j++;
						$tmp['daten'][$j] = array();
					}
					$tmp['daten'][$j][] = $dat;
				}
				$i++;
			}
			if(!isset($tmp['daten'][$j][1])){
				$tmp['daten'][$j][1] = '';
			}
			if(!isset($tmp['daten'][$j][2])){
				$tmp['daten'][$j][2] = '';
			}
			$daten[] = $tmp;

		}

		foreach($daten as $row){
			$y = $pdf->ezText('<b>'.$row['titel'].'</b>', $pdf->tk_schriftgroesse+1);
			$pdf->ezSetDy(-6);
			$y = $pdf->ezTable($row['daten'], '', '', $optionen);
			$i++;
			if($y < 130){
				$pdf->eznewPage();
			}
			$pdf->ezSetDy(-2);
		}
		$pdf->tkstream('staffelzusammensetzung.pdf');
	}
	$_tmpl->assign('lagen',$_lagen);
	$_tmpl->assign('mwx',$_geschlechter);
	$_tmpl->assign('mitglieder',$mitglieder);
	$_tmpl->assign('art',$art);
	$_tmpl->assign('staffeln',$staffeln);
	$_inh .= $_tmpl->fetch('wettkaempfe/42.staffeln-gespeicherte.inc.html');
}
else{

	if(isset($_GET['zuruecksetzen'])){
		unset($_SESSION['wk_abwickeln']['staffel']);
		weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=staffelzusammensetzung');
	}

	if(isset($_POST['speichern2'])){
		require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
		foreach($_POST['zeiten'] as $mid => $mitgl){
			foreach($mitgl as $lage => $zeit){
				if(empty($zeit)){
					$zeit = '';
				}
				else{
					$f = pruefen($zeit,'schwimmzeit','-');
					if(!empty($f)){
						$zeit = '';
					}
				}
				$_SESSION['wk_abwickeln']['staffel']['mitgliederzeiten'][$mid][$lage] = $zeit;
			}
		}
		if(isset($_POST['zeitenpdf'])){
			$daten = $_SESSION['wk_abwickeln']['staffel']['mitgliederzeiten'];
			$mids = array_keys($daten);
			$query = "SELECT id, CONCAT(nachname,', ',vorname,' (',YEAR(gebdatum),', ',mw,')') as name
						FROM ".DB_PREFIX."mitglieder WHERE id IN (".implode(',',$mids).") ORDER BY name";
			$_db->holeDaten($query);
			$mdaten = $_db->baueArray('name','id');
			$pdfdaten = array();
			foreach($daten as $mid => $row){
				$pdfdaten[] = array(
					'name' => $mdaten[$mid],
					'f'    => text_format($row[1],'schwimmzeit'),
					'b'    => text_format($row[2],'schwimmzeit'),
					'r'    => text_format($row[3],'schwimmzeit'),
					's'    => text_format($row[4],'schwimmzeit'),
				);
			}
			require_once(PFAD_INCLUDE.'class/pdf.inc.php');
			$pdf = new tkpdf;
			# Einstellungen
			$titel = 'Zeitenexport für Staffelzusammensetzung (Stand: '.date('d.m.Y H:i').')';
			$optionen = array(
				'fontSize' => $pdf->tk_schriftgroesse,
				'titelFontSize' => $pdf->tk_schriftgroesse,
				'xPos' => 50,
				'xOrientation' => 'right',
				'shaded' => 0,
				'showLines' => 2,
				'colGap' => 6,
				'rowGap' => 2,
				'innerLineThickness' => 0.5,
				'outerLineThickness' => 1.0
			);
			$spalten = array(
				'name' => 'Name',
				'f' => $_lagen[1],
				'b' => $_lagen[2],
				'r' => $_lagen[3],
				's' => $_lagen[4],
			);
			# Export
			$pdf->tkseitennummern();
			$pdf->tk_titel = $titel;
			$pdf->tkseitentitel($titel);
			$pdf->tk_autor = $_SESSION['user']['realname'];
			$pdf->ezTable($pdfdaten,$spalten,'',$optionen);
			$dateiname = 'zeitenexport_staffelzusammensetzung.pdf';
			$pdf->tkstream($dateiname);
		}
	}

	if(isset($_GET['speichern'])){
		if(!isset($_wkeinst['staffeln'])){
			$_wkeinst['staffeln'] = array();
		}
		if(!isset($_SESSION['wk_abwickeln']['staffel']['ergebnis'])){
			weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=staffelzusammensetzung');
		}
		$einst = $_SESSION['wk_abwickeln']['staffel']['einst'];
		$key = 'staffeln_'.$einst['schwimmer'].'x'.$einst['strecke'].'_'.$einst['lage'].'_'.$einst['mwx'].'';
		$_wkeinst['staffeln'][$key] = str_replace('"',"'",serialize($_SESSION['wk_abwickeln']['staffel']['ergebnis']));
		schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'],$_wkeinst,true);
		weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=staffelzusammensetzung','Die Staffeln wurden gespeichert');
	}

	if(isset($_POST['speichern1']) and !empty($_POST['art']['staffeln'])){
		$_SESSION['wk_abwickeln']['staffel'] = array();
		$w = $_POST['art'];
		if($w['lage']==5){
			$w['schwimmer'] = 4;
		}
		$_SESSION['wk_abwickeln']['staffel']['einst'] = array(
			'staffeln'   => (ctype_digit($w['staffeln']) and (int)$w['staffeln']>0)?(int)$w['staffeln']:1,
			'schwimmer'  => (ctype_digit($w['schwimmer']) and (int)$w['schwimmer']>0)?(int)$w['schwimmer']:4,
			'lage'       => (in_array($w['lage'],array_keys($_lagen))?$w['lage']:1),
			'strecke'    => (ctype_digit($w['strecke']) and (int)$w['strecke']>0)?(int)$w['strecke']:50,
			'mwx'        => (in_array($w['mwx'],array_keys($_geschlechter))?$w['mwx']:'x'),
			'xbedingung' => (in_array($w['xbedingung'],array(1,2))?$w['xbedingung']:1)
		);

		$_SESSION['wk_abwickeln']['staffel']['einst']['schwimmerids'] = array();
		if(isset($_POST['kandidaten']['gemeldete']) and is_array($_POST['kandidaten']['gemeldete'])){
			foreach($_POST['kandidaten']['gemeldete'] as $mid){
				if((int)$mid != 0){
					$_SESSION['wk_abwickeln']['staffel']['einst']['schwimmerids'][] = (int)$mid;
				}
			}
		}
		if(isset($_POST['kandidaten']['nichtgemeldete']) and is_array($_POST['kandidaten']['nichtgemeldete'])){
			foreach($_POST['kandidaten']['nichtgemeldete'] as $mid){
				if((int)$mid != 0){
					$_SESSION['wk_abwickeln']['staffel']['einst']['schwimmerids'][] = (int)$mid;
				}
			}
		}
		$mwx = $_SESSION['wk_abwickeln']['staffel']['einst']['mwx'];
		$schwimmer = $_SESSION['wk_abwickeln']['staffel']['einst']['schwimmerids'];
		if(count($schwimmer)>0){
			$query = "SELECT id FROM ".DB_PREFIX."mitglieder
						WHERE id IN (".implode(',',$schwimmer).")".($mwx!='x'?" AND mw = '".$mwx."'":'')."
						ORDER BY nachname, vorname";
			$_db->holeDaten($query);
			$_SESSION['wk_abwickeln']['staffel']['einst']['schwimmerids'] = array();
			if($_db->ergebnis['anzahl']>0){
				$_SESSION['wk_abwickeln']['staffel']['einst']['schwimmerids'] = $_db->baueArray('id','#');
			}
		}
		else{
			$_SESSION['wk_abwickeln']['staffel']['einst']['schwimmerids'] = array();
		}
	}

	if(!isset($_SESSION['wk_abwickeln']['staffel']['einst'])){ # Art der Staffeln und Mitglieder waehlen

		$gespeicherte = false;
		if(isset($_wkeinst['staffeln'])){
			foreach($_wkeinst['staffeln'] as $key => $st){
				if(substr($key,0,9) == 'staffeln_'){
					$gespeicherte = true;
				}
			}
		}
		$_tmpl->assign('gespeicherte',$gespeicherte);
		$_tmpl->assign('mwx',$_geschlechter);
		unset($_lagen[6]);
		$_tmpl->assign('lagen',$_lagen);
		$voreinst = array('lagen'=>1,'mwx'=>'x');

		$query = "SELECT mid, CONCAT(nachname,', ',vorname,' (',YEAR(gebdatum),', ',mw,')') as name, teilnahme
					FROM ".DB_PREFIX."meldungen_teilnehmer as mt, ".DB_PREFIX."mitglieder as m
					WHERE wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND mt.mid=m.id
					ORDER BY name";
		$_db->holeDaten($query);
		if($_db->ergebnis['anzahl'] > 0){
			$_tmpl->assign('gemeldete',$_db->baueArray('name','mid'));
			$gemeldete = $_db->baueArray('mid','#');
			$voreinst['mitgl'] = array();
			foreach($_db->ergebnis['daten'] as $row){
				if($row['teilnahme'] != '-'){
					$voreinst['mitgl'][] = $row['mid'];
				}
			}
			$query = "SELECT mitgliedid, CONCAT(nachname,', ',vorname,' (',YEAR(gebdatum),', ',mw,')') as name
						FROM ".DB_PREFIX."mitglieder_gruppen as mt, ".DB_PREFIX."mitglieder as m
						WHERE mt.mitgliedid=m.id AND gruppenid <= 15 AND mitgliedid NOT IN (".implode(',',$gemeldete).")
						GROUP BY mitgliedid ORDER BY name";
			$_db->holeDaten($query);
			$_tmpl->assign('nichtgemeldete',$_db->baueArray('name','mitgliedid'));
		}
		else{
			$_tmpl->assign('gemeldete',false);
		}
		$_tmpl->assign('daten',$voreinst);
		$_inh .= $_tmpl->fetch('wettkaempfe/42.staffeln-zusammensetzung.inc.html');
	}
	elseif(!isset($_SESSION['wk_abwickeln']['staffel']['mitgliederzeiten'])){ # Zeiten der Mitglieder holen und anzeigen
		# benoetigte Strecken/Disziplinen ermitteln
		$einst = $_SESSION['wk_abwickeln']['staffel']['einst'];
		if($einst['lage'] == 5){
			$lagen = array(1,2,3,4);
		}
		else{
			$lagen = array($einst['lage']);
		}
		$laenge = $einst['strecke'];
		$daten = array();
		# Zeiten holen
		$query = "SELECT mid, laenge, disziplin, zeit 
					FROM ".DB_PREFIX."aktuellezeiten as a LEFT JOIN ".DB_PREFIX."mitglieder as m ON a.mid = m.id
					WHERE mid IN (".implode(',',$einst['schwimmerids']).") AND laenge = ".$laenge." AND
					  ".(count($lagen)==1?"disziplin = ".$lagen[0]:"disziplin IN (".implode(',',$lagen).")")."
					ORDER BY nachname, vorname, disziplin, laenge";
		$_db->holeDaten($query);
		$tmpzeiten = $_db->baueArray('*','#');
		foreach($tmpzeiten as $zeit){
			if(!isset($daten[$zeit['mid']])){
				$daten[$zeit['mid']] = array();
			}
			$daten[$zeit['mid']][$zeit['disziplin']] = $zeit['zeit'];
		}

		# Daten an Template übergeben
		$_tmpl->assign('zeiten',$daten);
		if(count($daten)>0){
			$query = "SELECT id, CONCAT(nachname,', ',vorname,' (',YEAR(gebdatum),', ',mw,')') as name FROM ".DB_PREFIX."mitglieder as m
						WHERE id IN (".implode(',',array_keys($daten)).") ORDER BY name";
			$_db->holeDaten($query);
			$_tmpl->assign('mitglieder',$_db->baueArray('name','id'));
		}
		$_tmpl->assign('disziplinen',$lagen);
		$_tmpl->assign('lagen',$_lagen);
		$_inh = $_tmpl->fetch('wettkaempfe/42.staffeln-zusammensetzung-zeiten.inc.html');
	}
	else{ # Ergebnis errechnen und ausgeben

		$einst = $_SESSION['wk_abwickeln']['staffel']['einst'];
		$zeiten = $_SESSION['wk_abwickeln']['staffel']['mitgliederzeiten'];

		# beste Zeiten suchen
		$ergebnis = array();
		if($einst['lage'] == 5){
			$speicher = array(1=>array(),2=>array(),3=>array(),4=>array());
			foreach($zeiten as $mid => $mitgl){
				if(!empty($mitgl[1])){
					$speicher[1][$mid] = $mitgl[1];
				}
				if(!empty($mitgl[2])){
					$speicher[2][$mid] = $mitgl[2];
				}
				if(!empty($mitgl[3])){
					$speicher[3][$mid] = $mitgl[3];
				}
				if(!empty($mitgl[4])){
					$speicher[4][$mid] = $mitgl[4];
				}
			}
			asort($speicher[1]);
			asort($speicher[2]);
			asort($speicher[3]);
			asort($speicher[4]);
			for($i=0;$i<$einst['staffeln'];$i++){
				$fertig = $wk->ermittleSchnellsteLagenstaffelkombinationen($speicher,$einst['mwx'],$einst['xbedingung']);
				if(!$fertig){
					continue;
				}

				/*
				# ersten 10 Kombinationen ausgeben
				$besten10 = $mids = array();
				for($j=0;$j<10;$j++){
					if(!isset($fertig[$j])){
						break;
					}
					$besten10[] = $fertig[$j];
					foreach($fertig[$j]['schwimmer'] as $id){
						$mids[] = $id;
					}
				}
				$mids = array_unique($mids);
				$query = "SELECT id, CONCAT(nachname,', ',vorname) as name FROM ".DB_PREFIX."mitglieder WHERE id IN (".implode(',',$mids).")";
				$_db->holeDaten($query);
				$id2name = $_db->baueArray('name','id');
				foreach($besten10 as $key => $staffel){
					$besten10[$key]['geszeit'] = text_format($staffel['geszeit'],'schwimmzeit');
					foreach($staffel['schwimmer'] as $key2 => $mid){
						$besten10[$key]['schwimmer'][$key2] = $id2name[$mid];
					}
				}
				# 10 Kombinationen, Ende
				*/

				$ergebnis[] = $fertig[0];
				$mitglieder = $fertig[0]['schwimmer'];
				foreach($mitglieder as $mid){
					if(isset($speicher[1][$mid])){
						unset($speicher[1][$mid]);
					}
					if(isset($speicher[2][$mid])){
						unset($speicher[2][$mid]);
					}
					if(isset($speicher[3][$mid])){
						unset($speicher[3][$mid]);
					}
					if(isset($speicher[4][$mid])){
						unset($speicher[4][$mid]);
					}
				}
			}
		}
		else{
			$tmp = $zeiten;
			$zeiten = array();
			foreach($tmp as $mid => $zeit){
				if(empty($zeit[$einst['lage']])){
					continue;
				}
				$zeiten[$mid] = $zeit[$einst['lage']];
			}
			asort($zeiten);
			# Geschlechter holen
			$schwimmer = array_keys($zeiten);
			$query = "SELECT id, mw FROM ".DB_PREFIX."mitglieder WHERE id IN (".implode(',',$schwimmer).")";
			$_db->holeDaten($query);
			$mw = $_db->baueArray('mw','id');
			$m = $w = array();
			foreach($mw as $mid => $geschl){
				if($geschl == 'w'){
					$w[] = $mid;
				}
				else{
					$m[] = $mid;
				}
			}
			for($i=0;$i<$einst['staffeln'];$i++){
				if($einst['mwx'] == 'w'){
					$werlaubt = $einst['schwimmer'];
					$merlaubt = 0;
				}
				elseif($einst['mwx'] == 'm'){
					$werlaubt = 0;
					$merlaubt = $einst['schwimmer'];
				}
				else{
					if($einst['xbedingung'] == 1){
						$werlaubt = $merlaubt = $einst['schwimmer']-1;
					}
					else{
						$werlaubt = $merlaubt = $einst['schwimmer']/2;
					}
				}
				$tmp = array(
					'geszeit'   => 0,
					'schwimmer' => array()
				);
				foreach($zeiten as $mid => $zeit){
					if(count($tmp['schwimmer'])>=$einst['schwimmer']){
						break;
					}
					if(in_array($mid,$m)){
						if($merlaubt > 0){
							$tmp['geszeit'] += $zeit;
							$tmp['schwimmer'][] = $mid;
							unset($zeiten[$mid]);
							$merlaubt--;
						}
						continue;
					}
					if(in_array($mid,$w)){
						if($werlaubt > 0){
							$tmp['geszeit'] += $zeit;
							$tmp['schwimmer'][] = $mid;
							unset($zeiten[$mid]);
							$werlaubt--;
						}
						continue;
					}
				}
				$ergebnis[] = $tmp;
			}
			foreach($ergebnis as $key => $daten){
				if(count($daten['schwimmer'])<$einst['schwimmer']){
					unset($ergebnis[$key]);
				}
			}
		}
		$mids = array();
		foreach($ergebnis as $key => $daten){
			foreach($daten['schwimmer'] as $key2 => $mid){
				$mids[] = $mid;
			}
		}
		if(count($mids)>0){
			$query = "SELECT id, CONCAT(nachname,', ',vorname,' (',YEAR(gebdatum),', ',mw,')') as name FROM ".DB_PREFIX."mitglieder as m
						WHERE id IN (".implode(',',$mids).") ORDER BY name";
			$_db->holeDaten($query);
			$mitglieder = $_db->baueArray('name','id');
			$_tmpl->assign('mitglieder',$mitglieder);
		}

		$_SESSION['wk_abwickeln']['staffel']['ergebnis'] = $ergebnis;
		$_tmpl->assign('ergebnis',$ergebnis);
		$_tmpl->assign('einst',$einst);
		$_tmpl->assign('lagen',$_lagen);
		$_tmpl->assign('mw',$_geschlechter);
		$_inh .= $_tmpl->fetch('wettkaempfe/42.staffeln-zusammensetzung-ergebnis.inc.html');
	}
}
# EOF
