<?php
/*
Wettkampfabwicklung, Aktion: uebersicht_wettkaempfe
verwendete Templates:
 - 42.uebersicht-wettkaempfe.inc.html
*/
$bearbeiten = (pruefeRechte('w_abwickeln_mitglhinzufuegen') and !$flags['meldeschlussvorbei']);

if($bearbeiten and isset($_GET['startentfernen']) and preg_match('~^[0-9]+_[0-9]+$~D',$_GET['startentfernen'])){
	list($tid,$wkid) = explode('_',$_GET['startentfernen']);
	$query = "DELETE FROM ".DB_PREFIX."meldungen_starts WHERE teilnehmerid = ".$tid." AND wkid = ".$wkid."";
	$_db->fuehreQueryAus($query);
	weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=uebersicht_wettkaempfe','Der Start wurde aus der Meldung entfernt');
}

if(isset($_POST['neuezeit'])){
	function ergebnismeldung($code, $zeit=''){
		$statusmeldungen = array(
			1 => 'Die Meldezeit wurde geändert',
			2 => '', # leere Meldung wenn die Meldezeit nicht geändert wurde
			-1 => 'Dir fehlen die Rechte um die Meldezeit bearbeiten zu dürfen',
			-2 => 'Der Meldeschluss ist bereits vorbei, die Meldung kann nicht mehr geändert werden',
			-3 => 'Die Meldezeit ist ungültig',
			-4 => 'Der Schreibschutz für alle Daten ist gesetzt, es können momentan keine Daten verändert werden.',
			-5 => 'Die Meldezeit konnte nicht geändert werden'
		);
	
		$meldung = $statusmeldungen[$code];

		if($code == 1){
			global $_db;
			$_db->speichereGeaenderteTabellen();
		}
		$ausgabe = '<?xml version="1.0" encoding="UTF-8" ?>'."\n";
		$ausgabe .= '<ergebnis>'."\n";
		$ausgabe .= ' <code>'.$code.'</code>'."\n";
		$ausgabe .= ' <meldung>'.text_format($meldung,'xml').'</meldung>'."\n";
		if($code > 0){
			$ausgabe .= ' <zeit>'.$zeit.'</zeit>'."\n";
		}
		$ausgabe .= '</ergebnis>';
		header('Content-Type: text/xml');
		echo $ausgabe;
		exit;
	}
	
	if(!pruefeRechte('w_abwickeln_mitglhinzufuegen')){
		ergebnismeldung(-1);
	}
	elseif($flags['meldeschlussvorbei']){
		ergebnismeldung(-2);
	}
	elseif(TKSWIM_SCHREIBSCHUTZ){
		ergebnismeldung(-4);
	}
	else{
		if($_POST['neuezeit'] == ''){
			$zeit = '';
		}
		else{
			require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
			$f = pruefen($_POST['neuezeit'], 'schwimmzeit', '-');
			if(!empty($f)){
				ergebnismeldung(-3);
			}
			$zeit = $_POST['neuezeit'];
		}
		list($tid,$wkid) = explode('_',$_POST['strecke']);
		$query = "SELECT meldezeit FROM ".DB_PREFIX."meldungen_starts 
					WHERE teilnehmerid = '".text_format($tid,'db')."' AND wkid = '".text_format($wkid,'db')."'";	
		$_db->holeDaten($query);
		$altezeit = $_db->holeWert();
		if(is_null($altezeit) and empty($zeit) or $altezeit == $zeit){
			ergebnismeldung(2, text_format($zeit, 'schwimmzeit'));
		}
		$query = "UPDATE ".DB_PREFIX."meldungen_starts 
					SET meldezeit = ".(empty($zeit)?'NULL':$zeit)."
					WHERE teilnehmerid = '".text_format($tid,'db')."' AND wkid = '".text_format($wkid,'db')."'";	
		$_db->fuehreQueryAus($query);
		ergebnismeldung($_db->holeAnzahl()==1?1:-5, text_format($zeit, 'schwimmzeit'));
	}
}

$query = "SELECT w.id, abschnittid, wknr, mw, laenge, disziplin, jahrgang, wkart , a.nr as abschnnr
			FROM ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a
			WHERE w.abschnittid = a.id AND a.wettkampfid = ".$_SESSION['wk_abwickeln']['id']." AND SUBSTRING(laenge,2,1) != 'x'
			ORDER BY a.nr, wknr";
$_db->holeDaten($query);
if($_db->ergebnis['anzahl'] > 0){
	$wkdaten = $_db->ergebnis['daten'];
	foreach($wkdaten as $key => $row){
		if($row['wkart'] != 'e' AND $row['wkart'] != 'v'){
			$wkdaten[$key]['_mitglieder'] = array();
			continue;
		}
		$query = "SELECT teilnehmerid as tid, CONCAT(m.nachname,', ',m.vorname) as name, ms.meldezeit as zeit, 
					  IF(meldezeit IS NULL,1,0) zeitnull, ms.teilnahme
					FROM ".DB_PREFIX."mitglieder as m, ".DB_PREFIX."meldungen_starts as ms, ".DB_PREFIX."meldungen_teilnehmer as mt
					WHERE ms.teilnehmerid = mt.id AND mt.mid = m.id AND wkid = ".$row['id']."
					ORDER BY zeitnull, zeit, name";
		$_db->holeDaten($query);
		if($_db->ergebnis['anzahl'] < 1){
			$wkdaten[$key]['_mitglieder'] = array();
			continue;
		}
		$wkdaten[$key]['_mitglieder'] = $_db->ergebnis['daten'];
	}
}
else{
	$wkdaten = array();
}
$teilnahmeklassen = array(
	'+' => 't_ja',
	'0' => 't_offen',
	'-' => 't_nein weg'
);
if(!in_array($_wettkampfart,array('wrcup','vm')) and (isset($_wkeinst['flags']['ruecklaufzettel'])?$_wkeinst['flags']['ruecklaufzettel']=='+':$_gleinst['wettkaempfe_abwickeln']['ruecklaufzettel']=="1")){
	$_tmpl->assign('cl', $teilnahmeklassen);
}
$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
$_tmpl->tk_javascriptzuweisen('onready', "\$('.loeschen').tkswim_loeschfrage({elternelement:'li',keineloeschfrage:true,art:'wkabw_startentfernen'});");
$_tmpl->assign('lagen',$_lagen);
$_tmpl->assign('wkdaten',$wkdaten);
$_tmpl->assign('bearbeiten', $bearbeiten);
$_tmpl->assign('_az', $_SESSION['wk_abwickeln']['abschnitte']>1);



if($bearbeiten){
	$_tmpl->tk_javascriptzuweisen('inline', "var ajaxdatei2 = '".ROOT."/wettkaempfe/abwickeln?aktion=uebersicht_wettkaempfe';");
	$_tmpl->tk_javascriptzuweisen('onready', "\$('.zeitbearbeiten').dblclick(function(event){
    \$('#zeitbearbeiten').dialog('open');
    var e = $(this);
    \$(\"input[name='zeilenid']\").val(e.parent().attr('id'));
    e.parent().addClass('aktuell');
    \$(\"input[name='neuezeit']\").val(e.text()=='[ohne Zeit]'?'':e.text()).focus();
  });");

	$_tmpl->tk_javascriptzuweisen('onready',"$('#zeitbearbeiten').dialog({
    bgiframe: true, autoOpen: false, modal: true, width: 'auto', minHeight:50,
    closeText: '×', height: 'auto', resizable: false, title: 'Meldezeit bearbeiten',
    close: function(){ \$('#'+\$(\"input[name='zeilenid']\").val()).removeClass('aktuell'); }
  });");
	$_tmpl->tk_javascriptzuweisen('inline',"function zeitbearbeiten(){
  var zeit = \$(\"input[name='neuezeit']\").val();
  var strecke = \$(\"input[name='zeilenid']\").val().substr(1);
  $.post(ajaxdatei2, {mimeType:'text/xml',strecke:strecke,neuezeit:zeit},
    function(a){
      var li = \$('#'+\$(\"input[name='zeilenid']\").val());
      if($(a).find('code').text() > 0){ // erfolgreich
        \$().message($(a).find('meldung').text());
        li.find('.zeitbearbeiten').text($(a).find('zeit').text()==''?'[ohne Zeit]':$(a).find('zeit').text());
      }
      else{ // Fehler
        $().message('Fehler: '+$(a).find('meldung').text());
      }
    },'xml');
    \$('#zeitbearbeiten').dialog('close');
  return false;
}");
}







$_inh .= $_tmpl->fetch('wettkaempfe/42.uebersicht-wettkaempfe.inc.html');
# EOF
?>