<?php
# Modul: wkabwickeln_dms

# Flags
$flags['dms_mannschaften'] = (isset($_wkeinst['dms']) and count($_wkeinst['dms'])>0)?true:false;
$flags['dms_streckenzuordnung'] = (isset($_wkeinst['dmsstreckenzuordnung']) and count($_wkeinst['dmsstreckenzuordnung'])>0)?true:false;

# Aktionen
$aktionen['dms_einstellungen'] = array(
	'titel'     => 'Einstellungen',
	'recht'     => 'w_abwickeln_meldung',
	'kategorie' => 'vorbereitung',
	'anzeigen'  => 1,
	'block'     => 5
);
$aktionen['dms_mannschaften'] = array(
	'titel'     => 'Mannschaften'.(pruefeRechte('w_abwickeln_mitglhinzufuegen')?' bearbeiten':''),
	'recht'     => 'w_abwickeln_anzeigen',
	'kategorie' => 'vorbereitung',
	'anzeigen'  => !$flags['meldeschlussvorbei'],
	'block'     => 1
);
$aktionen['dms_meldedateigenerieren'] = array(
	'titel'     => 'Meldedatei generieren',
	'recht'     => 'w_abwickeln_meldung',
	'kategorie' => 'meldeschluss',
	'anzeigen'  => ($flags['ansprechpartner'] and $flags['dms_mannschaften']),
	'block'     => 1
);
$aktionen['dms_meldeformular'] = array(
	'titel'     => 'Meldeformular generieren',
	'recht'     => 'w_abwickeln_meldung',
	'kategorie' => 'meldeschluss',
	'anzeigen'  => ($flags['ansprechpartner'] and $flags['dms_mannschaften']),
	'block'     => 1
);
$aktionen['dms_streckenschwimmerzuordnen'] = array(
	'titel'     => 'Strecken Schwimmer zuordnen',
	'recht'     => 'w_abwickeln_meldung',
	'kategorie' => 'vorwettkampf',
	'anzeigen'  => $flags['dms_mannschaften'],
	'block'     => 1
);
$aktionen['dms_startkarten'] = array(
	'titel'     => 'Startkarten generieren',
	'recht'     => 'w_abwickeln_meldung',
	'kategorie' => 'vorwettkampf',
	'anzeigen'  => $flags['dms_mannschaften'],
	'block'     => 1
);
$aktionen['dms_aufstellungexportieren'] = array(
	'titel'     => 'Aufstellung exportieren',
	'recht'     => 'w_abwickeln_anzeigen',
	'kategorie' => 'vorwettkampf',
	'anzeigen'  => $flags['dms_mannschaften'],
	'block'     => 1
);
$aktionen['ergebnisse'] = array(
	'titel'     => 'Wettkampfauswertung anzeigen',
	'recht'     => 'w_ergebnisse',
	'kategorie' => 'nachwettkampf',
	'anzeigen'  => $flags['ergebnisseimportiert'],
	'block'     => 1,
	'fussnote'  => 'die Ergebnisdarstellung befindet sich außerhalb der Wettkampfabwicklung'
);

# Fehlermeldungen
$modulfehler = array();
$modulfehler['dms_mannschaften'] = 'Der Meldeschluss ist bereits vorbei.<br />';
$modulfehler['dms_meldeformular'] = '';
if(!$flags['ansprechpartner']){
	$url = ROOT.'/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=dms_einstellungen';
	$modulfehler['dms_meldeformular'] .= 'Die <a href="'.$url.'">Einstellungen</a> sind noch nicht gesetzt worden.<br />';
}
if(!$flags['dms_mannschaften']){
	$modulfehler['dms_meldeformular'] .= 'Es sind noch keine Mannschaften gesetzt.<br />';
}
$modulfehler['dms_streckenschwimmerzuordnen'] = 'Es sind noch keine Mannschaften gesetzt.<br />';

# EOF