<?php
# Modul: wkabwickeln_dmsj

# Flags
$flags['dmsj_wkzuordnung']  = $_wettkampfart == 'dmsj'?(isset($_wkeinst['wkzuordung'])?true:false):true;
$flags['dmsj_mannschaften'] = (isset($_wkeinst['dmsj']) and count($_wkeinst['dmsj'])>0)?true:false;

# Aktionen
$aktionen['dmsj_einstellungen']          = array(
	'titel'     => 'Einstellungen',
	'recht'     => 'w_abwickeln_meldung',
	'kategorie' => 'vorbereitung',
	'anzeigen'  => 1,
	'block'     => 5
);
$aktionen['dmsj_ergebnisse2manschaften'] = array(
	'titel'     => 'Ergebnisse Mannschaften zuordnen',
	'recht'     => 'w_abwickeln_ergebnisse',
	'kategorie' => 'nachwettkampf',
	'anzeigen'  => $flags['ergebnisseimportiert'],
	'block'     => 1
);
$aktionen['dmsj_mannschaften']           = array(
	'titel'     => 'Mannschaften'.(pruefeRechte('w_abwickeln_mitglhinzufuegen')?' bearbeiten':''),
	'recht'     => 'w_abwickeln_anzeigen',
	'kategorie' => 'vorbereitung',
	'anzeigen'  => !$flags['meldeschlussvorbei'],
	'block'     => 1
);
$aktionen['dmsj_meldeformular']          = array(
	'titel'     => 'Meldeformular generieren',
	'recht'     => 'w_abwickeln_meldung',
	'kategorie' => 'meldeschluss',
	'anzeigen'  => ($flags['ansprechpartner'] and $flags['dmsj_mannschaften']),
	'block'     => 1
);
$aktionen['dmsj_pdf_startkarten']        = array(
	'titel'     => 'Startkarten generieren',
	'recht'     => 'w_abwickeln_meldung',
	'kategorie' => 'vorwettkampf',
	'anzeigen'  => 1,
	'block'     => 1
);
$aktionen['ergebnisse'] = array(
	'titel'     => 'Wettkampfauswertung anzeigen',
	'recht'     => 'w_ergebnisse',
	'kategorie' => 'nachwettkampf',
	'anzeigen'  => ($flags['ergebnisseimportiert'] and $flags['dmsj_wkzuordnung']),
	'block'     => 1,
	'fussnote'  => 'die Ergebnisdarstellung befindet sich außerhalb der Wettkampfabwicklung'
);

# Fehlermeldungen
$modulfehler = array();
$modulfehler['dmsj_ergebnisse2manschaften'] = 'Die DSV-Datei muss erst importiert werden.<br />';
$modulfehler['dmsj_mannschaften'] = 'Der Meldeschluss ist bereits vorbei.<br />';
$modulfehler['dmsj_meldeformular'] = '';
if(!$flags['ansprechpartner']){
	$url = ROOT.'/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=dmsj_einstellungen';
	$modulfehler['dmsj_meldeformular'] .= 'Die <a href="'.$url.'">Einstellungen</a> sind noch nicht gesetzt worden.<br />';
}
if(!$flags['dmsj_mannschaften']){
	$modulfehler['dmsj_meldeformular'] .= 'Es sind noch keine Mannschaften gesetzt.<br />';
}

# EOF
?>