<?php
require_once('../__inc/_start.inc.php');
$_seite = 21;
$erlaubt = pruefeRechte('a_rechte_anzeigen');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{

# einzelne Rechte dürfen nicht allen Rechtegruppen zugewiesen werden
$whitelist = array();
$blacklist = array(
	8 => array(
		'*aendern*', '*bearbeiten*',
		'a_*', 'e_*', 'm_tools_*', 'z_eingeben_*', 't_logdatei_*',
		'm_logins', 'm_anzeigen_adresse', 'm_anlegen',
		'tr_stundennachweis',
		'w_abwickeln_eigenekarimeldung', 'w_abwickeln_eigenemeldung', 'w_abwickeln_meldnintmeldeschl', 'w_abwickeln_mitglhinzufuegen',
		'w_abwickeln_ruecklaufzettel', 'w_abwickeln_kampfrichter', 'w_abwickeln_meldung', 'w_abwickeln_bemerkungen',
		'w_abwickeln_ergebnisse', 'w_abwickeln_meldezettel', 'w_anlegen',
		'z_aktuellezeiteneinlesen', 'z_vereinsrekordeeinlesen',	'z_importieren',
		's_einstellungen', 's_dateien_rootzugriff',
		't_austrittevormerken', 't_berichte', 't_hauptvereinabgleich', 'tr_anwesenheitsliste'
	)
);

$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
switch($_GET['aktion']){
case 'bereinigen':
	$_tmpl->assign('ueberschrift','Rechte bereinigen');
	if(!isset($_GET['sicher'])){
		$_tmpl->assign('frage','Sollen wirklich alle Verknüpfungen Rechte-Rechtegruppe gelöscht werden?');
		$_tmpl->assign('url', '/admin/rechte'.TKSWIM_DATEIENDUNG);
		$_inh .= $_tmpl->fetch('tools/9902.loeschfrage.inc.html');
	}
	else{
		$query = "DELETE FROM ".DB_PREFIX."rechtegruppen_rechte WHERE rechteid = '".text_format($_GET['id'],'db')."'";
		$_db->fuehreQueryAus($query);
		weiterleiten('/admin/rechte'.TKSWIM_DATEIENDUNG,'Das Rechte wurde erfolgreich bereinigt');
	}
	break;

case 'aendern':
	if(!pruefeRechte('a_rechte_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	$_tmpl->assign('ueberschrift','Rechte ändern');
	$_dbid = text_format($_GET['id'],'db');
	
	$query = "SELECT id, bezeichnung FROM ".DB_PREFIX."rechtegruppen WHERE LEFT(bezeichnung,1) != '_' ORDER BY sort";
	$_db->holeDaten($query);
	$_rechtegruppen = $_db->baueArray('bezeichnung','id');
	foreach($_rechtegruppen as $id => $gruppe){
		if(!array_key_exists($id, $blacklist)){
			continue;
		}
		$erlaubt = true;
		foreach($blacklist[$id] as $bl){
			if($bl[0]=='*' and substr($bl,-1)=='*'){ 
				if(strpos($_GET['id'], substr($bl,1,-1))!==false){
					$erlaubt = false;
					break;
				}
			}
			elseif(substr($bl,-1)=='*'){
				if(substr($_GET['id'], 0, strlen($bl)-1) == substr($bl, 0, -1)){
					$erlaubt = false;
					break;
				}
			}
			else{
				if($_GET['id'] == $bl){
					$erlaubt = false;
					break;
				}	
			}
		}
		if(!$erlaubt){
			unset($_rechtegruppen[$id]);	
		}
	}
	$_tmpl->assign('_rechtegruppen', $_rechtegruppen);

	if(!isset($_POST['speichern'])){
		if($_dbid=='t_hauptvereinabgleich' and TKSWIM_VEREINSID=='6408'){
			$_dbid .= '--'; # verhindert dass das Recht bearbeitet werden kann wenn Verein != TSV Stein
		}
		$query = "SELECT id, sort, bezeichnung FROM ".DB_PREFIX."rechte WHERE id = '".$_dbid."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){
			$_tmpl->assign('fehler','Das Recht existiert nicht.');
			break;
		}
		$daten = $_db->holeZeile();
		$query = "SELECT rechtegrid FROM ".DB_PREFIX."rechtegruppen_rechte WHERE rechteid = '".$_dbid."'";
		$_db->holeDaten($query);
		$daten['_rechtegruppen'] = $_db->baueArray('rechtegrid','#');
	}
	else{
		if(isset($_POST['_rechtegruppen']) and is_array($_POST['_rechtegruppen'])){
			$loeschen = $anlegen = array();
			$query = "SELECT rechtegrid FROM ".DB_PREFIX."rechtegruppen_rechte WHERE rechteid = '".$_dbid."'";
			$_db->holeDaten($query);
			$vorhanden = $_db->baueArray('rechtegrid','#');
			foreach($_rechtegruppen as $rgr => $tmp){
				if(in_array($rgr, $_POST['_rechtegruppen']) and !in_array($rgr, $vorhanden)){
					$anlegen[] = $rgr;
				}										
				if(!in_array($rgr, $_POST['_rechtegruppen']) and in_array($rgr, $vorhanden)){
					$loeschen[] = $rgr;
				}
			}
			if(count($anlegen)>0 and substr($_GET['id'],0,1)!='_'){
				$query = "INSERT INTO ".DB_PREFIX."rechtegruppen_rechte (rechtegrid, rechteid) VALUES (".implode(", '".$_dbid."'), (", $anlegen).",'".$_dbid."')";
				$_db->fuehreQueryAus($query);
			}
			if(count($loeschen)>0){
				$query = "DELETE FROM ".DB_PREFIX."rechtegruppen_rechte WHERE rechtegrid IN (".implode(",",$loeschen).") AND rechteid = '".$_dbid."'";
				$_db->fuehreQueryAus($query);
			}
		}
		else{
			$query = "DELETE FROM ".DB_PREFIX."rechtegruppen_rechte WHERE rechteid = '".$_dbid."'";
			$_db->fuehreQueryAus($query);
		}
		weiterleiten('/admin/rechte'.TKSWIM_DATEIENDUNG,'Das Recht »'.text_format($_POST['bezeichnung'],'html').'« wurde geändert');
	
	}
	$_tmpl->assign('daten',$daten);	
	$_inh .= $_tmpl->fetch('admin/21.rechte-formular.inc.html');
	break;

default:
	$where = '';
	if(TKSWIM_VEREINSID != '6408'){
		$where = " AND r.id != 't_hauptvereinabgleich'";
	}
	$query = "SELECT r.id, r.sort, r.bezeichnung, count(rgr.rechteid) AS anzahl, LEFT(r.id,2) as bereich
				FROM ".DB_PREFIX."rechte AS r LEFT JOIN ".DB_PREFIX."rechtegruppen_rechte AS rgr ON r.id = rgr.rechteid
				WHERE LEFT(r.id,1) != '_'".$where."
				GROUP BY r.id ORDER BY sort";
	$_db->holeDaten($query);
	$_tmpl->assign('ueberschrift','Rechteübersicht');
	$_bereiche = array(
		'm_' => 'Mitglieder',
		'a_' => 'Admin',
		'tr' => 'Training',
		'w_' => 'Wettkämpfe',
		'z_' => 'Zeiten',
		's_' => 'Sonstiges',
		'e_' => 'Export',
		't_' => 'Tools'
	);
	$_tmpl->assign('_bereiche',$_bereiche);
	$_tmpl->assign('rechte',$_db->baueArray('*', 'id'));
	$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
	$_tmpl->tk_javascriptzuweisen('onready', "\$('.bereinigen').tkswim_loeschfrage({frage:'Sollen wirklich alle Verknüpfungen zu Rechtegruppen gelöscht werden?',ajax:false});");
	$_inh .= $_tmpl->fetch('admin/21.rechte-uebersicht.inc.html');
	break;
}
} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
