<?php
require_once('../__inc/_start.inc.php');
$_seite = 6;
$erlaubt = pruefeRechte('s_kalender_anzeigen','s_dateien');
$_tmpl->assign('ueberschrift','Sonstiges');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{

# Termine holen
$termine = array();
$query = "SELECT id, DATE_FORMAT(datum,'%W, %e. %M %Y') as dat, TIME_FORMAT(datum,'%H:%i') as zeit, titel
			FROM ".DB_PREFIX."termine
			WHERE datum BETWEEN DATE_SUB(NOW(), INTERVAL 1 DAY) AND DATE_ADD(NOW(), INTERVAL 8 MONTH)
			ORDER BY datum ASC";
$_db->holeDaten($query);
$termine['zukunft'] = $_db->baueArray('*','id');

$query = "SELECT id, DATE_FORMAT(datum,'%W, %e. %M %Y') as dat, TIME_FORMAT(datum,'%H:%i') as zeit, titel
			FROM ".DB_PREFIX."termine
			WHERE datum BETWEEN DATE_SUB(NOW(), INTERVAL 4 MONTH) AND DATE_SUB(NOW(), INTERVAL 1 DAY)
			ORDER BY datum DESC";
$_db->holeDaten($query);
$termine['vergangenheit'] = $_db->baueArray('*','id');

# Dateien holen
$query = "SELECT v.rechte as vrechte, d.id, DATE_FORMAT(letzteaenderung,'%d.%m.%Y, %H:%i') as datum,
			  d.userid, d.gruppenid, d.rechte, dateiname, typ, verzeichnisid, v.id as vid, d.typ,
			  IF(LOCATE('\n',beschreibung)=0,beschreibung,SUBSTRING(beschreibung, 1,LOCATE('\n',beschreibung)-2)) as titel
			FROM ".DB_PREFIX."dateien as d LEFT JOIN ".DB_PREFIX."verzeichnisse as v ON v.id=d.verzeichnisid
			ORDER BY letzteaenderung DESC";
$_db->holeDaten($query);
$dateientmp = $_db->baueArray('*','id');

require_once(PFAD_INCLUDE.'class/dateien.inc.php');
$dat = new dateien($_db,$_tmpl,true);
$dateien = array();
$i = 1;
foreach($dateientmp as $id => $row){
	$vrechte = $dat->ermittleRechte($row['vrechte'], $row['userid'], $row['gruppenid']);
	if($vrechte['r'] != 1 and !is_null($row['vid'])){
		continue;
	}
	$dateien[$id] = array(
		'vid' => $row['vid'],
		'id' => $row['id'],
		'datum' => $row['datum'],
		'dateiname' => $row['dateiname'],
		'typ' => $row['typ'],
		'titel' => $row['titel']
	);
	$tmp = $dat->holeVerzeichnisBaum($row['vid'],false);
	if($tmp == 'home'){
		$tmp = 'Homeverzeichnis';
		$dateien[$id]['vid'] = false;
	}
	elseif($tmp == 'root'){
		$tmp = 'Rootverzeichnis';
		$dateien[$id]['vid'] = false;
	}
	elseif(substr($tmp,0,4)=='root'){
		$tmp = substr($tmp,4);
	}
	$dateien[$id]['_vbaum'] = $tmp;
	$rechte = $dat->ermittleRechte($row['rechte'], $row['userid'], $row['gruppenid']);
	$dateien[$id]['_leserecht'] = $rechte['r']==1?true:false;
	$i++;
	if($i > 10){
		break;
	}
}

# Daten ausgeben
$_tmpl->assign('dateisymbole',$_einst['dateisystem']['dateisymbole']);
$_tmpl->assign('termine',$termine);
$_tmpl->assign('dateien',$dateien);
$_inh = $_tmpl->fetch('sonstiges/6.index.inc.html');
} # Ende des Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
?>