<?php
# Modul: sonstiges_hvabgl
require_once('../__inc/_start.inc.php');
$_seite = 96;
$erlaubt = prueferechte('t_hauptvereinabgleich') and TKSWIM_VEREINSID==6408;
$titel = 'Mitglieder mit Hauptverein abgleichen';
$_tmpl->assign('ueberschrift','Mitglieder mit Hauptverein abgleichen');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{

if(isset($_GET['anderedatei']) and isset($_SESSION['hauptvereinabgleich'])){
	unset($_SESSION['hauptvereinabgleich']);
	weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG);
}

if(isset($_GET['auswerten']) and isset($_SESSION['hauptvereinabgleich']['daten'])){
	$_SESSION['hauptvereinabgleich']['auswerten'] = true;
	weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG);
}

if(isset($_GET['zurueckzurkontrolle']) and isset($_SESSION['hauptvereinabgleich']['auswerten'])){
	unset($_SESSION['hauptvereinabgleich']['auswerten']);
	unset($_SESSION['hauptvereinabgleich']['auswertung']);
	weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG);
}

if(!isset($_SESSION['hauptvereinabgleich'])){ # Hochgeladene Datei auswählen
	$dateien = parse_ini_file(PFAD_INIDATEIEN.'dateien_tmp.ini');
	$anzeigen = array();
	foreach($dateien as $datei => $daten){
		if(substr($daten,-4) != '.csv'){
			continue;
		}
		list(,$userid,$dateiname) = explode('|',$daten);
		if($userid != $_SESSION['user']['id']){
			continue;
		}
		$anzeigen[$datei] = $dateiname;
	}
	if(isset($_POST['datei']) and in_array($_POST['datei'],array_keys($anzeigen))){
		$_SESSION['hauptvereinabgleich']['datei'] = $_POST['datei'];
		weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG);
	}
	$_tmpl->assign('dateien',$anzeigen);
	$_inh .= $_tmpl->fetch('tools/991.hauptvereinabgleich-index.inc.html');
}
elseif(!isset($_SESSION['hauptvereinabgleich']['auswerten'])){
	if(isset($_GET['dateineueinlesen']) and isset($_SESSION['hauptvereinabgleich']['daten'])){
		unset($_SESSION['hauptvereinabgleich']['daten']);
		weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG);
	}

	if(!isset($_SESSION['hauptvereinabgleich']['daten'])){ # Daten einlesen und aufdröseln
		$daten = array(0=>array());
		$fh = fopen(PFAD_TMP.$_SESSION['hauptvereinabgleich']['datei'],'r');
		while(($dat = fgetcsv($fh, 10000, ',')) !== false){
			if(strtolower($dat[0]) == 'anrede'){
				continue;
			}
			$dat = array_map('trim',$dat);
			if(substr($dat[3],0,2)=='D-'){
				$dat[3] = substr($dat[3],2);
			}
			$row = array(
				'mw'       => ($dat[0]=='Herrn'?'m':'w'),
				'vorname'  => '',
				'nachname' => '',
				'strasse'  => '',
				'hausnr'   => '',
				'plz'      => substr($dat[3],0,5),
				'ort'      => substr($dat[3],6),
				'gebdatum' => $dat[4],
				'vorwahl'  => '',
				'telefon'  => '',
				'schwimmabteilung' => (strpos($dat[6], '27')===false?0:1),
				'austritt' => ''
			);
			# Name aufdroeseln
			$pos = strpos($dat[1],' ');
			$row['vorname']  = substr($dat[1],$pos+1);
			$row['nachname'] = substr($dat[1],0,$pos);
			# Strasse/Hausnr aufdroeseln
			$hausnr = preg_match('~(.*?) ?([0-9].*)~',$dat[2],$match);
			if($hausnr == 0){
				$row['strasse'] = $dat[2];
			}
			else{
				$row['strasse'] = $match[1];
				$row['hausnr']  = str_replace(' ','',strtolower($match[2]));
			}
			$row['strasse'] = str_replace('str.','straße',$row['strasse']);
			$row['strasse'] = str_replace('Str.','Straße',$row['strasse']);
			# Austrittsdatum
			$dat[7] = str_replace(array(' ','-',':'),'',$dat[7]);
			if(!empty($dat)){
				$row['austritt'] = $dat[7];
			}
			# Telefon
			if(empty($dat[5])){
			}
			elseif(preg_match('~^[0-9]+$~',$dat[5])){
				$row['vorwahl'] = $_gleinst['seitenweit']['standardvorwahl'];
				$row['telefon'] = $dat[5];
				
			}
			else{
				preg_match('~.*?([0-9]+).*?([0-9]*)$~',$dat[5],$match);
				if(empty($match[2])){
					$row['vorwahl'] = $_gleinst['seitenweit']['standardvorwahl'];
					$row['telefon'] = $match[1];
				}
				else{
					$row['vorwahl'] = $match[1];
					$row['telefon'] = $match[2];
				}
			}
			$daten[] = $row;
		}
		fclose($fh);
		unset($daten[0]);
		$_SESSION['hauptvereinabgleich']['daten'] = $daten;
	}

	if(isset($_GET['bearbeiten']) and isset($_SESSION['hauptvereinabgleich']['daten'][$_GET['bearbeiten']])){
		if(!isset($_POST['speichern'])){
			$_tmpl->assign('mitgl',$_SESSION['hauptvereinabgleich']['daten'][$_GET['bearbeiten']]);
		}
		else{
			$dat = &$_SESSION['hauptvereinabgleich']['daten'][$_GET['bearbeiten']];
			$dat['nachname'] = $_POST['nachname'];
			$dat['vorname'] = $_POST['vorname'];
			$dat['gebdatum'] = $_POST['gebdatum'];
			$dat['strasse'] = $_POST['strasse'];
			$dat['hausnr'] = $_POST['hausnr'];
			$dat['plz'] = $_POST['plz'];
			$dat['ort'] = $_POST['ort'];
			$dat['vorwahl'] = $_POST['vorwahl'];
			$dat['telefon'] = $_POST['telefon'];
			$dat['schwimmabteilung'] = isset($_POST['schwimmabteilung'])?1:0;
			$dat['austritt'] = $_POST['austritt'];
			weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG,'Die Änderungen wurden gespeichert.');
		}
	}
	$_tmpl->assign('daten',$_SESSION['hauptvereinabgleich']['daten']);
	$_inh .= $_tmpl->fetch('tools/991.hauptvereinabgleich-kontrollieren.inc.html');
}
else{
	$keineauswertung = false;
	$query = "SELECT id, vorname, nachname, mw, DATE_FORMAT(gebdatum,'%d.%m.%Y') as gebdatum, strasse, hausnr, plz, ort, ausgetreten, eingetreten
				FROM ".DB_PREFIX."mitglieder ORDER BY nachname, vorname";
	$_db->holeDaten($query);
	$schwimmabteilung = array();
	foreach($_db->ergebnis['daten'] as $row){
		$schwimmabteilung[$row['id']] = $row;
	}
	$hauptverein = $_SESSION['hauptvereinabgleich']['daten'];

	if(isset($_GET['ergebnisse']) and isset($_SESSION['hauptvereinabgleich']['ergebnisse'])){
		if(count($_SESSION['hauptvereinabgleich']['ergebnisse']['namenskorrekturen']) < 1){
			weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG,'Es sind keine Namensänderungen vorhanden');
		}
		require_once(PFAD_INCLUDE.'class/pdf.inc.php');
		$pdf = new tkpdf;
		$pdf->tk_schriftgroesse = 10;
		$pdf->tkseitentitel('Korrekturen in der Hauptvereinsliste');
		$pdf->tkseitennummern();
		$pdf->tk_autor = $_SESSION['user']['realname'];
		$pdf->tk_titel = 'Korrekturen in der Hauptvereinsliste';
		$optionen = array(
			'fontSize' => $pdf->tk_schriftgroesse,
			'titelFontSize' => $pdf->tk_schriftgroesse,
			'xPos' => 80,
			'xOrientation' => 'right',
			'shaded' => 0,
			'showLines' => 2,
			'colGap' => 6,
			'rowGap' => 3,
			'maxWidth' => 750,
			'innerLineThickness' => 0.5,
			'outerLineThickness' => 1.5
		);
		$daten = array();
		foreach($_SESSION['hauptvereinabgleich']['ergebnisse']['namenskorrekturen'] as $hkey => $mid){
			$h = $hauptverein[$hkey];
			$s = $schwimmabteilung[$mid];
			$tmp = array(
				'falsch'  => $h['nachname'].', '.$h['vorname'].' ('.$h['mw'].', '.$h['gebdatum'].')',
				'richtig' => ''
			);
			$tmp['richtig'] .= ($h['nachname'] != $s['nachname'])?'<b>'.$s['nachname'].'</b>, ':$s['nachname'].', ';
			$tmp['richtig'] .= ($h['vorname'] != $s['vorname'])?'<b>'.$s['vorname'].'</b> (':$s['vorname'].' (';
			$tmp['richtig'] .= ($h['mw'] != $s['mw'])?'<b>'.$s['mw'].'</b>, ':$s['mw'].', ';
			$tmp['richtig'] .= ($h['gebdatum'] != $s['gebdatum'])?'<b>'.$s['gebdatum'].'</b>)':$s['gebdatum'].')';
			$daten[] = $tmp;
		}
		# sortieren
		$tmp = array();
		foreach($daten as $key => $value){
			$tmp[$key] = $value['falsch'];
		}
		asort($tmp);
		$datenalt = $daten;
		$daten = array();
		foreach($tmp as $key => $name){
			$daten[] = $datenalt[$key];
		}
		$y = $pdf->ezTable($daten,'','falsch geschriebene Namen',$optionen);
		# Schwimmer die im Hauptverein nicht als Schwimmer gemeldet sind
		/*
		$pdf->ezNewPage();
		$daten = array();
		foreach($_SESSION['hauptvereinabgleich']['auswertung']['nichtimhauptvereingemeldet'] as $skey => $dat){
			$daten[] = $dat;
		}
		$tmp = $daten;
		$daten = array();
		$anz = count($tmp);
		for($i1=0,$i2=floor($anz/2)+1;$i1<ceil($anz/2);$i1++,$i2++){
			if(!isset($tmp[$i2])){
				$tmp[$i2] = array('name'=>'','gebdatum'=>'','mw'=>'');
			}
			$daten[] = array(
				'name1' => $tmp[$i1]['name'],
				'gebdatum1' => $tmp[$i1]['gebdatum'],
				'mw1' => $tmp[$i1]['mw'],
				'name2' => $tmp[$i2]['name'],
				'gebdatum2' => $tmp[$i2]['gebdatum'],
				'mw2' => $tmp[$i2]['mw']
			);
		}
		$spalten = array('name1'=>'Name','gebdatum1'=>'Gebdatum','mw1'=>'mw','name2'=>'Name','gebdatum2'=>'Gebdatum','mw2'=>'mw');
		$y = $pdf->ezTable($daten,$spalten,'Schwimmer die nicht im Hauptverein als Schwimmer gemeldet sind',$optionen);
		*/
		# und raus damit
		$pdf->tkstream('aenderungen_'.date('m-Y').'.pdf');
	}

	if(isset($_GET['neuauswerten']) and isset($_SESSION['hauptvereinabgleich']['auswertung'])){
		unset($_SESSION['hauptvereinabgleich']['auswertung']);
		weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG);
	}

	if(isset($_GET['suchen']) and ($_GET['suchen']{0} == 'h' or $_GET['suchen']{0} == 'a')){
		$keineauswertung = true;
		if(!isset($_GET['id'])){
			require_once(PFAD_INCLUDE.'func/mitgliedwaehlen.inc.php');
			$_inh .= mitgliedwaehlen('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG, 'suchen='.$_GET['suchen']);
		}
		else{
			$key = ($_GET['suchen']{0}=='h')?'hauptverein_nichtschwimmen':'austretende';
			$_SESSION['hauptvereinabgleich']['auswertung'][$key][substr($_GET['suchen'],1)]['mid'] = $_GET['id'];
			weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG,'Das Mitglied wurde gespeichert');
		}
	}

	if(isset($_GET['suchen']) and $_GET['suchen']{0} == 's'){
		$keineauswertung = true;
		if(!isset($_GET['id'])){
			$daten = array();
			foreach($hauptverein as $hkey => $dat){
				$daten[$hkey] = $dat['nachname'].', '.$dat['vorname'].' ('.$dat['mw'].', '.$dat['gebdatum'].')';
			}
			$_tmpl->assign('hauptverein',$daten);
			$_inh .= $_tmpl->fetch('tools/991.hauptvereinabgleich-mitgliedinhauptvereinsuchen.inc.html');
		}
		else{
			$_SESSION['hauptvereinabgleich']['auswertung']['schwimmen_nichthauptverein'][substr($_GET['suchen'],1)]['mid'] = $_GET['id'];
			weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG,'Das Mitglied wurde gespeichert');
		}
	}

	if(isset($_GET['ignorieren'])){
		$zuweisung = array(
			'h' => 'hauptverein_nichtschwimmen',
			's' => 'schwimmen_nichthauptverein',
			'a' => 'austretende',
			'k' => 'adressenkollision'
		);
		$key = isset($zuweisung[$_GET['ignorieren']{0}])?$zuweisung[$_GET['ignorieren']{0}]:'-';
		if($key != '-'){
			unset($_SESSION['hauptvereinabgleich']['auswertung'][$key][substr($_GET['ignorieren'],1)]);
			weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG,'Das Mitglied wurde entfernt');
		}
	}

	if(isset($_GET['ausgetreten'])){
		$gespeicherte = parse_ini_file(PFAD_INIDATEIEN.'tools_ausgetretene.ini',true);
		$jahr = date('Y')-1;
		$mid = substr($_GET['ausgetreten'],1);
		if(isset($schwimmabteilung[$mid])){
			if(!isset($gespeicherte[$jahr])){
				$gespeicherte[$jahr] = array();
				ksort($gespeicherte);
			}
			$dat = $schwimmabteilung[$mid];
			$name = $dat['nachname'].', '.$dat['vorname'].' ('.$dat['mw'].', '.$dat['gebdatum'].')';
			$gespeicherte[$jahr][$mid] = $name;

			asort($gespeicherte[$jahr]);

			unset($_SESSION['hauptvereinabgleich']['auswertung']['schwimmen_nichthauptverein'][$mid]);
			require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
			schreibe_ini_datei(PFAD_INIDATEIEN.'tools_ausgetretene.ini',$gespeicherte,true);
			weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG,'Das Mitglied wurde vorgemerkt');
		}
	}

	if(isset($_GET['korrekt'])){
		switch($_GET['korrekt']{0}){
		case 's': # In Schwimmabteilung, aber nicht im Hautpverein
			$smid = substr($_GET['korrekt'],1);
			if(!isset($schwimmabteilung[$smid])){
				break;
			}
			$loesung = $_SESSION['hauptvereinabgleich']['auswertung']['schwimmen_nichthauptverein'][substr($_GET['korrekt'],1)];
			if(!isset($_SESSION['hauptvereinabgleich']['ergebnisse'])){
				$_SESSION['hauptvereinabgleich']['ergebnisse'] = array();
			}
			if(!isset($_SESSION['hauptvereinabgleich']['ergebnisse']['namenskorrekturen'])){
				$_SESSION['hauptvereinabgleich']['ergebnisse']['namenskorrekturen'] = array();
			}
			$_SESSION['hauptvereinabgleich']['ergebnisse']['namenskorrekturen'][$loesung['mid']] = $smid;
			unset($_SESSION['hauptvereinabgleich']['auswertung']['schwimmen_nichthauptverein'][$smid]);
			weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG,'Der Name wurde gespeichert');
		case 'h': # Im Hauptverein als Schwimmer, aber nicht in Schwimmabteilung
			$hmid = substr($_GET['korrekt'],1);
			if(!isset($hauptverein[$hmid])){
				break;

			}
			$loesung = $_SESSION['hauptvereinabgleich']['auswertung']['hauptverein_nichtschwimmen'][substr($_GET['korrekt'],1)];
			if(!isset($_SESSION['hauptvereinabgleich']['ergebnisse'])){
				$_SESSION['hauptvereinabgleich']['ergebnisse'] = array();
			}
			if(!isset($_SESSION['hauptvereinabgleich']['ergebnisse']['namenskorrekturen'])){
				$_SESSION['hauptvereinabgleich']['ergebnisse']['namenskorrekturen'] = array();
			}
			$_SESSION['hauptvereinabgleich']['ergebnisse']['namenskorrekturen'][$hmid] = $loesung['mid'];
			unset($_SESSION['hauptvereinabgleich']['auswertung']['hauptverein_nichtschwimmen'][$hmid]);
			weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG,'Der Name wurde gespeichert');
		case 'k': # Adresskollisionen
			$mid = substr($_GET['korrekt'],2);
			if(!isset($_SESSION['hauptvereinabgleich']['auswertung']['adressenkollision'][$mid])){
				break;
			}
			$daten = $_SESSION['hauptvereinabgleich']['auswertung']['adressenkollision'][$mid]['h'];
			if($_GET['korrekt']{1} == 'h'){ # Adresse des Hauptvereins ist korrekt
				$query = "UPDATE ".DB_PREFIX."mitglieder SET
							strasse = '".text_format($daten['strasse'],'db')."',
							hausnr = '".text_format($daten['hausnr'],'db')."',
							plz = '".text_format($daten['plz'],'db')."',
							ort = '".text_format($daten['ort'],'db')."'
							WHERE id = ".$mid."";
				$_db->fuehreQueryAus($query);
			}
			else{ # Adresse der Schwimmabteilung ist korrekt
				$alteadresse = $daten['strasse'].' '.$daten['hausnr'].'|'.$daten['plz'].' '.$daten['ort'];
				$query = "SELECT wert FROM ".DB_PREFIX."eigenschaften WHERE art = 'm' AND artid = ".$mid." AND eigenschaft = 'alteadresse'";
				$_db->holeDaten($query);
				if($_db->ergebnis['anzahl'] == 0){ # kein Datensatz vorhanden -> anlegen
					$query = "INSERT INTO ".DB_PREFIX."eigenschaften (art, artid, eigenschaft, wert)
								VALUES ('m', ".$mid.", 'alteadresse', '".text_format($alteadresse,'db')."')";
				}
				else{ # Datensatz vorhanden -> aendern
					$query = "UPDATE ".DB_PREFIX."eigenschaften SET wert = '".text_format($alteadresse,'db')."'
								WHERE art = 'm' AND artid = ".$mid." AND eigenschaft = 'alteadresse'";
				}
				$_db->fuehreQueryAus($query);
			}
			unset($_SESSION['hauptvereinabgleich']['auswertung']['adressenkollision'][substr($_GET['korrekt'],2)]);
			weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG,'Die Adresse wurde gespeichert');
		default:
			break;
		}
	}

	if(isset($_GET['aktion'])){
		switch($_GET['aktion']){
		case 'abweichendeadressenignorieren':
			$_SESSION['hauptvereinabgleich']['auswertung']['adressenkollision'] = array();
			weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG,'Die restlichen Adresskollisionen wurden entfernt.');
			break;

		case 'schwimmerinhauptvereinsuchen':
			$austr = &$_SESSION['hauptvereinabgleich']['auswertung']['schwimmen_nichthauptverein'];
			foreach($austr as $akey => $adat){
				$adaten = $schwimmabteilung[$akey];
				foreach($hauptverein as $skey => $sdaten){
					$ok = 0;
					if($sdaten['nachname'] == $adaten['nachname']){
						$ok++;
					}
					if($sdaten['vorname'] == $adaten['vorname']){
						$ok++;
					}
					if($sdaten['gebdatum'] == $adaten['gebdatum']){
						$ok++;
					}
					if($sdaten['mw'] == $adaten['mw']){
						$ok++;
					}
					if($ok == 3){
						$austr[$akey]['mid'] = $skey;
					}
				}
			}
			weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG,'Die gefundenen Mitglieder wurde gespeichert');

		case 'schwimmerinschwimmabteilungsuchen':
			$austr = &$_SESSION['hauptvereinabgleich']['auswertung']['hauptverein_nichtschwimmen'];
			foreach($austr as $akey => $adat){
				$adaten = $hauptverein[$akey];
				foreach($schwimmabteilung as $skey => $sdaten){
					$ok = 0;
					if($sdaten['nachname'] == $adaten['nachname']){
						$ok++;
					}
					if($sdaten['vorname'] == $adaten['vorname']){
						$ok++;
					}
					if($sdaten['gebdatum'] == $adaten['gebdatum']){
						$ok++;
					}
					if($sdaten['mw'] == $adaten['mw']){
						$ok++;
					}
					if($ok == 3){
						$austr[$akey]['mid'] = $skey;
					}
				}
			}
			weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG,'Die gefundenen Mitglieder wurde gespeichert');

		case 'austrittesuchen':
			$austr = &$_SESSION['hauptvereinabgleich']['auswertung']['austretende'];
			foreach($austr as $akey => $adat){
				$adaten = $hauptverein[$akey];
				foreach($schwimmabteilung as $skey => $sdaten){
					$ok = 0;
					if($sdaten['nachname'] == $adaten['nachname']){
						$ok++;
					}
					if($sdaten['vorname'] == $adaten['vorname']){
						$ok++;
					}
					if($sdaten['gebdatum'] == $adaten['gebdatum']){
						$ok++;
					}
					if($sdaten['mw'] == $adaten['mw']){
						$ok++;
					}
					if($ok == 4){
						$austr[$akey]['mid'] = $skey;
					}
				}
			}
			weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG,'Die gefundenen Mitglieder wurde gespeichert');

		case 'austrittevormerken':
			$gespeicherte = parse_ini_file(PFAD_INIDATEIEN.'tools_ausgetretene.ini',true);
			foreach($_SESSION['hauptvereinabgleich']['auswertung']['austretende'] as $key => $loesung){
				if(empty($loesung['mid'])){
					continue;
				}
				$mitgl = $schwimmabteilung[$loesung['mid']];
				$name = $mitgl['nachname'].', '.$mitgl['vorname'].' ('.$mitgl['mw'].', '.$mitgl['gebdatum'].')';
				if(!isset($gespeicherte[$loesung['jahr']])){
					$gespeicherte[$loesung['jahr']] = array();
					ksort($gespeicherte);
				}
				$gespeicherte[$loesung['jahr']][$loesung['mid']] = $name;
				asort($gespeicherte[$loesung['jahr']]);
				unset($_SESSION['hauptvereinabgleich']['auswertung']['austretende'][$key]);
			}
			require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
			schreibe_ini_datei(PFAD_INIDATEIEN.'tools_ausgetretene.ini',$gespeicherte,true);
			weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG,'Die austretenden Mitglieder wurden vorgemerkt');

		case 'langenamen':
			$query = "SELECT m.id, mw, vorname, nachname, DATE_FORMAT(gebdatum,'%d.%m.%Y') as gebdatum, e.wert
						FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."eigenschaften as e
						ON e.artid=m.id AND e.art='m' AND e.eigenschaft = 'langname'
						WHERE wert IS NOT NULL ORDER BY nachname, vorname";
			$_db->holeDaten($query);
			$schwimmabteilungl = array();
			foreach($_db->ergebnis['daten'] as $row){
				list($row['vornamel'],$row['nachnamel']) = explode('|',$row['wert']);
				unset($row['wert']);
				$schwimmabteilungl[$row['id']] = $row;
			}
			$h_ns = &$_SESSION['hauptvereinabgleich']['auswertung']['hauptverein_nichtschwimmen'];
			foreach($h_ns as $hkey => $hid){
				$hdaten = $_SESSION['hauptvereinabgleich']['daten'][$hkey];
				$gefunden = false;
				foreach($schwimmabteilungl as $skey => $sdaten){
					$ok = 0;
					if($hdaten['nachname'] == $sdaten['nachnamel']){
						$ok++;
					}
					if($hdaten['vorname'] == $sdaten['vornamel']){
						$ok++;
					}
					if($hdaten['gebdatum'] == $sdaten['gebdatum']){
						$ok++;
					}
					if($hdaten['mw'] == $sdaten['mw']){
						$ok++;
					}
					if($ok == 4){
						$gefunden = true;
						break;
					}
				}
				if($gefunden){
					unset($h_ns[$hkey]);
				}
			}

			$s_nh = &$_SESSION['hauptvereinabgleich']['auswertung']['schwimmen_nichthauptverein'];
			foreach($s_nh as $skey => $sid){
				if(!isset($schwimmabteilungl[$skey])){
					continue;
				}
				$sdaten = $schwimmabteilungl[$skey];
				$gefunden = false;
				foreach($hauptverein as $hkey => $hdaten){
					$ok = 0;
					if($sdaten['nachnamel'] == $hdaten['nachname']){
						$ok++;
					}
					if($sdaten['vornamel'] == $hdaten['vorname']){
						$ok++;
					}
					if($sdaten['gebdatum'] == $hdaten['gebdatum']){
						$ok++;
					}
					if($sdaten['mw'] == $hdaten['mw']){
						$ok++;
					}
					if($ok == 4){
						$gefunden = true;
						#break;
					}
				}
				if($gefunden){
					unset($s_nh[$skey]);
				}
			}
			weiterleiten('/tools/hauptvereinabgleich'.TKSWIM_DATEIENDUNG,'Die gefundenen Mitglieder wurden entfernt');
		default:
			break;
		}
	}

	if(!isset($_SESSION['hauptvereinabgleich']['auswertung'])){

		# Zuordung eindeutig zugeordneter Mitglieder speichern
		$zuordung_gefundene = array();

		# Personen finden die in der Liste des Hauptvereins als Schwimmer stehen, aber nicht in der
		#  Schwimmerdatenbank auftauchen
		$hauptverein_nichtschwimmen = array();
		foreach($hauptverein as $hkey => $hdaten){
			if($hdaten['schwimmabteilung'] != 1){
				continue;
			}
			$gefunden = false;
			foreach($schwimmabteilung as $skey => $sdaten){
				$ok = 0;
				if($hdaten['nachname'] == $sdaten['nachname']){
					$ok++;
				}
				if($hdaten['vorname'] == $sdaten['vorname']){
					$ok++;
				}
				if($hdaten['gebdatum'] == $sdaten['gebdatum']){
					$ok++;
				}
				if($hdaten['mw'] == $sdaten['mw']){
					$ok++;
				}
				if($ok == 4){
					$gefunden = true;
					break;
				}
			}
			if(!$gefunden){
				$hauptverein_nichtschwimmen[$hkey] = array();
			}
			else{
				$zuordung_gefundene[$skey] = $hkey;
			}
		}

		# Schwimmer suchen die Schwimmerdatenbank stehen, aber nicht in der Liste vom Hauptverein
		$schwimmen_nichthauptverein = array();
		foreach($schwimmabteilung as $skey => $sdaten){
			if(!is_null($sdaten['ausgetreten'])){
				continue;
			}
			$gefunden = false;
			foreach($hauptverein as $hkey => $hdaten){
				$ok = 0;
				if($hdaten['nachname'] == $sdaten['nachname']){
					$ok++;
				}
				if($hdaten['vorname'] == $sdaten['vorname']){
					$ok++;
				}
				if($hdaten['gebdatum'] == $sdaten['gebdatum']){
					$ok++;
				}
				if($hdaten['mw'] == $sdaten['mw']){
					$ok++;
				}
				if($ok == 4){
					$gefunden = true;
					break;
				}
			}
			if(!$gefunden){
				$schwimmen_nichthauptverein[$skey] = array();
			}
			else{
				$zuordung_gefundene[$skey] = $hkey;
			}
		}

		# Austretende Mitglieder
		$austretende = array();
		foreach($hauptverein as $hkey => $hdaten){
			#if($hdaten['schwimmabteilung'] != 1 or empty($hdaten['austritt'])){
			if(empty($hdaten['austritt'])){
				continue;
			}
			$austretende[$hkey] = array('jahr'=>substr($hdaten['austritt'],-4),'mid'=>'');
		}

		# Adressenvergleich
		$adressenkollision = array();
		foreach($zuordung_gefundene as $skey => $hkey){
			$hdat = $hauptverein[$hkey];
			$sdat = $schwimmabteilung[$skey];
			if($hdat['strasse'] != $sdat['strasse'] or $hdat['hausnr'] != $sdat['hausnr'] or
			$hdat['plz'] != $sdat['plz'] or $hdat['ort'] != $sdat['ort']){
				$adressenkollision[$sdat['id']] = array(
					'sid'  => $sdat['id'],
					'name' => $sdat['nachname'].', '.$sdat['vorname'],
					'gebdatum' => $sdat['gebdatum'],
					'mw'   => $sdat['mw'],
					'h'    => array(
						'strasse' => $hdat['strasse'],
						'hausnr'  => $hdat['hausnr'],
						'plz'     => $hdat['plz'],
						'ort'     => $hdat['ort']
					),
					's' => array(
						'strasse' => $sdat['strasse'],
						'hausnr'  => $sdat['hausnr'],
						'plz'     => $sdat['plz'],
						'ort'     => $sdat['ort']
					)
				);
			}
		}
		# Kollisionen sortieren
		$tmp = $adressenkollision;
		$adressenkollision = array();
		$kids = array_keys($tmp);
		foreach($schwimmabteilung as $mid => $foo){
			if(!in_array($mid,$kids)){
				continue;
			}
			$adressenkollision[$mid] = $tmp[$mid];
		}

		# Schwimmer die nicht im Hautpverein als Schwimmer gemeldet sind, suchen
		$nichtimhauptvereingemeldet = array();
		foreach($zuordung_gefundene as $skey => $hkey){
			$hdat = $hauptverein[$hkey];
			$sdat = $schwimmabteilung[$skey];
			if($hdat['schwimmabteilung'] != 1 and empty($sdat['ausgetreten'])){
				$nichtimhauptvereingemeldet[$sdat['id']] = array(
					'sid'  => $sdat['id'],
					'name' => $sdat['nachname'].', '.$sdat['vorname'],
					'gebdatum' => $sdat['gebdatum'],
					'mw'   => $sdat['mw']
				);
			}
		}

		# in Session speichern
		$_SESSION['hauptvereinabgleich']['auswertung'] = array(
			'hauptverein_nichtschwimmen' => $hauptverein_nichtschwimmen,
			'schwimmen_nichthauptverein' => $schwimmen_nichthauptverein,
			'austretende'                => $austretende,
			'adressenkollision'          => $adressenkollision,
			'nichtimhauptvereingemeldet' => $nichtimhauptvereingemeldet
		);
	}
	$_tmpl->assign('hauptverein',$hauptverein);
	$_tmpl->assign('schwimmabteilung',$schwimmabteilung);
	$_tmpl->assign('auswertung',$_SESSION['hauptvereinabgleich']['auswertung']);
	if(!$keineauswertung){
		$_inh .= $_tmpl->fetch('tools/991.hauptvereinabgleich-auswertung.inc.html');
	}
}

} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
?>
