<?php
require_once('../__inc/_start.inc.php');
$_seite = 31;
$erlaubt = pruefeRechte('tr_gruppen_anzeigen');
$_tmpl->assign('ueberschrift','Gruppen');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{
$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
$_tmpl->assign('wochentage',$_wochentage);

$_trainingsorte_arten = array(
	'wa' => 'Wassertraining',
	'tr' => 'Trockentraining'
);

switch($_GET['aktion']){
case 'trainingsorte':
	$_tmpl->assign('ueberschrift','Trainingsorte');
	$_tmpl->assign('_arten', $_trainingsorte_arten);
	if(!pruefeRechte('tr_trainingsorte_anzeigen')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(isset($_GET['id']) and (ctype_digit($_GET['id']) or $_GET['id'] == 'neu') and pruefeRechte('tr_trainingsorte_bearbeiten')){
		$_bearbeiten = $_GET['id']!='neu';
		if($_bearbeiten){
			$query = "SELECT o.id, o.bezeichnung, o.art, 
						  (SELECT COUNT(*) FROM ".DB_PREFIX."trainingszeiten as z WHERE z.trainingsortid = o.id) as einheiten
						FROM ".DB_PREFIX."trainingsorte as o WHERE id = ".$_GET['id'];
			$_db->holeDaten($query);
			$daten = $_db->holeZeile();
		}
		else{
			$daten = array('art' => 'wa');
		}
		if(isset($_POST['speichern'])){
			if($_bearbeiten and isset($_POST['trainingsortloeschen']) and $daten['einheiten'] == 0){
				$query = "DELETE FROM ".DB_PREFIX."trainingsorte WHERE id = ".$_GET['id'];
				$_db->fuehreQueryAus($query);
				weiterleiten('/training/gruppen'.TKSWIM_DATEIENDUNG.'?aktion=trainingsorte', 'Der Trainingsort wurde gelöscht');
			}
			require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
			$f = '';
			$f .= pruefen($_POST['bezeichnung'], 'leer', 'Die Bezeichnung fehlt');
			$f .= pruefen($_POST['bezeichnung'], 'maxlaenge', 'Die Bezeichnung ist zu lang (max 50 Zeichen)', 50);
			$f .= pruefen($_POST['art'], 'leer', 'Die Art fehlt');
			$f .= pruefen($_POST['art'], 'wertemenge', 'Die Art ist ungültig', array_keys($_trainingsorte_arten));
			if(!empty($f)){
				$_tmpl->assign('fehler', $f);
				$daten = $_POST;
			}
			else{
				if($_bearbeiten){
					$query = "UPDATE ".DB_PREFIX."trainingsorte SET bezeichnung = '".text_format($_POST['bezeichnung'],'db')."', art = '".$_POST['art']."'
								WHERE id = ".$_GET['id'];
				}
				else{
					$query = "INSERT INTO ".DB_PREFIX."trainingsorte (bezeichnung, art) VALUES ('".text_format($_POST['bezeichnung'],'db')."', '".$_POST['art']."')";
				}
				$_db->fuehreQueryAus($query);
				weiterleiten('/training/gruppen'.TKSWIM_DATEIENDUNG.'?aktion=trainingsorte', 'Der Trainingsort wurde '.($_bearbeiten?'geändert':'angelegt'));
			}
		}
		$_tmpl->assign('daten', $daten);
		$_inh = $_tmpl->fetch('training/31.trainingsorte-formular.inc.html');
		break;
	}
	$query = "SELECT o.id, o.bezeichnung, o.art, (SELECT COUNT(*) FROM ".DB_PREFIX."trainingszeiten as z WHERE z.trainingsortid = o.id) as einheiten
				FROM ".DB_PREFIX."trainingsorte as o
				ORDER BY sort, o.art DESC, o.bezeichnung";
	$_db->holeDaten($query);
	$trainingsorte = $_db->baueArray('*','id');
	$_tmpl->assign('trainingsorte', $trainingsorte);
	if(pruefeRechte('tr_trainingsorte_bearbeiten')){
		$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
		$_tmpl->tk_javascriptzuweisen('onready', "$('.sortierbar').tkswim_sortieren('trainingsorte');");
	}
	$_inh .= $_tmpl->fetch('training/31.trainingsorte-uebersicht.inc.html');
	break;
	
case 'tags':
	$_tmpl->assign('ueberschrift','Tags');
	if(isset($_GET['id']) and (ctype_digit($_GET['id']) or $_GET['id'] == 'neu') and pruefeRechte('tr_tags_bearbeiten')){
		$_bearbeiten = $_GET['id']!='neu';
		if($_bearbeiten){
			$query = "SELECT t.id, t.titel, (SELECT COUNT(*) FROM ".DB_PREFIX."gruppen_tags as gt WHERE gt.tagid = t.id) as gruppen							 
						FROM ".DB_PREFIX."tags as t WHERE id = ".$_GET['id'];
			$_db->holeDaten($query);
			$daten = $_db->holeZeile();
		}
		else{
			$daten = array();
		}
		if(isset($_POST['speichern'])){
			if($_bearbeiten and isset($_POST['tagloeschen']) and $daten['gruppen'] == 0){
				$query = "DELETE FROM ".DB_PREFIX."tags WHERE id = ".$_GET['id'];
				$_db->fuehreQueryAus($query);
				weiterleiten('/training/gruppen'.TKSWIM_DATEIENDUNG.'?aktion=tags', 'Der Tag wurde gelöscht');
			}
			require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
			$f = '';
			$f .= pruefen($_POST['titel'], 'leer', 'Der Titel fehlt');
			$f .= pruefen($_POST['titel'], 'maxlaenge', 'Der Titel ist zu lang (max 50 Zeichen)', 50);
			if(!empty($f)){
				$_tmpl->assign('fehler', $f);
				$daten = $_POST;
			}
			else{
				if($_bearbeiten){
					$query = "UPDATE ".DB_PREFIX."tags SET titel = '".text_format($_POST['titel'],'db')."'
								WHERE id = ".$_GET['id'];
				}
				else{			
					$query = "UPDATE ".DB_PREFIX."tags SET sort = sort+1";
					$_db->fuehreQueryAus($query);
					$query = "INSERT INTO ".DB_PREFIX."tags (titel, sort) VALUES ('".text_format($_POST['titel'],'db')."', 1)";
				}
				$_db->fuehreQueryAus($query);
				weiterleiten('/training/gruppen'.TKSWIM_DATEIENDUNG.'?aktion=tags', 'Der Tag wurde '.($_bearbeiten?'geändert':'angelegt'));
			}
		}
		$_tmpl->assign('daten', $daten);
		$_inh = $_tmpl->fetch('training/31.tags-formular.inc.html');
		break;
	}
	$query = "SELECT t.id, t.titel, (SELECT COUNT(*) FROM ".DB_PREFIX."gruppen_tags as gt WHERE gt.tagid = t.id) as gruppen
				FROM ".DB_PREFIX."tags as t ORDER BY sort";
	$_db->holeDaten($query);
	$tags = $_db->baueArray('*','id');
	$_tmpl->assign('tags', $tags);
	if(pruefeRechte('tr_tags_bearbeiten')){
		$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
		$_tmpl->tk_javascriptzuweisen('onready', "$('.sortierbar').tkswim_sortieren('tags');");
	}
	$_inh .= $_tmpl->fetch('training/31.tags-uebersicht.inc.html');
	break;

case 'anlegen':
	$_tmpl->assign('ueberschrift','Trainingsgruppe anlegen');
	if(!pruefeRechte('tr_gruppen_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(isset($_POST['speichern'])){
		require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
		$f = '';
		$f .= pruefen($_POST['bezeichnung'],'leer','Die Bezeichnung fehlt');
		$f .= pruefen($_POST['bezeichnung'],'maxlaenge','Die Bezeichnung ist zu lang (max 50 Zeichen)',50);
		$f .= pruefen($_POST['kurz'],'leer','Die Kurzbezeichnung fehlt',10);
		$f .= pruefen($_POST['kurz'],'maxlaenge','Die Kurzbezeichnung ist zu lang (max 10 Zeichen)',10);
		if(!empty($f)){
			$_tmpl->assign('fehler',$f);
			$_tmpl->assign('daten',$_POST);
		}
		else{
			$query = "UPDATE ".DB_PREFIX."gruppen SET sort = sort+1";
			$_db->fuehreQueryaus($query);
			$query = "INSERT INTO ".DB_PREFIX."gruppen SET
						bezeichnung = '".text_format(trim($_POST['bezeichnung']),'db')."',
						kurz = '".text_format(trim($_POST['kurz']),'db')."',
						sort = 1,
						wechselndetrainer = ".(isset($_POST['wechselndetrainer'])?1:0);
			$_db->fuehreQueryaus($query);
			weiterleiten('/training/gruppen'.TKSWIM_DATEIENDUNG,'Die Trainingsgruppe wurde angelegt');
		}
	}
	$_inh .= $_tmpl->fetch('training/31.gruppen-formular.inc.html');
	break;

case 'details':
	$_tmpl->assign('ueberschrift','Gruppendetails');
	if(!isset($_GET['id']) or !ctype_digit($_GET['id'])){
		break;
	}

	# Übungsleiter
	if(pruefeRechte('tr_uebungsleiter_anzeigen')){
		$query = "SELECT u.id, CONCAT(m.nachname,', ',m.vorname) as name 
					FROM ".DB_PREFIX."uebungsleiter as u LEFT JOIN ".DB_PREFIX."mitglieder as m ON u.id=m.id 
					ORDER BY name";
		$_db->holeDaten($query);
		$uebungsleiter = $_db->baueArray('name','id');
		$_tmpl->assign('uebungsleiter', $uebungsleiter);
	}
	# Tags
	$query = "SELECT id, titel FROM ".DB_PREFIX."tags ORDER BY sort, titel";
	$_db->holeDaten($query);
	$tags = $_db->baueArray('titel','id');
	$_tmpl->assign('tags', $tags);
	# Trainingsorte
	$query = "SELECT id, bezeichnung, art FROM ".DB_PREFIX."trainingsorte ORDER BY sort, art DESC, bezeichnung";
	$_db->holeDaten($query);
	$trainingsorte = $_db->baueArray('*','id');
	foreach($trainingsorte as $tid => $row){
		$trainingsorte[$tid] = $row['bezeichnung'].' ('.$_trainingsorte_arten[$row['art']].')';
	}
	$_tmpl->assign('trainingsorte', $trainingsorte);
	$_tmpl->assign('wochentage', $_wochentage);

	$query = "SELECT id, bezeichnung, kurz, wechselndetrainer FROM ".DB_PREFIX."gruppen WHERE id = ".$_GET['id'];
	$_db->holeDaten($query);
	if($_db->holeAnzahl() != 1){
		$_inh .= T_KEINDATENSATZ;
		break;
	}
	$daten = $_db->holeZeile();
	$query = "SELECT uebungsleiterid FROM ".DB_PREFIX."gruppen_uebungsleiter WHERE gruppenid = ".$_GET['id'];
	$_db->holeDaten($query);
	$daten['uebungsleiter'] = $_db->baueArray('uebungsleiterid', '#');
	$query = "SELECT tagid FROM ".DB_PREFIX."gruppen_tags WHERE gruppenid = ".$_GET['id'];
	$_db->holeDaten($query);
	$daten['tags'] = $_db->baueArray('tagid', '#');
	# Trainingszeiten
	$query = "SELECT TIME_FORMAT(von, '%H:%i') as anfang, TIME_FORMAT(bis, '%H:%i') as ende,
				  wochentag, trainingsortid, inferien, CONCAT_WS('_', gruppenid, von, wochentag) as id
				FROM ".DB_PREFIX."trainingszeiten WHERE gruppenid = ".$_GET['id']." ORDER BY wochentag, von";
	$_db->holeDaten($query);
	$daten['tz'] = $_db->baueArray('*', '#');	
	
	$_tmpl->assign('daten',$daten);
	$_inh .= $_tmpl->fetch('training/31.gruppen-detail.inc.html');
	break;

case 'aendern':
	$_tmpl->assign('ueberschrift','Gruppe ändern');
	if(!pruefeRechte('tr_gruppen_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(!isset($_GET['id']) or !ctype_digit($_GET['id'])){
		break;
	}

	# Übungsleiter
	if(pruefeRechte('tr_uebungsleiter_bearbeiten')){
		$query = "SELECT u.id, CONCAT(m.nachname,', ',m.vorname) as name 
					FROM ".DB_PREFIX."uebungsleiter as u LEFT JOIN ".DB_PREFIX."mitglieder as m ON u.id=m.id 
					ORDER BY name";
		$_db->holeDaten($query);
		$uebungsleiter = $_db->baueArray('name','id');
		$_tmpl->assign('uebungsleiter', $uebungsleiter);
	}
	# Tags
	$query = "SELECT id, titel FROM ".DB_PREFIX."tags ORDER BY sort, titel";
	$_db->holeDaten($query);
	$tags = $_db->baueArray('titel','id');
	$_tmpl->assign('tags', $tags);
	# Trainingsorte
	$query = "SELECT id, bezeichnung FROM ".DB_PREFIX."trainingsorte ORDER BY sort, art DESC, bezeichnung";
	$_db->holeDaten($query);
	$trainingsorte = $_db->baueArray('bezeichnung','id');
	$_tmpl->assign('trainingsorte', $trainingsorte);
	
	$_tmpl->assign('wochentage', $_wochentage);

	if(isset($_REQUEST['gruppeloeschen'])){
		if(!isset($_GET['sicher'])){
			$_tmpl->assign('frage','Soll die Trainingsgruppe wirklich gelöscht werden?');
			$_tmpl->assign('jaquery','gruppeloeschen=1');
			$_tmpl->assign('neinquery','aktion=aendern&amp;id='.$_GET['id']);
			$_tmpl->assign('url', '/training/gruppen'.TKSWIM_DATEIENDUNG);
			$_inh .= $_tmpl->fetch('tools/9902.loeschfrage.inc.html');
			break;
		}
		else{
			$query = "DELETE FROM ".DB_PREFIX."gruppen_uebungsleiter WHERE gruppenid = ".$_GET['id'];
			$_db->fuehreQueryAus($query);
			$query = "DELETE FROM ".DB_PREFIX."gruppen_wettkaempfe WHERE gruppenid = ".$_GET['id'];
			$_db->fuehreQueryAus($query);
			$query = "DELETE FROM ".DB_PREFIX."mitglieder_gruppen WHERE gruppenid = ".$_GET['id'];
			$_db->fuehreQueryAus($query);
			$query = "DELETE FROM ".DB_PREFIX."trainingszeiten WHERE gruppenid = ".$_GET['id'];
			$_db->fuehreQueryAus($query);
			$query = "DELETE FROM ".DB_PREFIX."gruppen_tags WHERE gruppenid = ".$_GET['id'];
			$_db->fuehreQueryAus($query);			
			$query = "DELETE FROM ".DB_PREFIX."gruppen WHERE id = ".$_GET['id'];
			$_db->fuehreQueryAus($query);
			require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
			mitglieder_rechtegruppensetzen($_GET['id']);
			weiterleiten('/training/gruppen'.TKSWIM_DATEIENDUNG,'Die Gruppe wurde gelöscht');
		}
	}

	if(isset($_POST['speichern'])){
		require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
		$f = '';
		$f .= pruefen($_POST['bezeichnung'],'leer','Die Bezeichnung fehlt');
		$f .= pruefen($_POST['bezeichnung'],'maxlaenge','Die Bezeichnung ist zu lang (max 50 Zeichen)',50);
		$f .= pruefen($_POST['kurz'],'leer','Die Kurzbezeichnung fehlt',10);
		$f .= pruefen($_POST['kurz'],'maxlaenge','Die Kurzbezeichnung ist zu lang (max 10 Zeichen)',10);
		if(isset($_POST['tz']) and is_array($_POST['tz'])){
			foreach($_POST['tz'] as $id => $row){
				if(empty($row['anfang'])){
					unset($_POST['tz'][$id]);
					continue; # Zeilen mit leeren Anfangswerten ignorieren
				}
				if(isset($row['loeschen'])){
					unset($_POST['tz'][$id]);
					continue; # Zeile soll gelöscht werden
				}
				# restliche Zeilen prüfen
				$tz = ' der '.($id+1).'. Trainingszeit ';
				$f .=  pruefen($row['wochentag'], 'leer', 'Der Wochentag'.$tz.'fehlt');
				$f .=  pruefen($row['wochentag'], 'wertemenge', 'Der Wochentag'.$tz.'ist ungültig', array_keys($_wochentage));
				$f .=  pruefen($row['anfang'], 'uhrzeit', 'Die Anfangszeit'.$tz.'ist ungültig');
				$f .=  pruefen($row['ende'], 'leer', 'Die Endzeit'.$tz.'fehlt');
				$f .=  pruefen($row['ende'], 'uhrzeit', 'Die Endzeit'.$tz.'ist ungültig');
				$f .=  pruefen($row['trainingsortid'], 'leer', 'Der Trainingsort'.$tz.'fehlt');
				$f .=  pruefen($row['trainingsortid'], 'wertemenge', 'Der Trainingsort'.$tz.'ist ungültig', array_keys($trainingsorte));
				$_POST['tz'][$id] = $row;
			}
		}
		if(!empty($f)){
			$_tmpl->assign('fehler',$f);
			$daten = $_POST;
		}
		else{
			$query = "UPDATE ".DB_PREFIX."gruppen
						SET
						 bezeichnung = '".text_format(trim($_POST['bezeichnung']),'db')."',
						 kurz = '".text_format(trim($_POST['kurz']),'db')."',
						 wechselndetrainer = ".(isset($_POST['wechselndetrainer'])?1:0)." 
						WHERE id = ".$_GET['id'];
			$_db->fuehreQueryaus($query);
			
			# Trainingszeiten speichern
			$query = "DELETE FROM ".DB_PREFIX."trainingszeiten WHERE gruppenid = ".$_GET['id'];
			$_db->fuehreQueryAus($query);
			if(isset($_POST['tz']) and is_array($_POST['tz'])){
				foreach($_POST['tz'] as $row){
					$query = "INSERT INTO ".DB_PREFIX."trainingszeiten SET 
								  gruppenid = ".$_GET['id'].",
								  von = '".text_format($row['anfang'],'db').":00',
								  bis = '".text_format($row['ende'],'db').":00',
								  wochentag = ".$row['wochentag'].",
								  trainingsortid = ".$row['trainingsortid'].",
								  inferien = ".(isset($row['inferien'])?1:0);
					#echo $query.'<br>';
					$_db->fuehreQueryAus($query);
				}
			}
		
			
			# Tags speichern
			  # vorhandene holen
			$query = "SELECT tagid FROM ".DB_PREFIX."gruppen_tags 
						WHERE gruppenid = ".$_GET['id'];
			$_db->holeDaten($query);
			$vorhandene = $_db->baueArray('tagid', '#');
			  # neue holen
			if(isset($_POST['tags'])){
				$neue = $_POST['tags'];
				foreach($neue as $key => $id){
					if(array_key_exists($id, $tags)){
						continue;
					}
					unset($neue[$key]);						
				}
			}
			else{
				$neue = array();
			}
			  # Unterschiede ermitteln und ggf. speichern	
			$loeschen = array_diff($vorhandene, $neue);
			$setzen = array_diff($neue, $vorhandene);
			if(count($loeschen)>0){
				$query = "DELETE FROM ".DB_PREFIX."gruppen_tags 
							WHERE gruppenid = ".$_GET['id']." AND tagid IN (".implode(',',$loeschen).")";
				$_db->fuehreQueryaus($query);
			}
			if(count($setzen)>0){ 
				$query = "INSERT INTO ".DB_PREFIX."gruppen_tags (gruppenid, tagid)
							VALUES (".$_GET['id'].",".implode('),('.$_GET['id'].',', $setzen).")";
				$_db->fuehreQueryaus($query);
			}

			if(pruefeRechte('tr_uebungsleiter_bearbeiten')){
				# vorhandene holen
				$query = "SELECT uebungsleiterid FROM ".DB_PREFIX."gruppen_uebungsleiter 
							WHERE gruppenid = ".$_GET['id'];
				$_db->holeDaten($query);
				$vorhandene = $_db->baueArray('uebungsleiterid', '#');
				
				# neue holen
				if(isset($_POST['uebungsleiter'])){
					$neue = $_POST['uebungsleiter'];
					foreach($neue as $key => $id){
						if(array_key_exists($id, $uebungsleiter)){
							continue;
						}
						unset($neue[$key]);						
					}
				}
				else{
					$neue = array();
				}
				# Unterschiede ermitteln und ggf. speichern
				$loeschen = array_diff($vorhandene, $neue);
				$setzen = array_diff($neue, $vorhandene);
				$behandeln = $loeschen+$setzen;
				if(count($loeschen)>0){
					$query = "DELETE FROM ".DB_PREFIX."gruppen_uebungsleiter 
								WHERE gruppenid = ".$_GET['id']." AND uebungsleiterid IN (".implode(',',$loeschen).")";
					$_db->fuehreQueryaus($query);
				}
				if(count($setzen)>0){ 
					$query = "INSERT INTO ".DB_PREFIX."gruppen_uebungsleiter (gruppenid, uebungsleiterid)
								VALUES (".$_GET['id'].",".implode('),('.$_GET['id'].',', $setzen).")";
					$_db->fuehreQueryaus($query);
				}
				# bei den Mitgliedern bei denen sich was geändert hat Funktion zum Setzten der Rechtegruppen aufrufen
				if(count($behandeln)>0){
					$query = "SELECT id FROM ".DB_PREFIX."uebungsleiter WHERE id IN (".implode(', ', $behandeln).")";
					$_db->holeDaten($query);
					$mids = $_db->baueArray('id','#');
					require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
					foreach($mids as $id){
						mitglieder_rechtegruppensetzen($id);
					}
				}					
			}
			weiterleiten('/training/gruppen'.TKSWIM_DATEIENDUNG,'Die Gruppe wurde geändert');
		}
	}
	else {
		$query = "SELECT id, bezeichnung, kurz, wechselndetrainer FROM ".DB_PREFIX."gruppen WHERE id = ".$_GET['id'];
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){
			$_inh .= T_KEINDATENSATZ;
			break;
		}
		$daten = $_db->holeZeile();
		$query = "SELECT uebungsleiterid FROM ".DB_PREFIX."gruppen_uebungsleiter WHERE gruppenid = ".$_GET['id'];
		$_db->holeDaten($query);
		$daten['uebungsleiter'] = $_db->baueArray('uebungsleiterid', '#');
		$query = "SELECT tagid FROM ".DB_PREFIX."gruppen_tags WHERE gruppenid = ".$_GET['id'];
		$_db->holeDaten($query);
		$daten['tags'] = $_db->baueArray('tagid', '#');
		# Trainingszeiten
		$query = "SELECT TIME_FORMAT(von, '%H:%i') as anfang, TIME_FORMAT(bis, '%H:%i') as ende,
					  wochentag, trainingsortid, inferien, CONCAT_WS('_', gruppenid, von, wochentag) as id
					FROM ".DB_PREFIX."trainingszeiten WHERE gruppenid = ".$_GET['id']." ORDER BY wochentag, von";
		$_db->holeDaten($query);
		$daten['tz'] = $_db->baueArray('*', '#');	
	}
	$_tmpl->assign('daten',$daten);
	$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
	$_tmpl->tk_javascriptzuweisen('inline', 'var naechstetrainingszeitid = '.count($daten['tz']).';');
	$_tmpl->tk_javascriptzuweisen('onready', "\$('#neuezeit').click(function(){
    var tr = $('#trainingszeiten tbody tr:last').clone();
    tr.find('td:last').html('');
    tr.find('select, input[type=text]').each(function(){
      var e = $(this);
      e.val('');
      e.attr('name','tz['+naechstetrainingszeitid+']['+e.attr('class')+']');
    });
    tr.appendTo('#trainingszeiten tbody');
    naechstetrainingszeitid++;
    return false;
  });");

	$_inh .= $_tmpl->fetch('training/31.gruppen-formular.inc.html');
	break;

default:
	$query = "SELECT g.id, bezeichnung, COUNT(DISTINCT mg.mitgliedid) as anz, 0 as eigenegruppe, sort, kurz
				FROM ".DB_PREFIX."gruppen as g LEFT JOIN ".DB_PREFIX."mitglieder_gruppen as mg ON g.id = mg.gruppenid
				GROUP BY g.id ORDER BY g.sort";
	$_db->holedaten($query);
	$gruppen = $_db->baueArray('*', 'id');

	# Übungsleiter holen
	$query = "SELECT tu.gruppenid, m.vorname, m.nachname, m.id as mid
				FROM (".DB_PREFIX."uebungsleiter as u LEFT JOIN ".DB_PREFIX."mitglieder as m ON u.id=m.id)
				LEFT JOIN ".DB_PREFIX."gruppen_uebungsleiter as tu ON u.id = tu.uebungsleiterid
				WHERE tu.gruppenid IS NOT NULL
				ORDER BY tu.gruppenid, IF(u.trainerbis IS NOT NULL,1,0) DESC, IF((YEAR(NOW())-YEAR(m.gebdatum)) > 18,1,0) DESC,
				m.vorname ASC, nachname ASC";
	$_db->holedaten($query);
	$uebungsleiter = $_db->baueArray('*', '#');
	# mehrfach vorkommende Vornamen ermitteln
	$vornamen = array();
	foreach($uebungsleiter as $row){
		if(!isset($vornamen[$row['vorname']])){
			$vornamen[$row['vorname']] = array();
		}
		$vornamen[$row['vorname']][$row['mid']] = $row['nachname'];
	}
	# einfach vorkommende entfernen
	foreach($vornamen as $v => $nachnamen){
		if(count($nachnamen)<2){
			unset($vornamen[$v]);
		}
	}
	# ermitteln auf wieviel Buchstaben der Nachname gekurzt werden kann
	$vorher = '';
	foreach($vornamen as $v => $nachnamen){
		asort($nachnamen);
		for($i=1;;$i++){
			$gleich = false;
			$maxlaenge = 0;
			foreach($nachnamen as $mid => $name){
				if(substr($name,0,$i) == $vorher){
					$gleich = true;
				}
				$maxlaenge = max($maxlaenge, strlen($name));
				$vorher = substr($name,0,$i);
			}
			if(!$gleich){break;}
			if($i==$maxlaenge)break;
		}
		# Namen kürzen
		foreach($nachnamen as $mid => $name){
			$nachnamen[$mid] = strlen($name)>$i?substr($name,0,$i).'.':$name;
		}
		$vornamen[$v] = $nachnamen;
	}
	# Übungsleiter den Gruppen zuordnen
	foreach($uebungsleiter as $row){
		if(!isset($gruppen[$row['gruppenid']]['uebungsleiter'])){
			$gruppen[$row['gruppenid']]['uebungsleiter'] = array();
		}
		if($row['mid'] == $_SESSION['user']['id']){
			$gruppen[$row['gruppenid']]['eigenegruppe'] = 1;
		}
		$tmp = $row['vorname'];
		if(isset($vornamen[$row['vorname']])){
			$tmp .= '&nbsp;'.$vornamen[$row['vorname']][$row['mid']];
		}
		$gruppen[$row['gruppenid']]['uebungsleiter'][] = $tmp;
	}
	# Übungsleiter zusammenbauen
	foreach($gruppen as $id => $row){
		if(!isset($row['uebungsleiter'])){
			continue;
		}
		$gruppen[$id]['uebungsleiter'] = implode(', ', $row['uebungsleiter']);
	}
	$_tmpl->assign('gruppen',$gruppen);
	if(pruefeRechte('tr_gruppen_bearbeiten')){
		$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
		$_tmpl->tk_javascriptzuweisen('onready', "$('.sortierbar').tkswim_sortieren('gruppen');");
	}
	$_inh .= $_tmpl->fetch('training/31.gruppen-uebersicht.inc.html');
	break;
}
} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
?>