<?php
require_once('../__inc/_start.inc.php');
$_seite = 31;
$erlaubt = pruefeRechte('tr_gruppen_mitglieder_anzeigen');
$_tmpl->assign('ueberschrift','Mitglieder in Trainingsgruppen');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{
$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
$_tmpl->assign('wochentage',$_wochentage);
switch($_GET['aktion']){
case 'hinzufuegen':
	if(!pruefeRechte('tr_gruppen_mitglieder_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(!isset($_GET['id'])){
		require_once(PFAD_INCLUDE.'func/mitgliedwaehlen.inc.php');
		$_inh .= mitgliedwaehlen('/training/mitglieder'.TKSWIM_DATEIENDUNG, 'aktion=hinzufuegen&amp;grid='.$_GET['grid']);
	}
	else{
		$query = "SELECT mitgliedid, gruppenid FROM ".DB_PREFIX."mitglieder_gruppen
					WHERE mitgliedid = ".$_GET['id']." AND gruppenid = ".$_GET['grid'];
		$_db->holeDaten($query);
		if($_db->holeAnzahl() == 0){
			$query = "INSERT INTO ".DB_PREFIX."mitglieder_gruppen SET mitgliedid = ".$_GET['id'].",
						gruppenid = ".$_GET['grid'];
			$_db->fuehreQueryAus($query);
			require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
			mitglieder_rechtegruppensetzen($_GET['id']);
			weiterleiten('/training/mitglieder'.TKSWIM_DATEIENDUNG.'?grid='.$_GET['grid'],'Das Mitglied wurde hinzugefügt');
		}
		else{
			weiterleiten('/training/mitglieder'.TKSWIM_DATEIENDUNG.'?grid='.$_GET['grid'],'Das Mitglied war bereits Mitglied in der Gruppe');
		}
	}
	break;

case 'loeschen':
	if(!pruefeRechte('tr_gruppen_mitglieder_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(!isset($_GET['sicher'])){
		$_tmpl->assign('frage','Soll das Mitglied wirklich aus der Gruppe entfernt werden?');
		$_tmpl->assign('query','grid='.$_GET['grid']);
		$_tmpl->assign('url', '/training/mitglieder'.TKSWIM_DATEIENDUNG);
		$_inh .= $_tmpl->fetch('tools/9902.loeschfrage.inc.html');
	}
	else{
		$query = "DELETE FROM ".DB_PREFIX."mitglieder_gruppen
					WHERE gruppenid = '".text_format($_GET['grid'],'db')."' AND mitgliedid = '".text_format($_GET['id'],'db')."'";
		$_db->fuehreQueryAus($query);
		require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
		mitglieder_rechtegruppensetzen($_GET['id']);
		weiterleiten('/training/mitglieder'.TKSWIM_DATEIENDUNG.'?grid='.$_GET['grid'],'Das Mitglied wurde aus der Gruppe gelöscht');
	}
	break;

case 'verschieben':
	if(!pruefeRechte('tr_gruppen_mitglieder_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	$_tmpl->assign('ueberschrift','Mitglied verschieben');
	if(isset($_POST['zielgruppe'])){
		require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
		$f = '';
		$f .= pruefen($_POST['zielgruppe'],'zahl','Die Zielgruppe ist ungültig');
		$f .= pruefen($_GET['grid'],'zahl','Die Ursprungsgruppe ist ungültig');
		$f .= pruefen($_GET['id'],'zahl','Das Mitglied wurde nicht gefunden');
		if(empty($f)){
			$query = "SELECT mitgliedid FROM ".DB_PREFIX."mitglieder_gruppen
						WHERE mitgliedid = ".$_GET['id']." AND gruppenid = ".$_POST['zielgruppe'];
			$_db->holeDaten($query);
			if($_db->holeAnzahl() != 0){
				$f .= 'Das Mitglied ist der gewählten Gruppe bereits zugeteilt.<br />';
			}
		}
		if(empty($f)){
			$query = "UPDATE ".DB_PREFIX."mitglieder_gruppen SET gruppenid = ".$_POST['zielgruppe']."
						WHERE gruppenid = ".$_GET['grid']." AND mitgliedid = ".$_GET['id']."";
			$_db->fuehreQueryAus($query);
			if(isset($_POST['gruppe']) and $_POST['gruppe'] == 'ziel'){
				$grid = $_POST['zielgruppe'];
			}
			else{
				$grid = $_GET['grid'];
			}
			weiterleiten('/training/mitglieder'.TKSWIM_DATEIENDUNG.'?grid='.$grid, 'Das Mitglied wurde verschoben');
		}
		else{
			$_tmpl->assign('fehler',$f);
		}
	}
	require_once(PFAD_INCLUDE.'func/holegruppen.inc.php');
	$_tmpl->assign('gruppen',holeGruppen());
	$_inh .= $_tmpl->fetch('training/31.mitglied-verschieben.inc.html');
	break;

default:
	if(!isset($_GET['grid']) or !ctype_digit($_GET['grid'])){
		weiterleiten('/training/gruppen'.TKSWIM_DATEIENDUNG);
	}

	if(isset($_POST['tag']) and $_SESSION['eingelogt']==1){
		$tag = false;
		if($_POST['tag'] == '0'){
			$tag = '0';
		}
		elseif(ctype_digit($_POST['tag'])){
			$query = "SELECT id FROM ".DB_PREFIX."tags WHERE id = '".text_format($_POST['tag'], 'db')."'";
			$_db->holeDaten($query);
			if($_db->holeAnzahl() == 1){
				$tag = $_db->holeWert();
			}
		}
		if($tag !== false){
			require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
			$datei = 'userconf_'.$_SESSION['user']['id'].'.ini';
			if(!file_exists(PFAD_INIDATEIEN.$datei)){
				copy(PFAD_INIDATEIEN.'userconf_default.ini', PFAD_INIDATEIEN.$datei);
				chmod(PFAD_INIDATEIEN.$datei, 0666);
				$_einst = parse_ini_file(PFAD_INIDATEIEN.$datei, true);
				$_einst['stundennachweis']['name'] = $_SESSION['user']['realname'];
			}
			$_einst['anwesenheitsliste']['standardgruppentag'] = $tag;
			schreibe_ini_datei(PFAD_INIDATEIEN.$datei, $_einst, true);
			weiterleiten('/training/mitglieder'.TKSWIM_DATEIENDUNG.'?grid='.$_GET['grid'], 'Der Tag wurde gespeichert');
		}
	}

	require_once(PFAD_INCLUDE.'func/holegruppen.inc.php');
	$gruppen = holeGruppen('mittag', $_einst['anwesenheitsliste']['standardgruppentag']);
	$_tmpl->assign('gruppen',$gruppen);
	if(!array_key_exists($_GET['grid'], $gruppen)){
		$query = "SELECT id, bezeichnung FROM ".DB_PREFIX."gruppen WHERE id = '".text_format($_GET['grid'],'db')."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){
			weiterleiten('/training/gruppen'.TKSWIM_DATEIENDUNG);
		}
		$bezeichnung = $_db->holeWert('bezeichnung');
	}
	else{
		$bezeichnung = $gruppen[$_GET['grid']];
	}
	$_tmpl->assign('bezeichnung', $bezeichnung);

	if(pruefeRechte('tr_gruppen_mitglieder_bearbeiten')){
		$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
		$_tmpl->tk_javascriptzuweisen('onready', "\$('#schwimmer tbody span').addClass('verschieben');");
		$_tmpl->tk_javascriptzuweisen('onready', "\$('.loeschen').tkswim_loeschfrage({art:'mitglied_gruppe',frage:'Soll das Mitglied%%% aus der Trainingsgruppe gelöscht werden?',tabellenid:'schwimmer',zusatzid:gruppe});");
		$_tmpl->tk_javascriptzuweisen('inline', "var gruppe = '".text_format($_GET['grid'],'js')."';");
	}
	$query = "SELECT id, titel FROM ".DB_PREFIX."tags ORDER BY sort";
	$_db->holeDaten($query);
	$tags = $_db->baueArray('titel', 'id');
	$tags = array('0'=>'<em>alle</em>')+$tags;
	$_tmpl->assign('tags', $tags);
	$_tmpl->assign('_einst', $_einst);
	
	$query = "SELECT CONCAT(nachname,', ',vorname) as name, YEAR(gebdatum) as jahrg, id
				FROM ".DB_PREFIX."mitglieder as t, ".DB_PREFIX."mitglieder_gruppen as tg
				WHERE tg.gruppenid = ".$_GET['grid']." AND t.id = tg.mitgliedid
				ORDER BY t.nachname, t.vorname";
	$_db->holeDaten($query);
	$_tmpl->assign('mitgl',$_db->baueArray('*','#'));
	$_tmpl->assign('anz',$_db->holeAnzahl());

	$_inh .= $_tmpl->fetch('training/31.mitglieder-gruppe.inc.html');

	break;
}
} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
?>