<?php
require_once('../__inc/_start.inc.php');
$_seite = 32;
$erlaubt = pruefeRechte('tr_uebungsleiter_anzeigen');
$_tmpl->assign('ueberschrift','Übungsleiter');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{
$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
$query = "SELECT id, bezeichnung FROM ".DB_PREFIX."gruppen ORDER BY sort";
$_db->holeDaten($query);
$trainingsgruppen = $_db->baueArray('bezeichnung', 'id');
$_tmpl->assign('trainingsgruppen',$trainingsgruppen);
switch($_GET['aktion']){
case 'loeschen':
	if(!pruefeRechte('tr_uebungsleiter_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(!ctype_digit($_GET['id'])){
		$_tmpl->assign('fehler','Die ID ist ungültig');
		break;
	}
	$query = "SELECT id FROM ".DB_PREFIX."uebungsleiter WHERE id = ".$_GET['id']."";
	$_db->holeDaten($query);
	if($_db->holeAnzahl() != 1){
		$_tmpl->assign('fehler','Der Übungsleiter existiert nicht');
		break;
	}
	else{
		$mid = $_db->holeWert();
	}
	$_tmpl->assign('ueberschrift','Übungsleiter löschen');
	if(!isset($_GET['sicher'])){
		$_tmpl->assign('frage','Soll der Übungsleiter wirklich gelöscht werden?');
		$_tmpl->assign('url', '/training/uebungsleiter'.TKSWIM_DATEIENDUNG);
		$_inh .= $_tmpl->fetch('tools/9902.loeschfrage.inc.html');
	}
	else{
		$query = "DELETE FROM ".DB_PREFIX."uebungsleiter WHERE id = ".$_GET['id'];
		$_db->fuehreQueryAus($query);
		$query = "DELETE FROM ".DB_PREFIX."gruppen_uebungsleiter WHERE uebungsleiterid = ".$_GET['id'];
		$_db->fuehreQueryAus($query);
		require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
		mitglieder_rechtegruppensetzen($mid);
		weiterleiten('/training/uebungsleiter'.TKSWIM_DATEIENDUNG, 'Der Übungsleiter wurde gelöscht');
	}
	break;

case 'aendern':
	if(!pruefeRechte('tr_uebungsleiter_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(!ctype_digit($_GET['id'])){
		$_tmpl->assign('fehler','Der Übungsleiter existiert nicht');
		break;
	}
	$query = "SELECT u.id as id, CONCAT(m.vorname,' ',m.nachname) as name, IF(trainerbis IS NULL,0,1) as trainer, u.trainerbis
				FROM ".DB_PREFIX."uebungsleiter as u LEFT JOIN ".DB_PREFIX."mitglieder as m ON u.id = m.id 
				WHERE u.id = '".text_format($_GET['id'],'db')."'";
	$_db->holeDaten($query);
	if($_db->holeAnzahl() != 1){
		$_inh .= T_KEINDATENSATZ;
		break;
	}
	$daten = $_db->holeZeile();
	if(!isset($_POST['speichern'])){
		$query = "SELECT t.id
					FROM ".DB_PREFIX."gruppen_uebungsleiter as tu LEFT JOIN ".DB_PREFIX."gruppen as t ON tu.gruppenid=t.id
					WHERE uebungsleiterid = ".$daten['id'];
		$_db->holeDaten($query);
		$daten['trainingsgruppe'] = $_db->baueArray('id','#');
		$_tmpl->assign('ueberschrift', 'Übungsleiter ändern');
		$_tmpl->assign('daten',$daten);
	}
	else{
		require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
		$f = '';
		if(isset($_POST['trainingsgruppe'])){
			foreach($_POST['trainingsgruppe'] as $id){
				$f .= pruefen($id,'zahl','Die Trainingsgruppe ist ungültig');
			}
		}
		if(isset($_POST['trainer'])){
			$tmp = '';
			$tmp .= pruefen($_POST['trainerbis'], 'leer', 'Die Gültigkeitsdauer der Trainerlizenz fehlt.');
			$tmp .= pruefen($_POST['trainerbis'], 'zahl', 'Die Gültigkeitsdauer der Trainerlizenz ist ungültig.');
			if(empty($tmp) and ($_POST['trainerbis'] < 1950 or $_POST['trainerbis'] > 2100)){
				$f .= 'Bei der Gültigkeit der Trainerlizenz muss ein gültiges Jahr angegeben werden.<br />';
			}
			else{
				$f .= $tmp;
			}
		}
		if(!empty($f)){
			$_tmpl->assign('fehler',$f);
			$_tmpl->assign('daten',$_POST);
		}
		else{
			$query = "UPDATE ".DB_PREFIX."uebungsleiter SET trainerbis = ".(isset($_POST['trainer'])?$_POST['trainerbis']:'NULL')."
						WHERE id = ".$_GET['id'];
			$_db->fuehreQueryAus($query);
			# Trainingsgruppen zuweisen
			# angegebene ermitteln
			if(!isset($_POST['trainingsgruppe'])){
				$zusetzen = array();
			}
			else{
				$zusetzen = $_POST['trainingsgruppe'];
			}
			# vorhandene holen
			$query = "SELECT gruppenid FROM ".DB_PREFIX."gruppen_uebungsleiter WHERE uebungsleiterid = ".$_GET['id'];
			$_db->holeDaten($query);
			$vorhandene = $_db->baueArray('gruppenid','#');
			# zu schreibende ermitteln
			$schreiben = array_diff($zusetzen, $vorhandene);
			$geaendert = false;
			if(count($schreiben)>0){
				$query = "INSERT INTO ".DB_PREFIX."gruppen_uebungsleiter (gruppenid,uebungsleiterid)
							VALUES (".implode(', '.$_GET['id'].'), (', $schreiben).", ".$_GET['id'].")";
				$_db->fuehreQueryAus($query);
				$geaendert = true;
			}
			# zu löschende ermitteln
			$loeschen = array_diff($vorhandene, $zusetzen);
			if(count($loeschen)>0){
				$query = "DELETE FROM ".DB_PREFIX."gruppen_uebungsleiter
							WHERE uebungsleiterid = ".$_GET['id']." AND gruppenid IN (".implode(', ', $loeschen).")";
				$_db->fuehreQueryAus($query);
				$geaendert = true;
			}
			if($geaendert){
				# Rechte des Mitgliedes neu setzen (um ggf. die Zuordung zur Übungsleiter-Rechtegruppe zu entfernen/hinzuzufügen)
				require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
				mitglieder_rechtegruppensetzen($daten['id']);
			}
			weiterleiten('/training/uebungsleiter'.TKSWIM_DATEIENDUNG, 'Der Übungsleiter »'.text_format($_POST['name'],'html').'« wurde geändert');
		}
	}
	
	$_tmpl->tk_javascriptzuweisen('dateien', 'jquery');
	$_tmpl->tk_javascriptzuweisen('onready', "document.forms[0].trainerbis.disabled = !document.forms[0].trainer.checked;");
	$_inh .= $_tmpl->fetch('training/32.uebungsleiter-formular.inc.html');
	break;

case 'anlegen':
	if(!pruefeRechte('tr_uebungsleiter_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	$_tmpl->assign('ueberschrift','Übungsleiter anlegen');
	if(!isset($_GET['id'])){
		require_once(PFAD_INCLUDE.'func/mitgliedwaehlen.inc.php');
		$_inh .= mitgliedwaehlen('/training/uebungsleiter'.TKSWIM_DATEIENDUNG, 'aktion=anlegen');
	}
	else{
		if(!isset($_POST['speichern'])){
			if(!ctype_digit($_GET['id'])){
				weiterleiten('/training/uebungsleiter'.TKSWIM_DATEIENDUNG.'?aktion=anlegen');
			}
			$query = "SELECT CONCAT(vorname,' ',nachname) as name, ausgetreten FROM ".DB_PREFIX."mitglieder WHERE id = ".$_GET['id'];
			$_db->holeDaten($query);
			$mitglied = $_db->holeZeile();
			$fehler = false;
			if($_db->holeAnzahl() != 1){
				$fehler = 'Es wurde kein Mitglied gefunden';
			}
			if(!is_null($mitglied['ausgetreten'])){
				$fehler = 'ausgetretene Mitglieder können nicht als Übungsleiter eingetragen werden.';
			}
			if($fehler === false){
				$query = "SELECT id FROM ".DB_PREFIX."uebungsleiter WHERE id = ".$_GET['id'];
				$_db->holeDaten($query);
				if($_db->holeAnzahl() > 0){
					$fehler = 'Das Mitglied ist bereits Übungsleiter.';
				}
			}
			
			if($fehler !== false){
				$_tmpl->assign('fehler', $fehler);
				require_once(PFAD_INCLUDE.'func/mitgliedwaehlen.inc.php');
				$_inh .= mitgliedwaehlen('/training/uebungsleiter'.TKSWIM_DATEIENDUNG, 'aktion=anlegen');
				break;
			}
			$_tmpl->assign('daten',$mitglied);
		}
		else{
			if(!ctype_digit($_GET['id'])){
				weiterleiten('/training/uebungsleiter'.TKSWIM_DATEIENDUNG.'?aktion=anlegen');
				break;
			}
			require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
			$f = '';
			if(isset($_POST['trainingsgruppe'])){
				foreach($_POST['trainingsgruppe'] as $id){
					$f .= pruefen($id,'zahl','Die Trainingsgruppe ist ungültig');
				}
			}
			if(isset($_POST['trainer'])){
				$tmp = '';
				$tmp .= pruefen($_POST['trainerbis'], 'leer', 'Die Gültigkeitsdauer der Trainerlizenz fehlt.');
				$tmp .= pruefen($_POST['trainerbis'], 'zahl', 'Die Gültigkeitsdauer der Trainerlizenz ist ungültig.');
				if(empty($tmp) and ($_POST['trainerbis'] < 1950 or $_POST['trainerbis'] > 2100)){
					$f .= 'Bei der Gültigkeit der Trainerlizenz muss ein gültiges Jahr angegeben werden.<br />';
				}
				else{
					$f .= $tmp;
				}
			}
			if(!empty($f)){
				$_tmpl->assign('fehler',$f);
				$_tmpl->assign('daten',$_POST);
			}

			else{
				$query = "INSERT INTO ".DB_PREFIX."uebungsleiter
							SET trainerbis = ".(isset($_POST['trainer'])?$_POST['trainerbis']:'NULL').", id = ".$_GET['id'];
				$_db->fuehreQueryAus($query);
				$uebungsleiterid = $_GET['id'];
				$werte = array();
				if(isset($_POST['trainingsgruppe'])){
					foreach($_POST['trainingsgruppe'] as $id){
						$werte[] = '('.$id.','.$uebungsleiterid.')';
					}
					$query = "INSERT INTO ".DB_PREFIX."gruppen_uebungsleiter (gruppenid,uebungsleiterid) VALUES ".implode(', ',$werte);
					$_db->fuehreQueryaus($query);
				}
				$text = 'Der Übungsleiter wurde angelegt';
				require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
				mitglieder_rechtegruppensetzen($_GET['id']);
				if(!isset($_POST['anschl']) OR (isset($_POST['anschl']) AND $_POST['anschl'] == 'uebers')){
					weiterleiten('/training/uebungsleiter'.TKSWIM_DATEIENDUNG, $text);
				}
				else{
					weiterleiten('/training/uebungsleiter'.TKSWIM_DATEIENDUNG.'?aktion=anlegen', $text);
				}
			}
		}
		$_inh .= $_tmpl->fetch('training/32.uebungsleiter-formular.inc.html');
	}
	break;

default:
	$query = "SELECT u.id as id, CONCAT(m.nachname,',&nbsp;',m.vorname) as name, email, trainerbis
				FROM ".DB_PREFIX."uebungsleiter as u, ".DB_PREFIX."mitglieder as m
				WHERE u.id = m.id ORDER BY m.nachname, m.vorname";
	$_db->holeDaten($query);
	$daten = array();
	$_dbergebnis = $_db->baueArray('*','#');
	foreach($_dbergebnis as $row){
		$query = "SELECT g.id, g.bezeichnung, g.kurz
					FROM ".DB_PREFIX."gruppen as g LEFT JOIN ".DB_PREFIX."gruppen_uebungsleiter as gu 
					  ON gu.gruppenid=g.id
					WHERE uebungsleiterid = ".$row['id']."
					ORDER BY sort";
		$_db->holeDaten($query);
		$tmp = array();
		$wochentag = 0;
		foreach($_db->baueArray('*','id') as $id => $row2){
			if(prueferechte('tr_gruppen_mitglieder_anzeigen')){
				$tmp[] = '<a href="'.ROOT.'/'.(TKSWIM_KURZLINKS?'g':'training/mitglieder'.TKSWIM_DATEIENDUNG.'?grid=').$id.'">'.$row2['kurz'].'</a>';
			}
			else{
				$tmp[] = $row2['kurz'];
			}
		}
		
		$daten[] = array(
			'id'      => $row['id'],
			'name'    => $row['name'],
			'email'   => $row['email'],
			'trainer' => is_null($row['trainerbis'])==1?'nein':'ja&nbsp;('.$row['trainerbis'].')',
			'trainingsgruppen' => implode(', ',$tmp)
		);
	}
	$_tmpl->assign('daten',$daten);
	$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
	$_tmpl->tk_javascriptzuweisen('onready', "\$('.loeschen').tkswim_loeschfrage({frage:'Soll der Übungsleiter%%% wirklich gelöscht werden?',ajax:false});");
	$_inh .= $_tmpl->fetch('training/32.uebungsleiter-uebersicht.inc.html');
	break;
}
} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
?>