<?php
# Modul: wkabwickeln_dms
/*
Wettkampfabwicklung, Aktion: dms_mannschaften
verwendete Templates:
 - 42.dms-mannschaften.inc.html
 - 42.dms-mannschaften-mitglieder.inc.html
*/
$bearbeiten = pruefeRechte('w_abwickeln_mitglhinzufuegen');

if($bearbeiten and isset($_POST['mannschaftanlegen'])){
	if(!isset($_wkeinst['dms'])){
		$_wkeinst['dms'] = array();
	}
	if(in_array($_POST['mannschaftanlegen'],array('m','w','x'))){
		$vorhanden = array_keys($_wkeinst['dms']);
		$nr = 0;
		foreach($vorhanden as $vorh){
			if(substr($vorh,0,1) != $_POST['mannschaftanlegen']){
				continue;
			}
			$tmpnr = substr($vorh,1);
			if($tmpnr > $nr){
				$nr = $tmpnr;
			}
		}
		$_wkeinst['dms'][$_POST['mannschaftanlegen'].($nr+1)] = '';
		require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
		ksort($_wkeinst['dms']);
		schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'],$_wkeinst,true);
		weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=dms_mannschaften','Es wurde eine '.$_geschlechter[$_POST['mannschaftanlegen']].'Mannschaft angelegt');
	}
}

$schreiben = false;
if($bearbeiten and isset($_POST['aktionen']['nachoben'])){
	$mannschaft = key($_POST['aktionen']['nachoben']);
	$nr = substr($mannschaft,1);
	if($nr > 1){
		$zielnr = $nr-1;
		$j = substr($mannschaft,0,1);
		$tmp = $_wkeinst['dms'][$j.$nr];
		$_wkeinst['dms'][$j.$nr] = $_wkeinst['dms'][$j.$zielnr];
		$_wkeinst['dms'][$j.$zielnr] = $tmp;
		$schreiben = true;
	}
}
if($bearbeiten and isset($_POST['aktionen']['nachunten'])){
	$mannschaft = key($_POST['aktionen']['nachunten']);
	$nr = substr($mannschaft,1);
	$j = substr($mannschaft,0,1);
	if(isset($_wkeinst['dms'][$j.($nr+1)])){
		$zielnr = $nr+1;
		$tmp = $_wkeinst['dms'][$j.$nr];
		$_wkeinst['dms'][$j.$nr] = $_wkeinst['dms'][$j.$zielnr];
		$_wkeinst['dms'][$j.$zielnr] = $tmp;
		$schreiben = true;
	}
}
if($bearbeiten and isset($_POST['aktionen']['loeschen'])){
	$mannschaft = key($_POST['aktionen']['loeschen']);
	$nr = substr($mannschaft,1);
	$mwx = substr($mannschaft,0,1);
	if(!isset($_wkeinst['dms'][$mwx.($nr+1)])){
		unset($_wkeinst['dms'][$mwx.($nr)]);
	}
	else{
		while(isset($_wkeinst['dms'][$mwx.($nr+1)])){
			$_wkeinst['dms'][$mwx.$nr] = $_wkeinst['dms'][$mwx.($nr+1)];
			unset($_wkeinst['dms'][$mwx.($nr+1)]);
			$nr++;
		}
	}
	$schreiben = true;
}
if($bearbeiten and isset($_POST['aktionen']['teilnehm'])){
	$mannschaft = key($_POST['aktionen']['teilnehm']);
	$mwx = $mannschaft[0];
	if(in_array($mwx,array('m','w','x'))){
		if(!isset($_POST['speichern'])){
			$weg = array();
			foreach($_wkeinst['dms'] as $key => $mansch){
				if($key == $mannschaft or $key[0] != $mwx or empty($mansch)){
					continue;
				}
				$weg = array_merge($weg,explode('|',$mansch));
			}
			$weg = array_unique($weg);
			sort($weg);
			$wegquery = '';
			if(count($weg) > 0){
				$wegquery = ' AND m.id NOT IN ('.implode(',',$weg).')';
			}
			$query = "SELECT DISTINCT m.id, nachname, vorname, YEAR(gebdatum) as jg, m.mw, dsvid, mt.mitgliedid, 
						  IF(e.art IS NULL,1,0) as wettkampfteilnahme
						FROM (".DB_PREFIX."mitglieder as m LEFT JOIN 
						  (".DB_PREFIX."mitglieder_gruppen as mt LEFT JOIN ".DB_PREFIX."trainingszeiten as tz ON mt.gruppenid=tz.gruppenid) ON m.id=mt.mitgliedid) 
						  LEFT JOIN ".DB_PREFIX."eigenschaften as e ON e.art='m' AND e.artid=m.id AND e.eigenschaft='keinewettkampfteilnahme'
						WHERE YEAR('".$_SESSION['wk_abwickeln']['wettkampfdatum']."')-YEAR(gebdatum) >= 10 AND 
						  mt.mitgliedid IS NOT NULL".$wegquery.($mwx!='x'?" AND m.mw = '".$mwx."'":'')."
						ORDER BY nachname, vorname";
			$_db->holeDaten($query);
			if($_db->holeAnzahl() < 1){
				if(empty($wegquery)){
					$fehler = 'Es sind keine Mitglieder vorhanden.';
				}
				else{
					$fehler = 'Es sind keine Mitglieder vorhanden da alle verfügbaren in anderen Mannschaften eingetragen sind.';
				}
				$_tmpl->assign('fehler', $fehler);
			}
			else{
				$_tmpl->assign('mannschaft',$mannschaft);
				$_tmpl->assign('vorhandene',$_db->baueArray('*','#'));
				$_tmpl->assign('gewaehlte',explode('|',$_wkeinst['dms'][$mannschaft]));
				$_inh .= $_tmpl->fetch('wettkaempfe/42.dms-mannschaften-mitglieder.inc.html');
			}
		}
		else{
			$schr = array();
			if(isset($_POST['mitglieder']) and count($_POST['mitglieder']) > 0){
				foreach($_POST['mitglieder'] as $m){
					if(ctype_digit($m)){
						$schr[] = $m;
					}
				}
			}
			$query = "SELECT id FROM ".DB_PREFIX."mitglieder WHERE id IN ('".implode("','",$schr)."')";
			$_db->holeDaten($query);
			$schr = $_db->baueArray('id','#');
			if(count($schr) > 0){
				$abgeschnitten = false;
				if(count($schr) > 11){
					$abgeschnitten = true;
					$tmp = $schr;
					$schr = array();
					for($i=0;$i<11;$i++){
						$schr[] = $tmp[$i];
					}
				}
				$_wkeinst['dms'][$mannschaft] = implode('|',$schr);
				if(count($schr) == 1){
					$_SESSION['hinweis'] = 'Für die Mannschaft wurde 1 Mitglied gemeldet.';
				}
				else{
					$text = 'Für die Mannschaft wurden '.count($schr).' Mitglieder gemeldet.';
					if($abgeschnitten){
						$text .= "\n".'Achtung: Da mehr als 11 Mitglieder angegeben waren, wurden nur die ersten 11 berücksichtigt!';
					}
					$_SESSION['hinweis'] = $text;
				}
			}
			else{
				if(!empty($_wkeinst['dms'][$mannschaft])){
					$_SESSION['hinweis'] = 'Die Meldungen für die Mannschaft wurden entfernt.';
				}
				$_wkeinst['dms'][$mannschaft] = '';
			}
			$schreiben = true;
		}
	}
}
elseif(isset($_wkeinst['dms'])){
	$mids = array();
	$mannschaften = array();
	foreach($_wkeinst['dms'] as $key => $mannschaft){
		$tmp = array();
		$tmp['mwx'] = substr($key,0,1);
		$tmp['mannschaftsnr'] = substr($key,1);
		$tmp['nachoben'] = $tmp['mannschaftsnr']!=1;
		$tmp['nachunten'] = isset($_wkeinst['dms'][$tmp['mwx'].($tmp['mannschaftsnr']+1)]);
		$tmp['_mitglieder'] = array();
		if(!empty($mannschaft)){
			$mitgl = explode('|',$mannschaft);
			$tmp['_mitglieder'] = $mitgl;
			$mids = array_merge($mids,$mitgl);
		}
		$mannschaften[$key] = $tmp;
	}
	if(count($mids) > 0){
		$query = "SELECT id, nachname, vorname, YEAR(gebdatum) as jg, dsvid FROM ".DB_PREFIX."mitglieder
					WHERE id IN (".implode(',',$mids).") ORDER BY nachname, vorname";
		$_db->holeDaten($query);
		$_tmpl->assign('mitglieder',$_db->baueArray('*', 'id'));
	}
	$_tmpl->assign('geschlechter', $_geschlechter);
	$_tmpl->assign('bearbeiten',$bearbeiten);
	$_tmpl->assign('mannschaften',$mannschaften);
	$_inh .= $_tmpl->fetch('wettkaempfe/42.dms-mannschaften.inc.html');
}
if($bearbeiten and $schreiben){
	ksort($_wkeinst['dms']);
	require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
	schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'],$_wkeinst,true);
	weiterleiten('/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=dms_mannschaften');
}
# EOF