<?php
/*
Wettkampfabwicklung, Aktion: kontrolllistegenerieren
verwendete Templates:
  - 42.abwickeln-kontrollliste.inc.html
*/
$fehler = false;

if(isset($_SESSION['wk_abwickeln']['pflichtzeiten']) and ($_SESSION['wk_abwickeln']['pflichtzeiten_rp']=='p' or $_SESSION['wk_abwickeln']['pflichtzeiten_o']==1)){
	$link = ROOT.'/wettkaempfe/abwickeln'.TKSWIM_DATEIENDUNG.'?aktion=einhaltung_pflichtzeit';
	if(!isset($_wkeinst['flags']['pflichtzeitengeprueft']) or $_wkeinst['flags']['pflichtzeitengeprueft'] == '0'){
		$fehlermeldung = 'Die Meldung muss erst auf die Einhaltung der Pflichtzeiten <a href="'.$link.'">überprüft</a> werden.';
		$fehler = true;
	}
	elseif($_wkeinst['flags']['pflichtzeitengeprueft'] == '-'){
		$fehlermeldung = 'Die momentane Meldung kann nicht abgeschickt werden, da Mitglieder gemeldet sind, die die Pflichtzeit nicht erfüllen bzw. ohne Zeit gemeldet sind, siehe <a href="'.$link.'">Prüfseite</a>.';
		$fehler = true;
	}
}

if(isset($_SESSION['wk_abwickeln']['pflichtzeiten']) and !$fehler){
	if(!isset($_wkeinst['flags']['pflichtzeitengeprueft']) or $_wkeinst['flags']['pflichtzeitengeprueft'] == '0'){
		$meldung = 'Die Meldung wurde noch nicht auf Einhaltung der Pflichtzeiten geprüft';
	}
	elseif($_wkeinst['flags']['pflichtzeitengeprueft'] == '-'){
		$meldung = 'In der momentanen Meldung sind Mitglieder gemeldet die Pflichtzeiten nicht erfüllen oder ohne Zeit gemeldet sind';
	}
	$_tmpl->assign('fehler', $meldung);
}


if($fehler){
	$_tmpl->assign('fehler', $fehlermeldung);
}
else{
$wkid = $_SESSION['wk_abwickeln']['id'];
if(isset($_wkeinst['flags']['ruecklaufzettel'])?$_wkeinst['flags']['ruecklaufzettel']=='+':$_gleinst['wettkaempfe_abwickeln']['ruecklaufzettel']=="1"){
	$query = "SELECT COUNT(*) as anz 
				FROM ".DB_PREFIX."meldungen_teilnehmer as mt LEFT JOIN ".DB_PREFIX."meldungen_starts as ms ON mt.id=ms.teilnehmerid
				WHERE wettkampfid = ".$wkid." AND ms.teilnahme = '0'";
	$_db->holeDaten($query);
	$_tmpl->assign('offenestarts', $_db->holeWert());
}
$kontrollliste = '';
# Kampfrichtermeldung
if(count($_wkeinst['kampfrichter']) > 0){
	# Abschnittid -> Abschnittnr
	$query = "SELECT id, nr FROM ".DB_PREFIX."abschnitte WHERE wettkampfid = ".$wkid."";
	$_db->holeDaten($query);
	$abschnids = $_db->baueArray('nr','id');
	# Kampfrichter
	$query = "SELECT k.id, CONCAT(nachname,', ',vorname) as name, gruppe
				FROM ".DB_PREFIX."kampfrichter as k, ".DB_PREFIX."mitglieder as m
				WHERE k.id = m.id AND k.id IN (".implode(',',array_keys($_wkeinst['kampfrichter'])).")
				ORDER BY m.nachname, m.vorname";
	$_db->holeDaten($query);
	$kampfr = array();
	foreach($_db->ergebnis['daten'] as $row){
		$kampfr[$row['id']] = $row;
	}
	# und zusammenbauen
	$kontrollliste = 'Kampfrichter:'."\n";
	foreach($_wkeinst['kampfrichter'] as $kariid => $kariabschn){
		if(!isset($kampfr[$kariid])){
			continue;
		}
		$tmp = explode(',',$kariabschn);
		$abschn = array();
		foreach($tmp as $t){
			$abschn[] = $abschnids[$t];
		}
		$kampfr[$kariid]['gruppe'] = $kampfr[$kariid]['gruppe'][2]==1?3:($kampfr[$kariid]['gruppe'][1]==1?2:1);
		$kontrollliste .= '  '.$kampfr[$kariid]['name'].' (KaRiGr: '.$kampfr[$kariid]['gruppe'].', Abschnitte: '.implode(',',$abschn).')'."\n";
	}
}

# Einzelmeldungen
$anzstarts = array('personen' => 0, 'einzeln' => 0, 'staffel' => 0);
$ruecklaufzettel = (isset($_wkeinst['flags']['ruecklaufzettel'])?$_wkeinst['flags']['ruecklaufzettel']=='+':$_gleinst['wettkaempfe_abwickeln']['ruecklaufzettel']==1);
$query = "SELECT CONCAT(m.nachname, ', ', m.vorname) as name, dsvid, UCASE(mw) as mw, YEAR(gebdatum) as jg, mt.id as meldungsid
			FROM ".DB_PREFIX."meldungen_teilnehmer as mt, ".DB_PREFIX."mitglieder as m
			WHERE wettkampfid = ".$wkid." AND m.id = mt.mid ".($ruecklaufzettel?"AND teilnahme = '+'":"")."
			ORDER BY m.nachname, m.vorname";
$_db->holeDaten($query);
if($_db->holeAnzahl() > 0){
	$kontrollliste .= "\nEinzelmeldungen:\n";
	$anzstarts['personen'] = $_db->ergebnis['anzahl'];
	$daten = $_db->ergebnis['daten'];
	foreach($daten as $m){
		$query = "SELECT wknr, ms.meldezeit as zeit, w.laenge, w.disziplin
					FROM ".DB_PREFIX."meldungen_starts as ms, ".DB_PREFIX."wks as w, ".DB_PREFIX."abschnitte as a
					WHERE ".($ruecklaufzettel?"teilnahme = '+' AND ":"")."teilnehmerid = ".$m['meldungsid']." 
					  AND ms.wkid = w.id AND a.id = w.abschnittid
					ORDER BY a.nr, w.wknr";
		$_db->holeDaten($query);
		if($_db->ergebnis['anzahl'] < 1){
			continue;
		}
		$anzstarts['einzeln'] += $_db->ergebnis['anzahl'];
		$wks = $_db->ergebnis['daten'];
		$tmp = '  '.$m['name'].' ('.$m['mw'].','.$m['jg'].''.(empty($m['dsvid'])?'':','.$m['dsvid']).'):';
		$kl = array();
		foreach($wks as $w){
			$kl[] = $w['laenge'].substr($_lagen[$w['disziplin']],0,1).'/WK'.$w['wknr'].' ('.(is_null($w['zeit'])?($_gleinst['wettkaempfe_abwickeln']['ohnemeldezeit']=='ohnezeit'?'00:00,00':'59:59,99'):text_format($w['zeit'],'schwimmzeit')).')';
		}
		if(count($kl) > 0){
			$maxbreite = 72;
			$laenge = strlen($tmp);
			$anz = count($kl);
			for($i=0;$i<$anz;$i++){
				if($laenge+strlen($kl[$i])+2 > $maxbreite){
					$tmp .= ($i!=0?',':'')."\n".'    '.$kl[$i];
					$laenge = strlen($kl[$i])+4;
				}
				else{
					$tmp .= ($i!=0?', ':' ').$kl[$i];
					$laenge += strlen($kl[$i])+2;
				}
			}
			$tmp .= "\n";
		}
		else{
			$tmp .= "keine Meldung\n";
		}
		$kontrollliste .= $tmp;
	}
}

# Staffeln
if(isset($_wkeinst['staffeln'])){
	foreach($_wkeinst['staffeln'] as $key => $staffel){
		if(substr($key,0,9) == 'staffeln_'){
			unset($_wkeinst['staffeln'][$key]);
		}
	}
	if(count($_wkeinst['staffeln']) > 0){
		$kontrollliste .= "\nStaffelmeldungen:\n";
		$query = "SELECT wknr, id, laenge, disziplin FROM ".DB_PREFIX."wks WHERE id IN (".implode(',', array_keys($_wkeinst['staffeln'])).")";
		$_db->holeDaten($query);
		$wkids = array();
		foreach($_db->ergebnis['daten'] as $row){
			$wkids[$row['id']] = $row;
		}
		$staffeln = array();
		foreach($_wkeinst['staffeln'] as $key => $staffel){
			$zeiten = explode(',', $staffel);
			$tmp = '  '.$wkids[$key]['laenge'].$_lagen[$wkids[$key]['disziplin']]{0}.'/WK'.$wkids[$key]['wknr'].': ';
			$klasse = 'foo';
			$staffeln = array();
			foreach($zeiten as $z){
				if(strpos($z,'-')!==false){
					list($z,$k) = explode('-',$z,2);
				}
				else{
					$k = '';
				}
				if($klasse != $k){
					$i = 1;
					$klasse = $k;
				}
				else{
					$i++;
				}
				$staffeln[] = 'Mannschaft '.$i.(!empty($k)?' ('.$k.')':'').': '.text_format($z, 'schwimmzeit');
			}
			$anzstarts['staffel'] += count($staffeln);
			if(count($staffeln) > 0){
				$maxbreite = 72;
				$laenge = strlen($tmp);
				$anz = count($staffeln);
				for($i=0;$i<$anz;$i++){
					if($laenge+strlen($staffeln[$i])+2 > $maxbreite){
						$tmp .= ($i!=0?',':'')."\n".'    '.$staffeln[$i];
						$laenge = strlen($staffeln[$i])+4;
					}
					else{
						$tmp .= ($i!=0?', ':'').$staffeln[$i];
						$laenge += strlen($staffeln[$i])+2;
					}
				}
				$tmp .= "\n";
			}
			else{
				$tmp .= "keine Meldung\n";
			}
			$kontrollliste .= $tmp;
		}
	}
}
$_tmpl->assign('kontrollliste', trim($kontrollliste));
# Meldegeld berechnen
$query = "SELECT meldegeld FROM ".DB_PREFIX."wettkaempfe WHERE id = ".$_SESSION['wk_abwickeln']['id']."";
$_db->holeDaten($query);
$meldegeld = $wk->parseMeldegeld($_db->holeWert(),'db','wkpreis_rechnen');
$query = "SELECT wknr, COUNT(*) as anz
			FROM ".DB_PREFIX."meldungen_starts as ms, ".DB_PREFIX."meldungen_teilnehmer as mt, ".DB_PREFIX."wks as w
			WHERE ms.teilnehmerid=mt.id AND ms.wkid=w.id AND wettkampfid = ".$_SESSION['wk_abwickeln']['id'].($ruecklaufzettel?" AND ms.teilnahme = '+'":"")."
			GROUP BY wknr ORDER BY wknr";
$_db->holeDaten($query);
$wkzahlen = $_db->baueArray('anz','wknr');
$preis = array('einzel'=>0,'staffel'=>0);
foreach($wkzahlen as $wknr => $zahl){
	if(in_array($wknr,array_keys($meldegeld['wks']))){
		$preis['einzel'] += $meldegeld['wks'][$wknr]*$zahl;
	}
	else{
		$preis['einzel'] += $meldegeld['einzel']*$zahl;
	}
}
$preis['staffel'] = $meldegeld['staffel']*$anzstarts['staffel'];
# Zusammenfassung ausgeben
$preis['summe'] = number_format($preis['einzel']+$preis['staffel'],2,',','');
$preis['einzel'] = number_format($preis['einzel'],2,',','');
$preis['staffel'] = number_format($preis['staffel'],2,',','');

$_tmpl->assign('anzstarts', $anzstarts);
$_tmpl->assign('preis', $preis);
$_tmpl->assign('stand', date('d.m.Y, H:i'));

$_inh .= $_tmpl->fetch('wettkaempfe/42.abwickeln-kontrollliste.inc.html');
} # Ende $fehler-else
# EOF
?>