<?php
function dateigroesse($size, $stellen = 1){
	if(!is_numeric($size)){
		$size = (int)$size;
	}
	$size = max(0, $size);

	$units = array( 'b', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB');
	$power = $size > 0 ? floor(log($size, 1024)) : 0;
	return number_format($size / pow(1024, $power), $stellen, ',', '.').' ' . $units[$power];
}
# EOF
