<?php
function schreibe_ini_datei($datei,$inhalt,$sections=true){
	if($datei !== false and TKSWIM_SCHREIBSCHUTZ and !(isset($_SESSION['adminlogin']) or strpos($_SERVER['SCRIPT_NAME'], '_cronjob.php')!==false)){
		trigger_error('[tkswim][func/schreibe_ini_datei] Die Daten konnten wegen aktivierem Schreibschutz nicht gespeichert werden.', E_USER_ERROR);
	}
	$zu = "\n"; # Zeilenumbruch
	$dateiinhalt = '';
	if($sections){
		# mit sections
		foreach($inhalt as $s => $sinh){
			$dateiinhalt .= $zu.'['.$s.']'.$zu;
			foreach($sinh as $key => $value){
				$dateiinhalt .= $key.'="'.$value.'"'.$zu;
			}
		}
	}
	else{
		# ohne sections
		foreach($inhalt as $key => $value){
			$dateiinhalt .= $key.'="'.$value.'"'.$zu;
		}
	}
	$dateiinhalt = trim($dateiinhalt);
	if($datei === false){
		return $dateiinhalt;
	}
	else{
		$fh = fopen($datei,'w');
		fwrite($fh,$dateiinhalt,strlen($dateiinhalt));
		fclose($fh);
		return true;
	}
}
