<?php
require_once('../__inc/_start.inc.php');
$_seite = 23;
$erlaubt = pruefeRechte('a_einstellungen_anzeigen');
$_tmpl->assign('ueberschrift','globale Einstellungen');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{

require_once(PFAD_INCLUDE.'conf/einstellungen-ini.php');
$_tmpl->assign('bodyid','einstellungen');
require_once(PFAD_INCLUDE.'class/einstellungen.inc.php');
$einst = new einstellungen('global');
$einst->db = &$_db;
#$einst->aktualisiereGlobalIniDatei();

$_tmpl->assign('daten',    $_einstellungen);
$_tmpl->assign('module',   $_einstellungen_module);

$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
switch($_GET['aktion']){
case 'aendern':
	if(!pruefeRechte('a_einstellungen_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}

	if(isset($_POST['speichern'])){
		$f = '';
		foreach($_einstellungen as $mid => $modul){
			if(!isset($_einstellungen[$mid]) or !is_array($modul)){
				#continue;
			}
			foreach($modul as $oid => $option){
				if(!isset($_einstellungen[$mid]) or !isset($_einstellungen[$mid][$oid])){
					#continue;
				}
				switch($_einstellungen[$mid][$oid]['art']){
				case 'bool':
					$_POST['werte'][$mid][$oid] = isset($_POST['werte'][$mid][$oid])?1:0;
					break;
				case 'text':
					if(preg_match('~^'.$_einstellungen[$mid][$oid]['form'].'$~', $_POST['werte'][$mid][$oid], $match) == 0){
						$f .= $_einstellungen[$mid][$oid]['fehler'].'<br />';
					}
					break;
				case 'select':
					if(!array_key_exists($_POST['werte'][$mid][$oid], $_einstellungen[$mid][$oid]['werte'])){
						$f .= $_einstellungen[$mid][$oid]['fehler'].'<br />';
					}
					break;
				}
			}
		}
		if(!empty($f)){
			$_tmpl->assign('fehler',$f);
			$_tmpl->assign('werte', $_POST['werte']);
		}
		else{
			$_werte = parse_ini_file($einst->globaldatei, true);
			foreach($_einstellungen as $mid => $modul){
				if(!isset($_POST['werte'][$mid])){
					continue;
				}
				foreach($modul as $oid => $option){
					if(isset($_POST['werte'][$mid][$oid])){
						$_werte[$mid][$oid] = $_POST['werte'][$mid][$oid];
					}
				}
			}
			require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
			schreibe_ini_datei($einst->globaldatei, $_werte, true);
			weiterleiten('/admin/einstellungen'.TKSWIM_DATEIENDUNG,'Die Einstellungen wurden gespeichert');
		}
	}
	else{
		$_werte = parse_ini_file($einst->globaldatei, true);
		if(count($_werte)<1){
			$_werte = array();
			foreach($_einstellungen as $mid => $modul){
				$_werte[$mid] = array();
				foreach($modul as $oid => $option){
					$_werte[$mid][$oid] = $option['standard'];
				}
			}
			$_SESSION['hinweis'] = 'Es sind noch keine Einstellungen gespeichert, die Standardeinstellungen wurden geladen.';
		}
		$_tmpl->assign('werte', $_werte);
	}
	$_inh .= $_tmpl->fetch('admin/23.einstellungen-formular.inc.html');
	break;

default:
	$_werte = parse_ini_file(PFAD_INCLUDE.'conf/einstellungen.ini', true);
	$anzeige = array();
	foreach($_einstellungen as $mid => $modul){
		if(!isset($anzeige[$mid])){
			$anzeige[$mid] = array(
				'id' => $mid,
				'titel' => $_einstellungen_module[$mid]['titel'],
				'beschreibung' => $_einstellungen_module[$mid]['beschreibung'],
				'_einstellungen' => array()
			);
		}
		foreach($modul as $oid => $option){
			$wert = '';
			switch($option['art']){
			case 'bool':
				$wert = $_werte[$mid][$oid]==1?'ja':'nein';
				break;
			case 'text':
				$von = array('<i>', '</i>', '<b>', '</b>');
				$nach1 = array('[i]', '[/i]', '[b]', '[/b]');
				$nach2 = array('<em>', '</em>', '<strong>', '</strong>');
				if(empty($_werte[$mid][$oid])){
					$wert = '<em>[leer]</em>';
				}
				else{
					$wert = str_replace($von, $nach1, $_werte[$mid][$oid]);
					$wert = text_format($wert, 'html');
					$wert = str_replace($nach1, $nach2, $wert);
				}
				break;
			case 'select':
				$wert = text_format($option['werte'][$_werte[$mid][$oid]], 'html');
				break;
			}
			$anzeige[$mid]['_einstellungen'][$oid] = array(
				'id' => $oid,
				'titel' => $option['titel'],
				'beschreibung' => $option['beschreibung'],
				'wert' => $wert
			);
		}
	}
	$_tmpl->assign('anzeige', $anzeige);
	$_inh .= $_tmpl->fetch('admin/23.einstellungen-anzeigen.inc.html');
	break;
}
} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
?>