<?php
require_once('./__inc/_start.inc.php');
$_seite = 0;
if(isset($_GET['changelog'])){
	$_tmpl->assign('ueberschrift','Changelog von tkswim');
	$pfad = './CHANGELOG';
	require_once(PFAD_INCLUDE.'func/parsechangelog.inc.php');
	if(isset($_GET['aeltere'])){
		$changelog = parseChangelog($pfad, false, date('Y-m-d', strtotime('-2 year', getlastmod())));
	}
	else{
		$changelog = parseChangelog($pfad, date('Y-m-d', strtotime('-2 year', getlastmod())));
	}
	$_tmpl->assign('changelog',$changelog);
	$_tmpl->assign('aeltere',isset($_GET['aeltere'])?1:0);
	$_inh .= $_tmpl->fetch('tmpl.0.index.inc.html');
}
elseif(isset($_GET['passwortvergessen']) and (!isset($_SESSION['eingelogt']) or $_SESSION['eingelogt']=='auto')){
	if(isset($_POST['name']) and !empty($_POST['name'])){
		$name = text_format($_POST['name'], 'db');
		$query = "SELECT m.id, l.anmeldename, m.email, m. vorname, m.nachname, m.mw
					FROM ".DB_PREFIX."logins as l LEFT JOIN ".DB_PREFIX."mitglieder as m ON l.id=m.id
					WHERE l.anmeldename = '".$name."' OR m.email = '".$name."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){
			$_tmpl->assign('fehler', 'Die Eingabe konnte nicht erkannt werden, bitte noch einmal versuchen');
			$_tmpl->assign('name', $_POST['name']);
		}
		else{
			$zeile = $_db->holeZeile();
			require_once(PFAD_INCLUDE.'func/generierepasswort.inc.php');
			$passwort_roh = generierePasswort(6);
			$passwort_db = password_hash($passwort_roh, PASSWORD_DEFAULT);
			$query = "INSERT INTO ".DB_PREFIX."eigenschaften (art, artid, eigenschaft, wert) 
						VALUES ('m', ".$zeile['id'].", 'tmppasswort', '".text_format($passwort_db, 'db')."')
						ON DUPLICATE KEY UPDATE wert = VALUES(wert)";
			$_db->fuehreQueryAus($query);
			$variablen = array('passwort' => $passwort_roh);
			if($_POST['name'] == $zeile['email']){
				$variablen['benutzername'] = $zeile['anmeldename'];
			}
			$_email = parse_ini_file(PFAD_INCLUDE.'conf/emails.ini',true);
			require_once(PFAD_INCLUDE.'class/mail.inc.php');
			$mail = new email;
			$mail->setzeBetreff($_email['betreff']['zugangsdaten'],false);
			$mail->setzeTextTemplate('sonstiges/0.mail-vergessenespasswort.inc.txt', $_tmpl, $zeile, $variablen);
			$mail->verschickeMail();
			weiterleiten('/?passwortvergessen', 'Das Passwort wurde per Mail verschickt');
		}
	}
	$_inh .= $_tmpl->fetch('sonstiges/0.passwortvergessen.inc.html');
}
elseif(isset($_SESSION['eingelogt']) and !isset($_SESSION['adminlogin'])){
	$trainingsgruppen = false;
	if(in_array(2, $_SESSION['user']['rechtegruppen'])){
		# Trainingsgruppen
		$query = "SELECT t.id, t.bezeichnung
					FROM ".DB_PREFIX."gruppen_uebungsleiter as tu LEFT JOIN ".DB_PREFIX."gruppen as t ON t.id=tu.gruppenid
					WHERE uebungsleiterid=".$_SESSION['user']['id']."
					ORDER BY sort";
		$_db->holeDaten($query);
		$trainingsgruppen = false;
		if($_db->holeAnzahl()){
			$trainingsgruppen = $_db->baueArray('bezeichnung', 'id');
		}
	}
	$_tmpl->assign('trainingsgruppen', $trainingsgruppen);

	if(pruefeRechte('tr_stundennachweis')){
		# aktueller Stundennachweis
		$stundennachweisurl = false;
		if($trainingsgruppen !== false){
			require_once(PFAD_INCLUDE.'class/stundennachweise.inc.php');
			$std = new stundennachweise();
			$aktuell = date('Y').'_'.(date('n')<7?1:2);
			if(isset($std->daten[$aktuell])){
				$stundennachweisurl = '/training/stundennachweis'.TKSWIM_DATEIENDUNG.'?aktion=bearbeiten&amp;id='.$aktuell;
			}
			else{
				$stundennachweisurl = '/training/stundennachweis'.TKSWIM_DATEIENDUNG.'?aktion=neu&amp;halbj='.$aktuell;
			}
		}
		$_tmpl->assign('stundennachweisurl', $stundennachweisurl);
	}

	if(pruefeRechte('s_kalender_anzeigen')){
		# die Termine des nächsten Monats
		$query = "SELECT id, DATE_FORMAT(datum,'%W, %e. %M %Y') as dat, TIME_FORMAT(datum,'%H:%i') as zeit, titel
					FROM ".DB_PREFIX."termine
					WHERE datum BETWEEN DATE_SUB(NOW(), INTERVAL 1 DAY) AND DATE_ADD(NOW(), INTERVAL 1 MONTH)
					ORDER BY datum ASC";
		$_db->holeDaten($query);
		$termine = $_db->baueArray('*','id');
		$_tmpl->assign('termine', $termine);
	}

	# abzuwickelnde Wettkaempfe
	$abzuwickelndewettkaempfe = false;
	if($_SESSION['flags']['abzuwickelndewettkaempfe']){
		require_once(PFAD_INCLUDE.'func/wettkaempfe_leseabzuwickelndeein.inc.php');
		wettkaempfe_leseAbzuwickelndeEin();
		$abzuwickelndewettkaempfe = $_SESSION['user']['wkabwickeln']['wettkaempfe'];
	}
	$_tmpl->assign('abzuwickelndewettkaempfe', $abzuwickelndewettkaempfe);

	# Hall-of-Fame-Links (es wird immer ein zufälliger aus den 4 50m- und 100m-Strecken und den 200L angezeigt)
	$hoflinks = array(
		'lage=1&laenge=50',  # 50F
		'lage=2&laenge=50',  # 50B
		'lage=3&laenge=50',  # 50R
		'lage=4&laenge=50',  # 50S
		'lage=1&laenge=100', # 100F
		'lage=2&laenge=100', # 100B
		'lage=3&laenge=100', # 100R
		'lage=4&laenge=100', # 100S
		'lage=5&laenge=200'  # 200L
	);
	$_tmpl->assign('halloffame', $hoflinks[array_rand($hoflinks)]);

	$_inh .= $_tmpl->fetch('tmpl.0.index.inc.html');
}
require_once('./__inc/_ende.inc.php');
# EOF
?>
