<?php
require_once('../__inc/_start.inc.php');
$_seite = 17;
$erlaubt = pruefeRechte('m_vorstand_anzeigen');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{
$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
switch($_GET['aktion']){
case 'mitgliedzuweisen':
	if(!pruefeRechte('m_vorstand_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(!ctype_digit($_GET['vid'])){
		$_tmpl->assign('fehler','die ID ist ungültig');
		break;
	}
	else{
		$query = "SELECT mitgliedid, bezeichnung FROM ".DB_PREFIX."vorstand WHERE id = '".text_format($_GET['vid'],'db')."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){
			$_tmpl->assign('fehler','Das Vorstandsamt existiert nicht.');
			break;
		}
		$_vorstand_alt = $_db->holeZeile();
		
	}
	$_tmpl->assign('ueberschrift','Vorstandsamt Mitglied zuweisen');
	if(!isset($_GET['id'])){
		require_once(PFAD_INCLUDE.'func/mitgliedwaehlen.inc.php');
		$_inh .= '<p><a href="'.ROOT.'/mitglieder/vorstand'.TKSWIM_DATEIENDUNG.'?id=-&amp;aktion=mitgliedzuweisen&amp;vid='.$_GET['vid'].'">Zuweisung löschen</a></p>';
		$_inh .= mitgliedwaehlen('/mitglieder/vorstand'.TKSWIM_DATEIENDUNG, 'aktion=mitgliedzuweisen&amp;vid='.$_GET['vid']);
	}
	else{
		$mw_switch = array(
			'Abteilungsleiter' => 'Abteilungsleiterin',
			'stellvertretender Abteilungsleiter' => 'stellvertretende Abteilungsleiterin',
			'sportlicher Leiter' => 'sportliche Leiterin',
			'Schriftführer' => 'Schriftführerin',
			'Kassier' => 'Kassiererin',
			'Jugendleiter' => 'Jugendleiterin',
			'stellvertretender Jugendleiter' => 'stellvertretende Jugendleiterin',
			'Jugendsprecher' => 'Jugendsprecherin'
		);
		require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');

		if($_GET['id'] == '-'){
			$bezeichnung = false;
			if(in_array($_vorstand_alt['bezeichnung'], $mw_switch)){
				$bezeichnung = array_search($_vorstand_alt['bezeichnung'], $mw_switch);
			}
			$query = "UPDATE ".DB_PREFIX."vorstand
						SET
						  ".($bezeichnung!==false?"bezeichnung = '".text_format($bezeichnung,'db')."',":'')."
						  mitgliedid = NULL
						WHERE id = '".$_GET['vid']."'";
		    $_db->fuehreQueryAus($query);
		    mitglieder_rechtegruppensetzen($_vorstand_alt['mitgliedid']);
		    weiterleiten('/mitglieder/vorstand'.TKSWIM_DATEIENDUNG,'Dem Vorstandsamt ist jetzt kein Mitglied mehr zugewiesen.');
		}
		else{
			$query = "SELECT id, mw FROM ".DB_PREFIX."mitglieder WHERE id = '".text_format($_GET['id'],'db')."'";
			$_db->holeDaten($query);
			if($_db->holeAnzahl() != 1){
				$_tmpl->assign('fehler','Das Mitglied existiert nicht.');
				require_once(PFAD_INCLUDE.'func/mitgliedwaehlen.inc.php');
				$_inh .= mitgliedwaehlen('/mitglieder/vorstand'.TKSWIM_DATEIENDUNG, 'aktion=mitgliedzuweisen&amp;vid='.$_GET['vid']);
			}
			else{
				$mitglied_neu = $_db->holeZeile();

				$bezeichnung = false;
				if($mitglied_neu['mw'] == 'w' and array_key_exists($_vorstand_alt['bezeichnung'], $mw_switch)){
					$bezeichnung = $mw_switch[$_vorstand_alt['bezeichnung']];
				}
				elseif($mitglied_neu['mw'] == 'm' and in_array($_vorstand_alt['bezeichnung'], $mw_switch)){
					$bezeichnung = array_search($_vorstand_alt['bezeichnung'], $mw_switch);
				}
				$query = "UPDATE ".DB_PREFIX."vorstand
							SET
							  ".($bezeichnung!==false?"bezeichnung = '".text_format($bezeichnung,'db')."',":'')."
							  mitgliedid = ".$mitglied_neu['id']."
							WHERE id = '".$_GET['vid']."'";
				$_db->fuehreQueryAus($query);
				mitglieder_rechtegruppensetzen($_vorstand_alt['mitgliedid']);
				mitglieder_rechtegruppensetzen($mitglied_neu['id']);
				weiterleiten('/mitglieder/vorstand'.TKSWIM_DATEIENDUNG,'Das Mitglied wurde dem Vorstandsamt zugewiesen');
			}
		}
	}
	break;
	
case 'aendern':
	if(!pruefeRechte('m_vorstand_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(!ctype_digit($_GET['id'])){
		$_tmpl->assign('fehler','die ID ist ungültig');
		break;
	}
	$_tmpl->assign('ueberschrift','Vorstandsamt ändern');
	if(!isset($_POST['speichern'])){
		$query = "SELECT v.id, v.bezeichnung, CONCAT(m.vorname,' ',m.nachname) as name
				FROM ".DB_PREFIX."vorstand as v LEFT JOIN ".DB_PREFIX."mitglieder as m ON v.mitgliedid=m.id
				WHERE v.id = '".text_format($_GET['id'],'db')."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){
			$_tmpl->assign('fehler','Dieses Amt existiert nicht.');
			break;
		}
		$_tmpl->assign('daten',$_db->holeZeile());
	}
	else{
		$f = '';
		require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
		$f .= pruefen($_POST['bezeichnung'],'leer','Die Bezeichnung darf nicht leer sein');
		$f .= pruefen($_POST['bezeichnung'],'minlaenge','Die Bezeichnung muss aus mindestens 2 Zeichen bestehen',2);
		$f .= pruefen($_POST['bezeichnung'],'maxlaenge','Die Bezeichnung darf aus höchstens 50 Zeichen bestehen',50);
		if(empty($f)){
			$query = "UPDATE ".DB_PREFIX."vorstand
						SET bezeichnung = '".text_format($_POST['bezeichnung'],'db')."'
						WHERE id = '".text_format($_GET['id'],'db')."'";
			$_db->fuehreQueryAus($query);
			weiterleiten('/mitglieder/vorstand'.TKSWIM_DATEIENDUNG,'Das Vorstandsamt »'.$_POST['bezeichnung'].'« wurde geändert');
		}
		else{
			$_tmpl->assign('daten',$_POST);
			$_tmpl->assign('fehler',$f);
		}
	}
	$_inh .= $_tmpl->fetch('mitglieder/17.vorstand-formular.inc.html');
	break;
	
case 'anlegen':
	if(!pruefeRechte('m_vorstand_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	$_tmpl->assign('ueberschrift','Vorstand anlegen');
	if(isset($_POST['speichern'])){
		$f = '';
		require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
		$f .= pruefen($_POST['bezeichnung'],'leer','Die Bezeichnung darf nicht leer sein');
		$f .= pruefen($_POST['bezeichnung'],'minlaenge','Die Bezeichnung muss aus mindestens 2 Zeichen bestehen',2);
		$f .= pruefen($_POST['bezeichnung'],'maxlaenge','Die Bezeichnung darf aus höchstens 50 Zeichen bestehen',50);
		if(empty($f)){
			$query = "UPDATE ".DB_PREFIX."vorstand SET sort = sort+1";
			$_db->fuehreQueryAus($query);
			$query = "INSERT INTO ".DB_PREFIX."vorstand
						SET sort = 1, bezeichnung = '".text_format($_POST['bezeichnung'],'db')."'";
			$_db->fuehreQueryAus($query);
			$text = 'Das Vorstandsamt »'.$_POST['bezeichnung'].'« wurde angelegt';
			weiterleiten('/mitglieder/vorstand'.TKSWIM_DATEIENDUNG,$text);
		}
		else{
			$_tmpl->assign('daten',$_POST);
			$_tmpl->assign('fehler',$f);
		}
	}
	$_inh .= $_tmpl->fetch('mitglieder/17.vorstand-formular.inc.html');
	break;
	
case 'loeschen':
	if(!pruefeRechte('m_vorstand_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(!ctype_digit($_GET['id'])){
		$_tmpl->assign('fehler','die ID ist ungültig');
		break;
	}
	if($_GET['id'] < 10){
		$_tmpl->assign('fehler','Dieses Vorstandsamt kann nicht gelöscht werden.');
		break;
	}
	$_tmpl->assign('ueberschrift','Vorstandsamt löschen');
	if(!isset($_GET['sicher'])){
		$_tmpl->assign('frage','Soll das Vorstandsamt wirklich gelöscht werden?');
		$_tmpl->assign('url', '/mitglieder/vorstand'.TKSWIM_DATEIENDUNG);
		$_inh .= $_tmpl->fetch('tools/9902.loeschfrage.inc.html');
	}
	else{
		$query = "SELECT mitgliedid FROM ".DB_PREFIX."vorstand WHERE id = '".text_format($_GET['id'],'db')."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){
			$_tmpl->assign('fehler','Dieses Vorstandsamt existiert nicht.');
			break;
		}
		$mid = $_db->holeWert();
		if(!is_null($mid)){
			$query = "DELETE FROM ".DB_PREFIX."rechtegruppen_mitglieder WHERE mitgliedid = ".$mid." AND rechtegrid = 4";
			$_db->fuehreQueryAus($query);
		}
		$query = "DELETE FROM ".DB_PREFIX."vorstand WHERE id = '".text_format($_GET['id'],'db')."'";
		$_db->fuehreQueryAus($query);
		weiterleiten('/mitglieder/vorstand'.TKSWIM_DATEIENDUNG,'Das Vorstandsamt wurde gelöscht');
	}
	break;
	
default:
	$query = "SELECT v.id, v.bezeichnung, CONCAT(m.vorname,' ',m.nachname) as name
				FROM ".DB_PREFIX."vorstand as v LEFT JOIN ".DB_PREFIX."mitglieder as m ON v.mitgliedid=m.id
				ORDER BY sort ASC";
	$_db->holeDaten($query);
	$_tmpl->assign('ueberschrift','Vorstand');
	$_tmpl->assign('vorstand',$_db->ergebnis['daten']);
	$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
	$_tmpl->tk_javascriptzuweisen('onready', "\$('.loeschen').tkswim_loeschfrage({art:'vorstand',frage:'Soll das Vorstandsamt%%% wirklich gelöscht werden?',tabellenid:'vorstand'});");
	if(pruefeRechte('m_vorstand_bearbeiten')){
		$_tmpl->tk_javascriptzuweisen('onready', "$('.sortierbar').tkswim_sortieren('vorstand');");
	}
	$_inh .= $_tmpl->fetch('mitglieder/17.vorstand-uebersicht.inc.html');
	break;
}
} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
?>